/**
 * Created on 27.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.bescheid;

import java.io.ByteArrayOutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import javax.xml.transform.TransformerException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.validator.ValidatorForm;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import asit.common.Utils;
import asit.moa.client.deliver.address.Adressat;
import asit.moa.client.deliver.address.Behoerde;
import asit.moa.client.deliver.address.PersonConstants;


/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Bescheid extends ValidatorForm implements BescheidElement {

  protected String verfahrensID_ = null;
  protected String geschaeftszahl_ = null;
  protected String fremdzahl_ = null;
  
  protected String datumgenehmigung_ = dateToStringNormal(new Date());
  protected String datumrechtskraft_ = null;
  
  protected Adressat adressat_ = new Adressat();
  
  protected WeitereEckDaten eckDaten_ = new WeitereEckDaten();
  
  protected ArrayList spruchteile_ = new ArrayList();
  
  protected String betreff_ = null;
 
  protected String begruendung_ = null;
  protected String rechtsmittelbelehrung_ = null;
  protected String hinweis_ = null;
  
  protected Behoerde aussteller_ = null;
  
  
  // URL des StyleSheets
  protected String styleSheetURL_ = null;
  
  
  
  protected static Log log_ = LogFactory.getLog(Bescheid.class.getName()); 

  
  public void removeSpruchteil(int index) {
    spruchteile_.remove(index);
  }
  
  public void setSpruchteil(int index, Spruchteil teil) {
    spruchteile_.set(index, teil);
  }
  
  public void addSpruchteil(Spruchteil teil) {
    spruchteile_.add(teil);
  }
  
  public Spruchteil getSpruchteil(int index) {
    return (Spruchteil)spruchteile_.get(index);
  }
  
  public ArrayList getSpruchteile() {
    return spruchteile_;
  }
                                    
  
  public WeitereEckDaten getBWeitereEckDaten() {
    return eckDaten_;
  }
  
  public static void addStringElement(Element parent, Document doc, String element, String content) {
    Element e = doc.createElementNS(BescheidConstants.BESCHEID_NS, element);
    e.appendChild(doc.createTextNode(content));
    parent.appendChild(e);
  }
  
  
  public static String dateToStringXML(Date date) {
    if (date == null) {
      return null;
    }
    SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
    return format.format(date);
  }

  public static String dateToStringNormal(Date date) {
    if (date == null) {
      return null;
    }
    SimpleDateFormat format = new SimpleDateFormat("dd.MM.yyyy");
    return format.format(date);
  }

  public static Date stringToDateNormal(String string) {
    if (string == null) {
      return null;
    }
    log_.debug("Date: " + string);
    SimpleDateFormat format = new SimpleDateFormat("dd.MM.yyyy");
    try {
      return format.parse(string);
    } catch(Exception e) {
      // second guess!!
      try {
        format = new SimpleDateFormat("yyyy-MM-dd");      
        return format.parse(string);        
      } catch (Exception e2) {      
        e2.printStackTrace();      
        return null;
      }
    }
  }

  public static Date stringToDateXML(String string) {
    if (string == null) {
      return null;
    }
    SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
    try {
      return format.parse(string);
    } catch(Exception e) {
      e.printStackTrace();
      return null;
    }
  }
  
  public void setAussteller(Behoerde aussteller) {
    if (aussteller != null) {
      aussteller_ = aussteller;
    }
  }
      
  public Behoerde getAussteller() {
    return aussteller_;
  }
  
  /* 
   * @see asit.bescheid.BescheidElement#toElement(org.w3c.dom.Document)
   */
  public Element toElement(Document doc) {
    Element bescheid = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.BESCHEID);

    //Element e = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + "Verfahresis");
    
    bescheid.setAttribute("xmlns:" + BescheidConstants.BESCHEID_NS_PREFIX, BescheidConstants.BESCHEID_NS);
    bescheid.setAttribute("xmlns:" + PersonConstants.PERSON_NS_PREFIX, PersonConstants.PERSON_NS);
    bescheid.setAttribute("xmlns:dsig", "http://www.w3.org/2000/09/xmldsig#");
    //bescheid.setAttribute("xmlns", BescheidConstants.XHTML_NS);
    
    // temporary
    //bescheid.setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
    //bescheid.setAttribute("xsi:schemaLocation", "http://reference.e-government.gv.at/namespace/notificationdata/20040510# bescheid.xsd");
    
    
    // add verfahrensid
    if (verfahrensID_ == null) {
      verfahrensID_ = "";
    }
    addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.VERFAHRENSID, verfahrensID_);

    // add geschaeftszahl
    if (geschaeftszahl_ == null) {
      geschaeftszahl_ = "";
    }
    addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.GESCHAEFTSZAHL, geschaeftszahl_);

    // add fremdzahl
    if (!NotificationUtils.isEmpty(fremdzahl_)) {
      addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FREMDZAHL, fremdzahl_);
    }

    // add datum genehmigung
    if (datumgenehmigung_ == null) {
      datumgenehmigung_ = dateToStringNormal(new Date());
    }
    Date tmp = stringToDateNormal(datumgenehmigung_);
    addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.DATUMGENEHMIGUNG, dateToStringXML(tmp));
    
    // add datum rechtskraft - if any
    if (!NotificationUtils.isEmpty(datumrechtskraft_)) {
      Date temp = stringToDateNormal(datumrechtskraft_);
      addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.DATUMRECHTSKRAFT, dateToStringXML(temp));
    }

    log_.debug("ToElement: " + (aussteller_ == null));
    
    // add aussteller
    if (aussteller_ != null) {
      log_.debug("Ok haenge aussteller hinzu");
      bescheid.appendChild(aussteller_.toElement(doc));
    }
    
    // add adressat
    if (adressat_ != null) {
      adressat_.setElementName(BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.ADRESSAT);
      bescheid.appendChild(adressat_.toElement(doc));
    }
    
    // add eckdaten
    if (eckDaten_.size() > 0) {
      Element eckDaten = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.WEITEREECKDATEN);
      bescheid.appendChild(eckDaten);
      
      for (int i=0; i<eckDaten_.size(); i++) {
        EckData data = (EckData)eckDaten_.get(i);
        
        // ok we have a person
        if (EckData.KOMPPERSON.equals(data.getType())) {
          Element typPerson = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.TYPPERSON);
          
          eckDaten.appendChild(typPerson);
          
          Adressat adressat = (Adressat)data;
          
          if (adressat.getEFeldName() == null) {
            adressat.setEFeldName("");
          }
          addStringElement(typPerson, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FELDNAME, adressat.getEFeldName());

          
          adressat.setElementName(BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.PERSON);
          
          typPerson.appendChild(adressat.toElement(doc));
          
          
        }

        // simple eckdata
        if (EckData.SIMPLE.equals(data.getType())) {
          /*Element typSimple = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.TYPSIMPLE);
          eckDaten.appendChild(typSimple);
          
          if (se.getEFeldName() == null) {
            se.setEFeldName("");
          }
          addStringElement(typSimple, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FELDNAME, se.getEFeldName());
          */
          SimpleEckData se = (SimpleEckData)data;
          eckDaten.appendChild(se.toElement(doc));
        }
        
      }
      
    }
    
    // add betreff
    if (!NotificationUtils.isEmpty(betreff_)) {
      addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.BETREFF, betreff_);
    }
    
    // add sprueche
    if (spruchteile_.size() > 0) {
      Element spruch = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.SPRUCH);
      bescheid.appendChild(spruch);
      
      for (int i=0; i<spruchteile_.size(); i++) {
        Spruchteil teil = (Spruchteil)spruchteile_.get(i);
        spruch.appendChild(teil.toElement(doc));
      }
    }

    // add begruendung
    if (!NotificationUtils.isEmpty(begruendung_)) {
      String formattedBegruendung = Utils.normalizeText(begruendung_); 
      addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.BEGRUENDUNG, formattedBegruendung);
    }

    // add hinweis
    if (!NotificationUtils.isEmpty(hinweis_)) {
      String formattedHinweis = Utils.normalizeText(hinweis_);
      addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.HINWEIS, formattedHinweis);
    }

    // add rechtsmittelbelehrung
    if (rechtsmittelbelehrung_ == null) {
      rechtsmittelbelehrung_ = "[ Darf nicht leer sein ]";
    }
    //String formattedRechtsmittelBelehrung = Utils.normalizeText(rechtsmittelbelehrung_);
    //addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.RECHTSMITTELBELEHRUNG, formattedRechtsmittelBelehrung);
    log_.debug("Adding mixed content: " + rechtsmittelbelehrung_);
    addMixedContentElement(bescheid, BescheidConstants.RECHTSMITTELBELEHRUNG, rechtsmittelbelehrung_);

    // add signatur element
    addStringElement(bescheid, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.SIGNATUR, "");

    
    return bescheid;
  }

  public void addMixedContentElement(Element root, String elementName, String content) {
    try {
      content = Utils.replaceVariable(content, "&auml;", "");
      content = Utils.replaceVariable(content, "&Auml;", "");
      content = Utils.replaceVariable(content, "&ouml;", "");
      content = Utils.replaceVariable(content, "&Ouml;", "");
      content = Utils.replaceVariable(content, "&uuml;", "");
      content = Utils.replaceVariable(content, "&Uuml;", "");
      content = Utils.replaceVariable(content, "&nbsp;", " ");
      content = Utils.replaceVariable(content, "&nbsp;", " ");
      content = Utils.replaceVariable(content, "&szlig;", "");
      
      //String tmp = "<" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + elementName + "><![CDATA[" + content + "]]></" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + elementName + ">";
      String tmp = "<" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + elementName + ">" + content + "</" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + elementName + ">";
      Element e = Utils.parseXMLStringNoNS(tmp).getDocumentElement();
      root.appendChild(root.getOwnerDocument().importNode(e, true));
    } catch(Exception e) {
      e.printStackTrace();
    }
  }
  
  /*
   * @see asit.bescheid.BescheidElement#update(org.w3c.dom.Element)
   */
  public void update(Element element) {
    log_.debug("Updating bescheid:");
    try {

      // read out verfahrensid
      Node vid = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.VERFAHRENSID + "/text()");
      if (vid != null) {
        log_.debug("Found VerfahrensID node: " + vid.getNodeValue());
        verfahrensID_ = vid.getNodeValue();
      }
      
      // read out geschaeftszahl
      Node geschaeftszahl = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.GESCHAEFTSZAHL + "/text()");
      if (geschaeftszahl != null) {
        log_.debug("Found Geschaeftszahl node: " + geschaeftszahl.getNodeValue());
        geschaeftszahl_ = geschaeftszahl.getNodeValue();
      }

      // read out fremdzahl
      Node fremdzahl = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FREMDZAHL + "/text()");
      if (fremdzahl != null) {
        log_.debug("Found Fremdzahl node: " + fremdzahl.getNodeValue());
        fremdzahl_ = fremdzahl.getNodeValue();
      }
      
      //  read out datum genehmigung
      Node datumgenehmigung = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.DATUMGENEHMIGUNG + "/text()");
      if (datumgenehmigung != null) {
        log_.debug("Found Datumgenehmigung node: " + datumgenehmigung.getNodeValue());
        Date date = stringToDateXML(datumgenehmigung.getNodeValue());
        datumgenehmigung_ = dateToStringNormal(date);
      }
      
      //  read out datum rechtskraft
      Node datumrechtskraft = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.DATUMRECHTSKRAFT + "/text()");
      if (datumrechtskraft != null) {
        log_.debug("Found Datumrechtskraft node: " + datumrechtskraft.getNodeValue());
        Date date = stringToDateXML(datumrechtskraft.getNodeValue());
        datumrechtskraft_ = dateToStringNormal(date);
      }


      // read out behoerde
      Node behoerde = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.BEHOERDE);
      if (behoerde != null) {
        log_.debug("Found behoerde");
        aussteller_ = new Behoerde();
        aussteller_.update((Element)behoerde);
      }

      
      // read out adressat
      Node adressat = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.ADRESSAT);
      if (adressat != null) {
        log_.debug("Found Adressat");
        adressat_ = new Adressat();
        adressat_.update((Element)adressat);
      }
      
      // read weitere eckdaten
      NodeList wed = XPathAPI.selectNodeList(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.WEITEREECKDATEN + "/child::node()");
      log_.debug("Anzahl der Eckdaten: " + wed.getLength());
      if (wed.getLength() > 0) {
        log_.debug("Found weitere eckdaten");
        
        for (int i=0; i<wed.getLength(); i++) {
          
          if (wed.item(i) instanceof Element) {

            
            Element eckdataElement = (Element)wed.item(i);
            log_.debug("Weitere eckdaten: " + eckdataElement.getLocalName());

            // found a natural person
            if (EckData.KOMPPERSON.equals(eckdataElement.getLocalName())) {
              log_.debug("Add natural person");
              Adressat adr = new Adressat();
              adr.update(eckdataElement);
              eckDaten_.add(adr);
            }

            // found a simple type
            if (EckData.SIMPLE.equals(eckdataElement.getLocalName())) {
              log_.debug("Add simple type");
              SimpleEckData simple = new SimpleEckData();
              simple.update(eckdataElement);
              eckDaten_.add(simple);
            }
          }
        }
        
      }
      
      // read out betreff
      Node betreff = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.BETREFF + "/text()");
      if (betreff != null) {
        log_.debug("Found Betreff node: " + betreff.getNodeValue());
        betreff_ = betreff.getNodeValue();
      }
      
      // sprueche
      NodeList spruchteile = XPathAPI.selectNodeList(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.SPRUCHTEIL);
      log_.debug("Anzahl der Spruchteile: " + spruchteile.getLength());
      if (spruchteile.getLength() > 0) {
       
        for (int i=0; i<spruchteile.getLength(); i++) {
          if (spruchteile.item(i) instanceof Element) {
            Spruchteil teil = new Spruchteil();
            teil.update((Element)spruchteile.item(i));
            spruchteile_.add(teil);
          }
        }
                                                      
        
      }

      //  begruendung
      Node begruendung = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.BEGRUENDUNG + "/text()");
      if (begruendung != null) {
        log_.debug("Found Begruendung node: " + begruendung.getNodeValue());
        begruendung_ = begruendung.getNodeValue();
      }

      //  hinweise
      Node hinweis = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.HINWEIS + "/text()");
      if (hinweis != null) {
        log_.debug("Found Hinweis node: " + hinweis.getNodeValue());
        hinweis_ = hinweis.getNodeValue();
      }
      
      //  rechtsmittelbelehrung
      Node rechtsmittelbelehrung = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.RECHTSMITTELBELEHRUNG);
      if (rechtsmittelbelehrung != null) {
        log_.debug("Found rechtsmittelbelehrung node: " + rechtsmittelbelehrung.getNodeName());
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        log_.debug("Number of child nodes: " + rechtsmittelbelehrung.getChildNodes().getLength());
        /*try {
          for (int i=0; i<rechtsmittelbelehrung.getChildNodes().getLength(); i++) {
            Utils.serializeNode(rechtsmittelbelehrung.getChildNodes().item(i), bos);
          }
          rechtsmittelbelehrung_ = bos.toString();
        } catch(Exception e) {
          e.printStackTrace();
        }*/
        
        if (rechtsmittelbelehrung.getChildNodes().getLength() > 0) {
          try {
            Utils.serializeElement((Element)rechtsmittelbelehrung, bos);
            rechtsmittelbelehrung_ = bos.toString("UTF-8");
            log_.debug(rechtsmittelbelehrung_);
            int beginIndex = rechtsmittelbelehrung_.indexOf(">")+1;
            int endIndex = rechtsmittelbelehrung_.indexOf("</b:Rechtsmittelbelehrung>");
            rechtsmittelbelehrung_ = rechtsmittelbelehrung_.substring(beginIndex, endIndex);
            log_.debug("Rechtsmittelbelehrung: " + rechtsmittelbelehrung_);
          } catch(Exception err) {
            err.printStackTrace();
          }
        } else {
          rechtsmittelbelehrung_ = null;
        }
        
        
        
      }

      
    } catch(TransformerException e) {
      e.printStackTrace();
      log_.debug("Error while evaluating XPath expression: " + e.getMessage());
    }
  }
  
  public Adressat getAdressat() {
    return adressat_;
  }
  
  /**
   * @return Returns the fremdzahl_.
   */
  public String getBFremdzahl() {
    return fremdzahl_;
  }
  /**
   * @param fremdzahl_ The fremdzahl_ to set.
   */
  public void setBFremdzahl(String fremdzahl) {
    this.fremdzahl_ = fremdzahl;
  }
  /**
   * @return Returns the geschaeftszahl_.
   */
  public String getBGeschaeftszahl() {
    return geschaeftszahl_;
  }
  /**
   * @param geschaeftszahl_ The geschaeftszahl_ to set.
   */
  public void setBGeschaeftszahl(String geschaeftszahl) {
    this.geschaeftszahl_ = geschaeftszahl;
  }
  /**
   * @return Returns the verfahrensID_.
   */
  public String getBVerfahrensID() {
    return verfahrensID_;
  }
  /**
   * @param verfahrensID_ The verfahrensID_ to set.
   */
  public void setBVerfahrensID(String verfahrensID) {
    this.verfahrensID_ = verfahrensID;
  }
  
  public Adressat getBAdressat() {
    return adressat_;
  }
  
  public void setBAdressat(Adressat adressat) {
    adressat_ = adressat;
  }
  
  // print person string
  public String getBAdressatPerson() {
    if ((adressat_ != null) &&
        (adressat_.getPerson() != null)) {
      return adressat_.getPerson().toString();
    } else {
      return "";
    }
  }
  
  public String getBAdressatAddress() {
    if ((adressat_ != null) &&
        (adressat_.getPostAddress() != null)) {
      return adressat_.getPostAddress().toString();
    } else {
      return "";
    }
  }
  

  
  /**
   * @return Returns the datumgenehmigung_.
   */
  public String getBStyleSheetURL() {
    return styleSheetURL_;
  }
  /**
   * @param datumgenehmigung_ The datumgenehmigung_ to set.
   */
  public void setBStyleSheetURL(String url) {
    styleSheetURL_ = url;
  }

  /**
   * @return Returns the datumgenehmigung_.
   */
  public String getBDatumgenehmigung() {
    return datumgenehmigung_;
  }
  /**
   * @param datumgenehmigung_ The datumgenehmigung_ to set.
   */
  public void setBDatumgenehmigung(String datumgenehmigung) {
    datumgenehmigung_ = datumgenehmigung;
  }
  /**
   * @return Returns the datumrechtskraft_.
   */
  public String getBDatumrechtskraft() {
    return datumrechtskraft_;
  }
  /**
   * @param datumrechtskraft_ The datumrechtskraft_ to set.
   */
  public void setBDatumrechtskraft(String datumrechtskraft) {
    datumrechtskraft_ = datumrechtskraft;
  }
  /**
   * @return Returns the betreff_.
   */
  public String getBBetreff() {
    return betreff_;
  }
  /**
   * @param betreff_ The betreff_ to set.
   */
  public void setBBetreff(String betreff) {
    this.betreff_ = betreff;
  }
  /**
   * @return Returns the begruendung_.
   */
  public String getBBegruendung() {
    return begruendung_;
  }
  /**
   * @param begruendung_ The begruendung_ to set.
   */
  public void setBBegruendung(String begruendung) {
    this.begruendung_ = begruendung;
  }
  /**
   * @return Returns the hinweis_.
   */
  public String getBHinweis() {
    return hinweis_;
  }
  /**
   * @param hinweis_ The hinweis_ to set.
   */
  public void setBHinweis(String hinweis) {
    this.hinweis_ = hinweis;
  }
  /**
   * @return Returns the rechtsmittelbelehrung_.
   */
  public String getBRechtsmittelbelehrung() {
    return rechtsmittelbelehrung_;
  }
  /**
   * @param rechtsmittelbelehrung_ The rechtsmittelbelehrung_ to set.
   */
  public void setBRechtsmittelbelehrung(String rechtsmittelbelehrung) {
    this.rechtsmittelbelehrung_ = rechtsmittelbelehrung;
  }
}
