/*
 * Created on 28.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.bescheid;

import javax.xml.transform.TransformerException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import asit.common.Utils;


/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Kosten implements BescheidElement {

  
  protected String betrag_ = null;
  protected String rechtsgrundlage_ = null;
  protected String text_ = null;
  
  
  protected static Log log_ = LogFactory.getLog(Kosten.class.getName()); 
  
  /**
   * @return Returns the betrag_.
   */
  public String getKBetrag() {
    return betrag_;
  }
  /**
   * @param betrag_ The betrag_ to set.
   */
  public void setKBetrag(String betrag) {
    this.betrag_ = betrag;
  }
  /**
   * @return Returns the rechtsgrundlage_.
   */
  public String getKRechtsgrundlage() {
    return rechtsgrundlage_;
  }
  /**
   * @param rechtsgrundlage_ The rechtsgrundlage_ to set.
   */
  public void setKRechtsgrundlage(String rechtsgrundlage) {
    this.rechtsgrundlage_ = rechtsgrundlage;
  }
  /**
   * @return Returns the text_.
   */
  public String getKText() {
    return text_;
  }
  /**
   * @param text_ The text_ to set.
   */
  public void setKText(String text) {
    this.text_ = text;
  }
  /* (non-Javadoc)
   * @see asit.bescheid.BescheidElement#toElement(org.w3c.dom.Document)
   */
  public Element toElement(Document doc) {
    Element kosten = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.KOSTEN);
    
    // add betrag
    if (betrag_ == null) {
      betrag_ = "";
    }
    Element betrag = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.BETRAG);
    betrag.setAttribute(BescheidConstants.WAEHRUNG, "EUR");
    betrag.appendChild(doc.createTextNode(betrag_));
    kosten.appendChild(betrag);
    

    // add rechtsgrundlage
    if (rechtsgrundlage_ == null) {
      rechtsgrundlage_ = "";
    }
    String formattedRechtsGrunldage = Utils.normalizeText(rechtsgrundlage_);
    Bescheid.addStringElement(kosten, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.RECHTSGRUNDLAGE, formattedRechtsGrunldage);

    // add text
    if (text_ == null) {
      text_ = "";
    }
    String formattedText = Utils.normalizeText(text_);
    Bescheid.addStringElement(kosten, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.TEXT, formattedText);

    
    return kosten;
  }

  /* (non-Javadoc)
   * @see asit.bescheid.BescheidElement#update(org.w3c.dom.Element)
   */
  public void update(Element element) {
    log_.debug("Updating person:");
    try {
      // retrieve betrag
      Node betrag = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.BETRAG + "/text()");
      if (betrag != null) {
        log_.debug("Found Betrag node: " + betrag.getNodeValue());
        betrag_ = betrag.getNodeValue();
      }

      // retrieve rechtsgrundlage
      Node rechtsgrundlage = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.RECHTSGRUNDLAGE + "/text()");
      if (rechtsgrundlage != null) {
        log_.debug("Found Rechtsgrundlage node: " + rechtsgrundlage.getNodeValue());
        rechtsgrundlage_ = rechtsgrundlage.getNodeValue();
      }
      
      //  retrieve rechtsgrundlage
      Node text = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.TEXT + "/text()");
      if (text != null) {
        log_.debug("Found Text node: " + text.getNodeValue());
        text_ = text.getNodeValue();
      }

      
    } catch(TransformerException e) {
      log_.debug("Error while evaluating XPath expression: " + e.getMessage());
    }
  }
}
