/*
 * Created on 04.12.2004
 * 
 * TODO To change the template for this generated file go to Window -
 * Preferences - Java - Code Style - Code Templates
 */

package asit.bescheid;

import iaik.ixsil.algorithms.Transform;
import iaik.ixsil.algorithms.TransformImplCanonicalXML;
import iaik.ixsil.algorithms.TransformImplEnvelopedSignature;
import iaik.ixsil.algorithms.TransformImplExclusiveCanonicalXML;
import iaik.ixsil.algorithms.TransformImplXSLT;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Properties;
import java.util.SortedSet;
import java.util.TreeSet;
import javax.servlet.http.HttpSession;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import asit.common.Utils;
import asit.moa.MoaConstants;
import asit.moa.client.ClientFactory;
import asit.moa.client.deliver.DeliveryClient;
import asit.moa.client.deliver.address.KompNatuerlichePerson;
import asit.moa.client.exception.ClientException;
import asit.moa.client.exception.DeliveryException;
import asit.moa.client.sign.CreateSignatureClient;
import asit.moa.client.sign.MetaInfo;
import asit.moa.client.sign.SignReference;
import asit.moa.client.sign.SingleSignatureInfo;
import asit.moa.client.util.MoaUtils;
import asit.moa.client.verify.VerifyResult;
import asit.moa.client.verify.VerifySignatureClient;

public class NotificationUtils {

  
  protected static Log log_ = LogFactory.getLog(NotificationUtils.class.getName()); 
  
  public static String getLeadingZero(int i) {
    if (i < 10) {
      return "0" + i;
    } else {
      return "" + i;
    }
  }
  
  public static Document loadNotification(String fileName) throws ParserConfigurationException, SAXException, IOException {
    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
    // of course we validate
    factory.setNamespaceAware(true);
    DocumentBuilder builder = factory.newDocumentBuilder();
    return builder.parse(new File(fileName));
  }
  
  public static void dumpBescheid(Bescheid bescheid, String fileName) {
    try {  
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      // of course we validate
      factory.setNamespaceAware(true);
      DocumentBuilder builder = factory.newDocumentBuilder();
      Document doc = builder.newDocument();
      Utils.serializeElement(bescheid.toElement(doc), new FileOutputStream(fileName));
    } catch(Exception e) {
      e.printStackTrace();
    }
      
  }
  
  // dumps all the content of a http session
  public static void dumpSessionParamter(HttpSession session, String param) {
    Enumeration attributes = session.getAttributeNames();
    while (attributes.hasMoreElements()) {
      session.removeAttribute((String)attributes.nextElement());
    }
  }
  
  public static boolean isEmpty(String value) {
    return value == null || "".equals(value.trim());
  }
  
  public static SortedSet getLaenderCodes(String fileName) {
    TreeSet ret = new TreeSet();
    try {
      Properties props = new Properties();
      props.load(new FileInputStream(fileName));
      Enumeration e = props.keys();
      while (e.hasMoreElements()) {
        ret.add(e.nextElement());
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
    return ret;
  }
  
  public static ArrayList getLaenderNamen(String fileName) {
    ArrayList ret = new ArrayList();
    Iterator keys = getLaenderCodes(fileName).iterator();
    try {
      Properties props = new Properties();
      props.load(new FileInputStream(fileName));
      while (keys.hasNext()) {
        ret.add(props.getProperty((String)keys.next()));
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
    return ret;
    
  }
  
  public static void main(String[] a) {
    String f = "C:/development/tomcat-5.0.28/webapps/gen-bescheide/WEB-INF/res/countries.txt";
    Iterator e = getLaenderCodes(f).iterator();
    while (e.hasNext()) {
//      System.out.println("-" + e.next() + "-");
    }
    
    ArrayList ln = getLaenderNamen(f);
    for (int i=0; i<ln.size(); i++) {
//      System.out.println("-" + ln.get(i) + "-");
    }
    
    String cc = "AT - Antillen";
//    System.out.println("::" + KompNatuerlichePerson.getCountryCode(cc) + "::");
//    System.out.println("::" + KompNatuerlichePerson.getCountryName(cc) + "::");
  }
  
  public static void deliverNotification(Bescheid bescheid, String bildmarkeFile, String styleSheetFile,
      String styleSheetWebURL, String moaSSAddress, String moaSSKeyIdentifier, DeliveryClient deliveryClient)
      throws DeliveryException {
    try {
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      factory.setNamespaceAware(true);
      DocumentBuilder builder = factory.newDocumentBuilder();
      Document doc = builder.newDocument();
      // specify transformations
      Transform envelopedSignature = new TransformImplEnvelopedSignature();
      TransformImplXSLT styleSheetTransform = new TransformImplXSLT();
      // load and set stylesheet
      InputStreamReader fileReader = null;
      if (bescheid.getBStyleSheetURL() == null) {
        log_.debug("Lade StyleSheet von Datei: " + styleSheetFile);
        fileReader = new InputStreamReader(new FileInputStream(styleSheetFile),
        "UTF-8");  
      } else {
        log_.debug("Lade StyleSheet von URL: " + bescheid.getBStyleSheetURL());
        fileReader = new InputStreamReader((new URL(bescheid.getBStyleSheetURL())).openStream());
      }
      InputSource styleSource = new InputSource(fileReader);
      Element style = builder.parse(styleSource).getDocumentElement();
      styleSheetTransform.setStyleSheet(style, null);
      TransformImplExclusiveCanonicalXML exclCanonicalization = new TransformImplExclusiveCanonicalXML();
      //exclCanonicalization.setInclusiveNamespacePrefixes("");
      TransformImplCanonicalXML canonical = new TransformImplCanonicalXML();
      Transform[] transforms = new Transform[]{envelopedSignature, styleSheetTransform, canonical};
      // settings for signature client
      SignReference reference = ClientFactory.getSignReference();
      MetaInfo metaInfo = ClientFactory.getMetaInfo("text/html", null);
      reference.setMetaInfo(metaInfo);
      reference.setReference("");
      reference.setStructure(SignReference.STRUCTURE_DETACHED);
      reference.setTransformations(transforms);
      SingleSignatureInfo info = ClientFactory.getSingleSignatureInfo();
      info.addReference(reference);
      // standardmaessig
      info.setDocumentToEmbed(bescheid.toElement(doc), "//b:Signatur", 0);
      info.addDocumentToEmbedNamespace("xmlns:b",
          "http://reference.e-government.gv.at/namespace/notificationdata/20040510#");
      // Notwending fuer Amtssignatur
      info.setIsSecurityLayerConform(true);
      // signature client
      CreateSignatureClient client = ClientFactory.getSignatureClient();
      // set the key identifier
      client.setKeyIdentifier(moaSSKeyIdentifier);
      client.setSingleSignatureInfos(new SingleSignatureInfo[]{info});
      // signed document
      Element signedDocument = client.sendSignatureRequest(moaSSAddress);
      
      
      

      
      doc = builder.newDocument();
      // prepare document
      
      log_.debug("Bescheid StyleSheet URL: " + bescheid.getBStyleSheetURL());
      
      String styleSheetURL = bescheid.getBStyleSheetURL() != null ? bescheid.getBStyleSheetURL() : styleSheetWebURL;
      
      doc.appendChild(doc.createProcessingInstruction("xml-stylesheet", "type=\"text/xsl\" href=\""
                                                                        + styleSheetURL + "\""));
      doc.appendChild(doc.importNode(signedDocument, true));
      
      Element nsnode = doc.createElement("DummyNode");
      nsnode.setAttribute("xmlns:xsl", "http://www.w3.org/1999/XSL/Transform");
      
      log_.debug("Root-node: " + doc.getDocumentElement());
      
      Node styleSheetNode = XPathAPI.selectSingleNode(doc, "descendant-or-self::stylesheet", nsnode);

      log_.debug("Do we have a stylesheet node: " + (styleSheetNode == null));
      
      if (styleSheetNode != null) {
        log_.debug("Now removing xmlns:xml attribute...");
        Element ssElement = (Element)styleSheetNode;
        ssElement.removeAttribute("xmlns:xml");
      }

      /*FileOutputStream out = new FileOutputStream("c:/delivered.xml");
      DOMUtilsImpl.serializeDocument(doc, out);
      out.flush();
      out.close();*/
      
      // now deliver
      
      // Converting to PDF
      InputStream ssIs = null;
      if (bescheid.getBStyleSheetURL() == null) {
        log_.debug("Lade StyleSheet von Datei: " + styleSheetFile);
        ssIs = new FileInputStream(styleSheetFile);  
      } else {
        log_.debug("Lade StyleSheet von URL: " + bescheid.getBStyleSheetURL());
        ssIs = (new URL(bescheid.getBStyleSheetURL())).openStream();
      }
      
      /*
      PDFGenerator pdfgen = new PDFGenerator();
      byte[] res = pdfgen.convertBescheidToPDF(doc, ssIs, "c:/development");
      FileOutputStream os = new FileOutputStream("c:/development/out.pdf");
      os.write(res);
      os.flush();
      os.close();
      */
      
      // adressat
      log_.debug("Setting receiver");
      deliveryClient.setReceiver(bescheid.getAdressat());
      ByteArrayOutputStream out = new ByteArrayOutputStream();
      Utils.serializeDocument(doc, out);
      log_.debug("Setting documents");
      deliveryClient.addPayLoadBinaryDocument(new ByteArrayInputStream(out.toByteArray()), "bescheid.xml", "text/xml");
      //deliveryClient.addBinaryDocument(new FileInputStream(styleSheetFile), "bescheid.xsl", "text/xml");
      deliveryClient.addPayLoadBinaryDocument(new FileInputStream(bildmarkeFile), "bildmarke.jpg", "image/gif");
      log_.debug("Now delivering");
      
      
    } catch (Exception e) {
      e.printStackTrace();
      throw new DeliveryException(
          "Folgender Fehler ist beim Zustellen des Bescheides aufgetreten: " + e.getMessage());
    }
  }

  public static VerifyResult verifyNotification(Bescheid bescheid, String signingTime, String signatureValue, String styleSheetFile, String privateKeyFile, String certificateFile, String moaspurl, String moaSPTrustProfile)
      throws ClientException {
    
    try {
      
      log_.debug("SignatureValue: " + signatureValue);

      // loesche alle leerzeichen
      signatureValue = signatureValue.replaceAll(" ", "");

      
      // check base64 value if it is ok
      Utils.checkBase64Signature(signatureValue);

      
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      factory.setNamespaceAware(true);
      DocumentBuilder builder = factory.newDocumentBuilder();
      Document doc = builder.newDocument();
      
      // append notification
      Element notification = bescheid.toElement(doc);
      
      ByteArrayOutputStream out = new ByteArrayOutputStream();
      Utils.serializeElement(notification, out);
      
      doc = builder.parse(new ByteArrayInputStream(out.toByteArray()));
      
      // specify transformations
      Transform envelopedSignature = new TransformImplEnvelopedSignature();
      TransformImplXSLT styleSheetTransform = new TransformImplXSLT();
      
      //    load and set stylesheet
      InputStreamReader fileReader = null;
      if (bescheid.getBStyleSheetURL() == null) {
        log_.debug("Lade StyleSheet von Datei: " + styleSheetFile);
        fileReader = new InputStreamReader(new FileInputStream(styleSheetFile),
        "UTF-8");  
      } else {
        log_.debug("Lade StyleSheet von URL: " + bescheid.getBStyleSheetURL());
        fileReader = new InputStreamReader((new URL(bescheid.getBStyleSheetURL())).openStream());
      }
      InputSource styleSource = new InputSource(fileReader);  
      Element style = builder.parse(styleSource).getDocumentElement();
      styleSheetTransform.setStyleSheet(style, null);
      TransformImplExclusiveCanonicalXML exclCanonicalization = new TransformImplExclusiveCanonicalXML();
      //exclCanonicalization.setInclusiveNamespacePrefixes("");
      TransformImplCanonicalXML canonical = new TransformImplCanonicalXML();
      Transform[] transforms = new Transform[]{envelopedSignature, styleSheetTransform, canonical};
      
      Document toVerify = MoaUtils.generateNotificationSignature(doc,
          "signature-1-1",
          "reference-1-1",
          "etsi-signed-1-1",
          signingTime,
          transforms,
          "/b:Bescheid/b:Signatur",
          0,
          new File(privateKeyFile),
          new File(certificateFile));
      
      //DOMUtilsImpl.serializeDocument(toVerify, new FileOutputStream("c:/out.xml"));
      
      // replace signaturevalues
      Node oldSigValue = XPathAPI.selectSingleNode(toVerify, "/b:Bescheid/b:Signatur/dsig:Signature/dsig:SignatureValue/text()");

      
      oldSigValue.setNodeValue(signatureValue);

      // now verify using moa-sp
      VerifySignatureClient client = ClientFactory.getVerifySignatureClient();

      client.setContent(toVerify.getDocumentElement());
      client.addAdditionalNamespace("dsig", MoaConstants.DSIG_NS);
      
      client.setSignatureLocation("//dsig:Signature");
      client.setTrustProfileID(moaSPTrustProfile);
      
      // now verify and return result
      return client.sendVerifyRequest(moaspurl);
      
    } catch (Exception e) {
      e.printStackTrace();
      throw new ClientException(
          "Folgender Fehler ist beim Verifizieren des Bescheides aufgetreten: " + e.getMessage());
    }
  }
}