package asit.bescheid;


import java.io.IOException;
import java.io.OutputStream;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.w3c.dom.Document;

import asit.common.Utils;
import asit.config.Configuration;

/**
 * @author Arne Tauber
 */
public class ShowBescheid extends HttpServlet {

  
  protected static Log log_ = LogFactory.getLog(ShowBescheid.class.getName());
  
    public void doGet(HttpServletRequest request, HttpServletResponse response)
            throws IOException, ServletException {
        doPost(request, response);

    }

    public void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        log_.debug("Entering doPost.");
        
        HttpSession session = request.getSession();
        
        if (session == null) {
          log_.debug("Ungltige Session");
          //response.setContentType("text/html");
          //out.write(getNotFoundText().getBytes("UTF-8"));
          response.sendError(500, "Die Session ist ung&uuml;ltig");
          return;
        }
        
        log_.debug("Session: " + session);
      
        Enumeration enumeration = session.getAttributeNames();
        log_.debug("Attributes:");
        while (enumeration.hasMoreElements()) {
          log_.debug(enumeration.nextElement());
        }
        
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html; charset=UTF-8");

        //PrintWriter out = response.getWriter();
        OutputStream out = response.getOutputStream();
        
        log_.debug("ShowBescheid: " + request.getSession().getAttribute("Bescheid"));
        
        if (request.getSession().getAttribute("Bescheid") == null) {
          response.setContentType("text/html");
          out.write(getNotFoundText().getBytes("UTF-8"));
        } else {
         
          // Write xml document
          response.setContentType("text/xml");
          Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");
          

          
          try {
            
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            factory.setNamespaceAware(true);
            DocumentBuilder builder = factory.newDocumentBuilder();
            Document doc = builder.newDocument();
            
            Configuration config = new Configuration();
            config.loadFromConfigFile(request.getSession().getServletContext());
            
            String styleSheetURL = bescheid.getBStyleSheetURL() == null ? config.getSSURL() : bescheid.getBStyleSheetURL();
            
            doc.appendChild(doc.createProcessingInstruction("xml-stylesheet", "type=\"text/xsl\" href=\"" + styleSheetURL + "\""));
            doc.appendChild(bescheid.toElement(doc));
            
            Utils.serializeDocument(doc, out);
          } catch (Exception e) {
            e.printStackTrace();
          }
          
        }
        

    }

    protected String getNotFoundText() {
      String ret = "<html>" +
              "<head>" +
              "<title>Nicht gefunden</title>" +
              "</head>" +
              "<body>" +
              "<h1>Fehler - Nicht gefunden</h1>" +
              "<p>Die angeforderte Ressource ist leider nicht verf&uuml;gbar.</p>" +
              "</body>" +
              "</html>";
              
      return ret;
    }
}

