/*
 * Created on 28.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.bescheid;

import javax.xml.transform.TransformerException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import asit.common.Utils;


/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SimpleEckData implements EckData, BescheidElement {

  protected String content_ = null;
  
  protected String feldName_ = null;
  
  protected static Log log_ = LogFactory.getLog(SimpleEckData.class.getName());
  
  public void setEContent(String content) {
    content_ = content;
  }
  
  public String getEContent() {
    return content_;
  }
  
  /*
   * @see asit.bescheid.EckData#getType()
   */
  public String getType() {
    return EckData.SIMPLE;
  }

  public void setType(String type) {}
  
  /* (non-Javadoc)
   * @see asit.bescheid.EckData#getEFeldName()
   */
  public String getEFeldName() {
    return feldName_;
  }

  /* (non-Javadoc)
   * @see asit.bescheid.EckData#setEFeldName(java.lang.String)
   */
  public void setEFeldName(String feldName) {
    feldName_ = feldName;
  }

  /* (non-Javadoc)
   * @see asit.bescheid.EckData#getEDescription()
   */
  public String getEDescription() {
    return content_;
  }
  
  public void setEDescription(String descr) {
   content_ = descr;
  }

  /* (non-Javadoc)
   * @see asit.bescheid.BescheidElement#toElement(org.w3c.dom.Document)
   */
  public Element toElement(Document doc) {
    Element simple = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.TYPSIMPLE);
    
    // add feldname
    if (feldName_ == null) {
      feldName_ = "";
    }
    Bescheid.addStringElement(simple, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FELDNAME, feldName_);

    // add wert
    if (content_ == null) {
      content_  = "";
    }
    String formattedContent = Utils.normalizeText(content_);
    Bescheid.addStringElement(simple, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.WERT, formattedContent);
    
    return simple;
  }

  /* (non-Javadoc)
   * @see asit.bescheid.BescheidElement#update(org.w3c.dom.Element)
   */
  public void update(Element element) {

    log_.debug("Updating simple eckdata:");
    try {
      // retrieve betrag
      Node feldname = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FELDNAME + "/text()");
      if (feldname != null) {
        log_.debug("Found Feldname node: " + feldname.getNodeValue());
        feldName_ = feldname.getNodeValue();
      }

      // retrieve wert
      Node wert = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.WERT + "/text()");
      if (wert != null) {
        log_.debug("Found Wert node: " + wert.getNodeValue());
        content_ = wert.getNodeValue();
      }

      
    } catch(TransformerException e) {
      log_.debug("Error while evaluating XPath expression: " + e.getMessage());
    }
      
  }
  

  
}
