package asit.bescheid;

import javax.xml.transform.TransformerException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import asit.common.Utils;

public class TextBlock implements BescheidElement {
  
  protected String id_ = null;
  protected String text_ = null;
  
  
  protected static Log log_ = LogFactory.getLog(TextBlock.class.getName());
  
  /**
   * @return Returns the id_.
   */
  public String getTId() {
    return id_;
  }
  /**
   * @param id_ The id_ to set.
   */
  public void setTId(String id) {
    this.id_ = id;
  }
  /**
   * @return Returns the text_.
   */
  public String getTText() {
    return text_;
  }
  /**
   * @param text_ The text_ to set.
   */
  public void setTText(String text) {
    this.text_ = text;
  }
  /* (non-Javadoc)
   * @see asit.bescheid.BescheidElement#toElement(org.w3c.dom.Document)
   */
  public Element toElement(Document doc) {
    Element textblock = doc.createElementNS(BescheidConstants.BESCHEID_NS, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.TEXTBLOCK);
    
    // add wert
    if (text_ == null) {
      text_  = "";
    }
    String formattedText = Utils.normalizeText(text_);
    Bescheid.addStringElement(textblock, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.TEXT, formattedText);

    // add feldname
    if (!NotificationUtils.isEmpty(id_)) {
      Bescheid.addStringElement(textblock, doc, BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FRIST, id_);
    }

    
    return textblock;
  }
  /* (non-Javadoc)
   * @see asit.bescheid.BescheidElement#update(org.w3c.dom.Element)
   */
  public void update(Element element) {
    log_.debug("Updating text block:");
    try {
      // retrieve betrag
      Node frist = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FRIST + "/text()");
      if (frist != null) {
        log_.debug("Found Frist node: " + frist.getNodeValue());
        id_ = frist.getNodeValue();
      }

      // retrieve wert
      Node wert = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.TEXT + "/text()");
      if (wert != null) {
        log_.debug("Found Wert node: " + wert.getNodeValue());
        text_ = wert.getNodeValue();
      }

      
    } catch(TransformerException e) {
      log_.debug("Error while evaluating XPath expression: " + e.getMessage());
    }
    
  }
}
