/*
 * Created on 12.01.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.common;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Vector;


/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Win32FileSystem {

  static {
    try
    {
      //extractAndLoadLib();
      System.loadLibrary("Win32FileSystem");
    }
    catch(Throwable throwable)
    {
      
      throwable.printStackTrace();
      //throwable.printStackTrace();
      /*try {
        extractAndLoadLib();
      } catch(Throwable err) {
        err.printStackTrace();
      }
    }*/
    }

  }
  
  
  
  native static String getDriveName(String name);
  native static String getFileSystemName(String name);
  native static int getDriveType(String name);
  
  native static boolean natIsDirectory(String name);
  native static boolean natIsEncrypted(String name);
  native static boolean natIsHidden(String name);
  native static boolean natIsNormal(String name);
  native static boolean natIsNotContentIndexed(String name);
  native static boolean natIsOffline(String name);
  native static boolean natIsReadOnly(String name);
  native static boolean natHasReparsePoint(String name);
  native static boolean natIsSparseFile(String name);
  native static boolean natIsSystemFile(String name);
  native static boolean natIsTemporaryFile(String name);
  
  native static boolean natEncryptFile(String name);
  native static String natEncryptFileStringReturn(String name);
  
  native static boolean natDecryptFile(String name);
  
  native static boolean natSecureDelete(String fileName);
  
  native static boolean deleteCertificate(String hexFingerPrint);
  
  native static boolean natSetSystemFile(String file);
  
  native static String natGetEnvironmentVariable(String name);
  
  public final static String FAT = "FAT";
  public final static String NTFS = "NTFS";
  
  public final static int DRIVE_UNKNOWN = 0;
  public final static int DRIVE_NO_ROOT_DIR = 1;
  public final static int DRIVE_REMOVABLE = 2;
  public final static int DRIVE_FIXED = 3;
  public final static int DRIVE_REMOTE = 4;
  public final static int DRIVE_CDROM = 5;
  public final static int DRIVE_RAMDISK = 6;

  
  public static File[] getNTFSDrives() {
    char[] drives = listAvailableDrives();
    Vector ret = new Vector();
    for (int i=0; i<drives.length; i++) {
      if (Win32FileSystem.NTFS.equals(getFileSystemName(drives[i])) &&
          Win32FileSystem.DRIVE_FIXED == getDriveType(drives[i])) {
        ret.add(String.valueOf(drives[i]));
      }
    }
    File[] okDrives = new File[ret.size()];
    for (int i=0; i<ret.size(); i++) {
      String drive = (String)ret.elementAt(i);
      okDrives[i] = new File(drive + ":\\");
    }
    return okDrives;
  }
  
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#listAvailableDrives()
   */
  public static char[] listAvailableDrives() {
    File[] roots = File.listRoots();
    if (roots != null) {
      char[] drives = new char[roots.length];
      for (int i=0; i<roots.length; i++) {
        drives[i] = roots[i].getAbsolutePath().charAt(0);
      }
      return drives;
    }
    return new char[0];
  }

  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#getDriveName(char)
   */
  public static String getDriveName(char driveName) {
    String name = String.valueOf(driveName) + ":\\";
    return getDriveName(name);
  }

  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#getFileSystemName(char)
   */
  public static String getFileSystemName(char driveName) {
    String name = String.valueOf(driveName) + ":\\";
    return getFileSystemName(name);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#getDriveType(char)
   */
  public static int getDriveType(char driveName) {
    String name = String.valueOf(driveName) + ":\\";
    return getDriveType(name);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isArchive(java.lang.String)
   */
  public static boolean isArchive(String fileName) {
    // TODO Auto-generated method stub
    return false;
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isCompressed(java.lang.String)
   */
  public static boolean isCompressed(String fileName) {
    // TODO Auto-generated method stub
    return false;
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isDirectory(java.lang.String)
   */
  public static boolean isDirectory(String fileName) {
    return natIsDirectory(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isEncrypted(java.lang.String)
   */
  public static boolean isEncrypted(String fileName) {
    return natIsEncrypted(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isHidden(java.lang.String)
   */
  public static boolean isHidden(String fileName) {
    return natIsHidden(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isNormal(java.lang.String)
   */
  public static boolean isNormal(String fileName) {
     return natIsNormal(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isNotContentIndexed(java.lang.String)
   */
  public static boolean isNotContentIndexed(String fileName) {
    return natIsNotContentIndexed(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isOffline(java.lang.String)
   */
  public static boolean isOffline(String fileName) {
     return natIsOffline(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isReadOnly(java.lang.String)
   */
  public static boolean isReadOnly(String fileName) {
    return natIsReadOnly(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isHasReparsePoint(java.lang.String)
   */
  public static boolean isHasReparsePoint(String fileName) {
    return natHasReparsePoint(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isSparseFile(java.lang.String)
   */
  public static boolean isSparseFile(String fileName) {
    return natIsSparseFile(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isSystemFile(java.lang.String)
   */
  public static boolean isSystemFile(String fileName) {
    return natIsSystemFile(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#isTemporaryFile(java.lang.String)
   */
  public static boolean isTemporaryFile(String fileName) {
    return natIsTemporaryFile(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#encryptFile(java.lang.String)
   */
  public static boolean encryptFile(String fileName) {
    return natEncryptFile(fileName);
  }

  public static String encryptFileString(String fileName) {
    return natEncryptFileStringReturn(fileName);
  }

  
  
  
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#decryptFile(java.lang.String)
   */
  public static boolean decryptFile(String fileName) {
    return natDecryptFile(fileName);
  }
  /* (non-Javadoc)
   * @see asit.api.Win32FileSystem#secureDelete(java.lang.String)
   */
  public static boolean secureDelete(String fileName) {
    return natSecureDelete(fileName);
  }
  
  public static boolean deleteCert(String fingerPrint) {
    return deleteCertificate(fingerPrint);
  }
  
  public static boolean setSystemFile(String file) {
    return natSetSystemFile(file);
  }
  
  public static void main(String[] args) throws Exception {
    //Win32FileSystem fs = new Win32FileSystem();
    //Runtime.getRuntime().load("c:/development/jsefs/Win32FileSystem.dll");
    //X509Certificate cer = new X509Certificate(new FileInputStream("c:/efsbenutzer.der.cer"));
    //System.out.println(Util.toString(cer.getFingerprintSHA(), ""));
    //fs.deleteCertificate(Util.toString(cer.getFingerprintSHA(), ""));
    //getNTFSDrives();
    /*System.out.println(System.getProperty("java.library.path"));
    System.out.println(isSystemFile("C:/test/system.txt"));
    System.out.println(setSystemFile("C:/test/system.txt"));
    System.out.println(isSystemFile("C:/test/system.txt"));
    System.out.println(getEnvironmentVariable("APPDATa"));
    System.out.println(secureDelete("c:/temp/testdatei.txt"));*/
    
  }
  
  public static String getEnvironmentVariable(String name) {
    return natGetEnvironmentVariable(name);
  }

  private static void extractAndLoadLib() throws Throwable {
    
    // try to load library
   
    String libName = "Win32FileSystem";
    
//    try {
//      System.loadLibrary(libName);
//      return;
//    } catch(UnsatisfiedLinkError err) {
//      // continue
//    }
    
    InputStream inputstream = Win32FileSystem.class.getResourceAsStream("/asit/" + libName + ".dll");
    if (inputstream == null) {
      throw new Exception("Library Win32FileSystem is not included in archive.");
    }
    byte abyte0[] = new byte[inputstream.available()];
    //ByteArrayOutputStream bos = new ByteArrayOutputStream();
    //Utils.dumpInputOutputStream(inputstream, bos);
    int i = 0;
    for(int j = inputstream.available(); i < j; i++)
        abyte0[i] = (byte)inputstream.read();
    
    //byte abyte0[] = bos.toByteArray();
    inputstream.close();
    String s = "cmd /c echo %SystemRoot%";
    String s2 = null;
    BufferedReader bufferedreader = null;
    try
    {
        Process process = Runtime.getRuntime().exec(s);
        bufferedreader = new BufferedReader(new InputStreamReader(new BufferedInputStream(process.getInputStream())));
    }
    catch(Exception exception)
    {
        String s1 = "command.com /c echo %windir%";
        try
        {
            Process process1 = Runtime.getRuntime().exec(s1);
            bufferedreader = new BufferedReader(new InputStreamReader(new BufferedInputStream(process1.getInputStream())));
        }
        catch(Exception exception1) { }
    }
    if(bufferedreader != null)
        s2 = bufferedreader.readLine();
    if(s2 == null || s2.equals("") || s2.equals("%SystemRoot%") || s2.equals("%windir%"))
    {
        throw new Exception("Could not find correct system root for windows. Neither SYSTEMROOT or WINDIR environment variables could give any useful information.\nHint: you can manually extract the file MSKeyStoreJNI.dll from the JAR file and copy it to an arbitrary directory defined in your PATH environment variable.");
    } else
    {
        String s3 = s2.replace('\\', '/');
        try {
        	FileOutputStream fileoutputstream = new FileOutputStream(s3 + "/" + libName + ".dll");
        	fileoutputstream.write(abyte0);
        	fileoutputstream.close();
        }
        catch (Throwable e) {
        	
        }
        System.loadLibrary(libName);
        return;
    }
  }

  
}
