package asit.config;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import javax.servlet.ServletContext;
import org.apache.struts.validator.ValidatorForm;


public class Configuration extends ValidatorForm {
  
  public static String CONFIG_FILE = "config.properties";

  protected static Hashtable values_ = new Hashtable();
  
  protected final static String MOASS_HOST = "MOASSHost";
  protected final static String MOASS_KEYID = "MOASSKeyIdentifier";
  
  protected final static String MOASP_HOST = "MOASPHost";
  protected final static String MOASP_TRUSTPROFILE = "MOASPTrustProfile";
  
  protected final static String MOASP_CERTIFICATE = "MOASPCertificate";
  
  protected final static String MOAZS_URL = "MOAZSURL";
  
  protected final static String SSURL = "SSURL";
  
  protected final static String MOA_SENDER = "MOASender";
  protected final static String MOAZS_SENDER = "MOAZSSender";
  protected final static String MOAZS_KEYIDENTIFER = "MOAZSKeyIdentifier";
  
  public String getMOAZSKeyIdentifier() {
    return (String)values_.get(MOAZS_KEYIDENTIFER);
  }
  
  public void setMOAZSKeyIdentifier(String keyid) {
    values_.put(MOAZS_KEYIDENTIFER, keyid);
  }
  
  public String getMOAZSSender() {
    return (String)values_.get(MOAZS_SENDER);
  }
  
  public void setMOAZSSender(String sender) {
    values_.put(MOAZS_SENDER, sender);
  }
  
  public String getMOASender() {
    return (String)values_.get(MOA_SENDER);
  }
  
  public void setMOASender(String sender) {
    values_.put(MOA_SENDER, sender);
  }
  
  public String getMOAZSURL() {
    return (String)values_.get(MOAZS_URL);
  }
  
  public void setMOAZSURL(String url) {
    values_.put(MOAZS_URL, url);
  }
  
  public String getMOASSHost() {
    return (String)values_.get(MOASS_HOST);
  }
  
  public String getSSURL() {
    return (String)values_.get(SSURL);
  }
  
  public String getMOASSKeyIdentifier() {
    return (String)values_.get(MOASS_KEYID);
  }
  
  
  public void setMOASSHost(String moass_host) {
    values_.put(MOASS_HOST, moass_host);
  }
  
  public void setSSURL(String ssurl) {
    values_.put(SSURL, ssurl);
  }
  
  public void setMOASSKeyIdentifier(String moass_keyid) {
    values_.put(MOASS_KEYID, moass_keyid);
  }
  
  public String getMOASPHost() {
    return (String)values_.get(MOASP_HOST);
  }
  
  public String getMOASPTrustProfile() {
    return (String)values_.get(MOASP_TRUSTPROFILE);
  }
  
  public String getMOASPCertificate() {
    return (String)values_.get(MOASP_CERTIFICATE);
  }

  public void setMOASPHost(String moasp_host) {
    values_.put(MOASP_HOST, moasp_host);
  }
  
  public void setMOASPTrustProfile(String moasp_trustprofile) {
    values_.put(MOASP_TRUSTPROFILE, moasp_trustprofile);
  }
  
  
  public void setMOASPCertificate(String moasp_certificate) {
    values_.put(MOASP_CERTIFICATE, moasp_certificate);
  }
  
  public void loadFromConfigFile(ServletContext context) throws IOException {
    
    values_.clear();
    
    Properties props = new Properties();
    String configFile = context.getRealPath("/WEB-INF/res/" + CONFIG_FILE);
    if ((new File(configFile)).exists()) {
      props.load(new FileInputStream(configFile));
    }
    Enumeration e = props.keys();
    
    while(e.hasMoreElements()) {
      String next = (String)e.nextElement();
      values_.put(next, props.getProperty(next));
    }
  }
  
  public void writeToConfigFile(ServletContext context) throws IOException {
    Properties props = new Properties();
    props.setProperty(MOASS_HOST, getMOASSHost());
    props.setProperty(MOASS_KEYID, getMOASSKeyIdentifier());
    
    props.setProperty(MOASP_HOST, getMOASPHost());
    props.setProperty(MOASP_TRUSTPROFILE, getMOASPTrustProfile());
    props.setProperty(MOASP_CERTIFICATE, getMOASPCertificate());
    props.setProperty(SSURL, getSSURL());
    props.setProperty(MOAZS_URL, getMOAZSURL());
    props.setProperty(MOA_SENDER, getMOASender());
    
    props.setProperty(MOAZS_SENDER, getMOAZSSender());
    props.setProperty(MOAZS_KEYIDENTIFER, getMOAZSKeyIdentifier());
    
    String configFile = context.getRealPath("/WEB-INF/res/" + CONFIG_FILE);

    FileOutputStream os = new FileOutputStream(configFile);
    props.store(os, "Configuration properties");
    os.flush();
    os.close();
  }
}
