package asit.config;
import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessages;
import asit.state.Success;


public class ConfigurationService extends Action {

  public static Log log_ = LogFactory.getLog(ConfigurationService.class.getName());
  
  public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request,
      HttpServletResponse response) throws ServletException, IOException {

    log_.debug("Entering configuration");
    
    Configuration config = (Configuration)form;
    
    // load configuration if requested new
    if ("change".equals(request.getParameter("action"))) {
      log_.debug("Loading configuration");
      config.loadFromConfigFile(request.getSession().getServletContext());
      return mapping.findForward("failure");
    }

    // do error handling
    ActionMessages errors = config.validate(mapping, request);
    log_.debug("Number of errors in configuration form found: " + errors.size());
    if (errors.size() > 0) {
      saveErrors(request, errors);
      return new ActionForward(mapping.getInput());
    }
    
    log_.debug("Ok, it seems all ok, we save the new configuration.");
    config.writeToConfigFile(request.getSession().getServletContext());
    
    Success success = new Success("Konfiguration erfolgreich aktualisiert.", "Konfiguration erfolgreich aktualisiert.");
    success.updateRequest(request);
    
    return mapping.findForward("success");
  }
}