/*
 * Created on 28.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.control;

import javax.servlet.http.HttpServletRequest;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.log4j.Logger;
import asit.bescheid.Bescheid;
import asit.bescheid.TextBlock;
import asit.common.LogFactory;
import asit.moa.client.deliver.address.AbstractPerson;
import asit.moa.client.deliver.address.Adressat;
import asit.moa.client.deliver.address.Behoerde;
import asit.moa.client.deliver.address.KompNatuerlichePerson;
import asit.moa.client.deliver.address.KompPostalAddress;


public class FlowControl {
  
  public static Logger log_ = LogFactory.getLogger(FlowControl.class.getName());
  
  // this method does not return a null person
  public static AbstractPerson getPerson(String location, int mainLocation, int index, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");
    
    AbstractPerson person = null;
    
    // person in Adressat
    if ("address".equalsIgnoreCase(location)) {
      person = bescheid.getAdressat().getPerson();
    } else if ("parteiantrag".equalsIgnoreCase(location)) {
      if (bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index) == null) {
        return new KompNatuerlichePerson();
      } else {
        person = bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index).getPerson();
      }
    } else if ("eckdaten".equalsIgnoreCase(location)) {
      
      Adressat adr = (Adressat)bescheid.getBWeitereEckDaten().get(index);
      
      person = adr.getPerson();
      
    } else if ("sachbearbeiter".equalsIgnoreCase(location)) {
      try {  
        Behoerde behoerde = new Behoerde();
        behoerde.loadDefaults(request.getSession().getServletContext());
        
        return (KompNatuerlichePerson)behoerde.getSachbearbeiter().get(index);
        
      } catch(Exception e) {
        e.printStackTrace();
      }
        
    } else if ("behoerde".equalsIgnoreCase(location)) {
      try {
        Behoerde behoerde = new Behoerde();
        behoerde.loadDefaults(request.getSession().getServletContext());
        return behoerde.getBehoerde();
      } catch(Exception e) {
        e.printStackTrace();
      }
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }
    
    // per default we create a natuerliche person
    if (person == null) {
      person = new KompNatuerlichePerson();
    }
    
    return person;
  }
  
//this method does not return a null person
  public static KompPostalAddress getPostalAddress(String location, int mainLocation, int index, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");
    
    KompPostalAddress address = null;
    
    // person in Adressat
    if ("address".equalsIgnoreCase(location)) {
      address = bescheid.getAdressat().getPostAddress();
    } else if ("parteiantrag".equalsIgnoreCase(location)) {
      if (bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index) == null) {
        return new KompPostalAddress();
      } else {
        address = bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index).getPostAddress();
      }
    } else if ("eckdaten".equalsIgnoreCase(location)) {
      
      Adressat adr = (Adressat)bescheid.getBWeitereEckDaten().get(index);
      
      address = adr.getPostAddress();
      
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }
    
    // per default we create a natuerliche person
    if (address == null) {
      address = new KompPostalAddress();
    }
    
    return address;
  }
  
  // this method does not return a null person
  public static void setPerson(String location, int mainLocation, int index, AbstractPerson person, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");

    log_.debug("Ok saving person in: " + location);
    
    // person in Adressat
    if ("address".equalsIgnoreCase(location)) {
      bescheid.getAdressat().setPerson(person);
    } else if ("parteiantrag".equalsIgnoreCase(location)) {
      if (bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index) == null) {
        bescheid.getSpruchteil(mainLocation).addParteienAntragPartei("", new Adressat());
        index = bescheid.getSpruchteil(mainLocation).getParteienAntragParteien().size()-1;
      }
      bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index).setPerson(person);
    } else if ("eckdaten".equalsIgnoreCase(location)) {
      
      Adressat adr = (Adressat)bescheid.getBWeitereEckDaten().get(index);
      
      if (adr == null) {
        adr = new Adressat();
        adr.setPerson(person);
        bescheid.getBWeitereEckDaten().add(adr);
      } else {
        adr.setPerson(person);
      }
    } else if ("sachbearbeiter".equalsIgnoreCase(location)) {
      Behoerde b = new Behoerde();
      try {
        b.loadDefaults(request.getSession().getServletContext());
      } catch(Exception e) {
        e.printStackTrace();
      }
      log_.debug("fuege sachbearbeiter hinzu");
      if (index >= 0) {
        b.getSachbearbeiter().set(index, person);
      } else {
        b.getSachbearbeiter().add(person);
      }
      log_.debug("anzahl: " + b.getSachbearbeiter().size());
      log_.debug("Schreibe hinaus");
      b.saveAll();
    } else if ("behoerde".equalsIgnoreCase(location)) {
      Behoerde behoerde = new Behoerde();
      try {
        behoerde.loadDefaults(request.getSession().getServletContext());
        BeanUtils.copyProperties(behoerde.getBehoerde(), person);
        behoerde.saveAll();
        //request.getSession().setAttribute("Behoerde", behoerde);
      } catch(Exception e) {
          e.printStackTrace();
      }
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }
  }
  
//this method does not return a null person
  public static void setPostalAddress(String location, int mainLocation, int index, KompPostalAddress address, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");

    log_.debug("Ok saving person in: " + location);
    
    // person in Adressat
    if ("address".equalsIgnoreCase(location)) {
      bescheid.getAdressat().setPostAddress(address);
    } else if ("parteiantrag".equalsIgnoreCase(location)) {

      log_.debug("Spruchteil " + mainLocation + ": " + (bescheid.getSpruchteil(mainLocation) == null));
      
      log_.debug("Partei " + index + ": " + (bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index) == null));
      
      if (bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index) == null) {
        log_.debug("Create new partei");
        bescheid.getSpruchteil(mainLocation).addParteienAntragPartei("", new Adressat());
        index = bescheid.getSpruchteil(mainLocation).getParteienAntragParteien().size()-1;
      }
      log_.debug("Partei " + index + ": " + (bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index) == null));
      bescheid.getSpruchteil(mainLocation).getParteienAntragPartei(index).setPostAddress(address);
    } else if ("eckdaten".equalsIgnoreCase(location)) {
      if (index >= 0) {
        Adressat adr = (Adressat)bescheid.getBWeitereEckDaten().get(index);
        
        if (adr == null) {
          adr = new Adressat();
          adr.setPostAddress(address);
          bescheid.getBWeitereEckDaten().add(adr);
        } else {
          adr.setPostAddress(address);
        }
      } else {
        bescheid.getBWeitereEckDaten().add(address);
      }
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }
  }
  
  
   
  
  
  //this method does not return a null person
  public static void setTextBlock(String location, int locationIndex, int index, TextBlock block, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");
    
    // add textblocks
    if ("parteiantrag".equalsIgnoreCase(location)) {
      if (index >= 0) {
        log_.debug("Hinzufuegen von textblock in parteiantrag: locationindex = " + locationIndex + " index = " + index); 
        bescheid.getSpruchteil(locationIndex).setParteienAntragTextBlock(index, block);
      } else {
        log_.debug("Hinzufuegen von textblock in parteiantrag: locationindex = " + locationIndex + " index = " + index);
        bescheid.getSpruchteil(locationIndex).addParteienAntragTextBlock(block);
      }
    } else if ("amtsanlass".equalsIgnoreCase(location)) {
      if (index >= 0) {
        bescheid.getSpruchteil(locationIndex).setAmtsanlassTextBlock(index, block);
      } else {
        bescheid.getSpruchteil(locationIndex).addAmtsanlassTextBlock(block);
      }
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }
  }
  
  //this method does not return a null person
  public static void setAdressat(String location, int locationIndex, int index, Adressat adressat, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");
    
    Adressat adr = null;

    log_.debug("Setting adressat: locationIndex = " + locationIndex + " index= " + index);
    
    log_.debug("location=" + location);
    
    // add textblocks
    if ("parteiantrag".equalsIgnoreCase(location)) {
      if (index >= 0) {
        adr = bescheid.getSpruchteil(locationIndex).getParteienAntragPartei(index);
      }
      
      if (index < 0 || adr == null) {
        adr = adressat;
        bescheid.getSpruchteil(locationIndex).addParteienAntragPartei(null, adr);
      }
    } else if ("address".equalsIgnoreCase(location)) {
      if (index >= 0) {
        adr = bescheid.getBAdressat();
      }
      if (index < 0 || adr == null) {
        adr = adressat;
        bescheid.setBAdressat(adr);
      }
    } else if ("eckdaten".equalsIgnoreCase(location)) {
      if (index >= 0 && index < bescheid.getBWeitereEckDaten().size()) {
        adr = (Adressat)bescheid.getBWeitereEckDaten().get(index);
      } else {
        adr = new Adressat();
        bescheid.getBWeitereEckDaten().add(adr);
      }
      if (index < 0 || adr == null) {
        adr = adressat;
        bescheid.getBWeitereEckDaten().set(index, adr);
      }
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }

    adr.setAInternetAdress(adressat.getAInternetAdress());
    adr.setATelefonnummer(adressat.getATelefonnummer());
  }
  
  public static Adressat getAdressat(String location, int locationIndex, int index, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");
    
    Adressat adr = null;
    
    // add textblocks
    if ("parteiantrag".equalsIgnoreCase(location)) {
      return bescheid.getSpruchteil(locationIndex).getParteienAntragPartei(index);
    } else if ("address".equalsIgnoreCase(location)) {
      return bescheid.getBAdressat();
    } else if ("eckdaten".equalsIgnoreCase(location)) {
      if (index < bescheid.getBWeitereEckDaten().size()) {
        return (Adressat)bescheid.getBWeitereEckDaten().get(index);
      } else {
        Adressat adressat = new Adressat();
        bescheid.getBWeitereEckDaten().add(adressat);
        return adressat;
      }
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }
  }
  
  //this method does not return a null person
  public static TextBlock getTextBlock(String location, int locationIndex, int index, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");
    
    // person in Adressat
    if ("parteiantrag".equalsIgnoreCase(location)) {
      return bescheid.getSpruchteil(locationIndex).getParteienAntragTextBlock(index);
    } else if ("amtsanlass".equalsIgnoreCase(location)) {
      return bescheid.getSpruchteil(locationIndex).getAmtsanlassTextBlock(index);
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }
  }
  
//this method does not return a null person
  public static void deleteTextBlock(String location, int locationIndex, int index, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");
    
    // person in Adressat
    if ("parteiantrag".equalsIgnoreCase(location)) {
      bescheid.getSpruchteil(locationIndex).removeParteienAntragTextBlock(index);
    } else if ("amtsanlass".equalsIgnoreCase(location)) {
      bescheid.getSpruchteil(locationIndex).removeAmtsanlassTextBlock(index);
      
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }
  }
  
//this method does not return a null person
  public static void deleteAddress(String location, int locationIndex, int index, HttpServletRequest request) throws FlowControlException {

    Bescheid bescheid = (Bescheid)request.getSession().getAttribute("Bescheid");
    
    // person in Adressat
    if ("parteiantrag".equalsIgnoreCase(location)) {
      bescheid.getSpruchteil(locationIndex).removeParteienAntragPartei(index);
    } else {
      throw new FlowControlException("Ungltige Location Angabe", "Der \"location\" Parameter in der Anfrage enthlt einen ungltigen Wert.");
    }
  }
  
}
