/*
 * Created on 22.07.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.framework.servlet;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import asit.framework.servlet.content.ContentFactory;

/**
 * @author troessler
 * 
 *  
 */
public abstract class BackEndServlet extends HttpServlet {

    protected String serverAddress_;

    protected boolean debugMode_ = true;

    protected ContentFactory contentFacotryImpl_;

    protected ServletConfig globalServletConfig_;

    /**
     * servlet initialization
     */
    public void init(ServletConfig config) throws ServletException {

        //		it is very important to set the encoding to UTF-8 in order to process
        System.setProperty("file.encoding", "UTF8");

        this.globalServletConfig_ = config;

        try {

            this.serverAddress_ = config.getServletContext().getInitParameter(
                    ServletConstants.WEBXML_SERVER_ADDRESS);

            this.debugMode_ = config.getServletContext().getInitParameter(
                    ServletConstants.WEBXML_DEBUG_MODE)
                    .equalsIgnoreCase("true");
            
            this.contentFacotryImpl_ = setContentFacotryImpl();

        } catch (Exception e) {

            // TODO log4j
            e.printStackTrace();
        }

    }

    /**
     *  
     */
    public void doGet(HttpServletRequest request, HttpServletResponse response)
            throws IOException, ServletException {
        doPost(request, response);

    }

    /**
     * @throws IOException
     * @throws ServletException
     *  
     */
    public void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        // very important - otherwise due to lacking encoding definition in the
        // request
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html; charset=UTF-8");

        
        // use factory interface
        this.contentFacotryImpl_.setHttpServletRequest(request);
        this.contentFacotryImpl_.setHttpServletResponse(response);
        String stringtowrite = this.contentFacotryImpl_.getResponseString();

        PrintWriter out = response.getWriter();

        if (stringtowrite != null) {
            out.println(stringtowrite);
        }
        out.flush();
        out.close();
    }

    protected void setServerAddress(String serverAddress) {
        this.serverAddress_ = serverAddress;
    }
    
    protected abstract ContentFactory setContentFacotryImpl() throws Exception;

    /**
     * 
     * @param filename
     * @return
     */
    public String getRealPath(String filename) {
        return this.globalServletConfig_.getServletContext().getRealPath(filename);
    }

}