package asit.framework.servlet;


import iaik.ixsil.exceptions.DOMUtilsException;
import iaik.ixsil.util.DOMUtilsImpl;
import java.io.IOException;
import java.io.OutputStream;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;
import org.w3c.dom.Document;
import asit.framework.servlet.content.ContentFactory;

/**
 * @author Arne Tauber
 */
public class ShowData extends HttpServlet {

    protected String dispatchJSP_ = "dispatch.jsp";

    protected String serverAddress_;

    protected boolean debugMode_ = true;

    protected RequestDispatcher jspDispatcher_;

    protected ContentFactory contentFactoryImpl_;
    
    protected ServletConfig globalServletConfig_;

    /**
     * The Logger
     */
    static Logger logger_ = Logger.getLogger(ShowData.class.getName());
    
    /**
     * servlet initialization
     */
    public void init(ServletConfig config) throws ServletException {

        // it is very important to set the encoding to UTF-8 in order to process
        System.setProperty("file.encoding", "UTF8");
        
        this.globalServletConfig_ = config;
        
        try {

            this.serverAddress_ = config.getServletContext().getInitParameter(
                    ServletConstants.WEBXML_SERVER_ADDRESS);

            this.debugMode_ = "true".equalsIgnoreCase(config.getServletContext().getInitParameter(
                    ServletConstants.WEBXML_DEBUG_MODE));
                    
            

        } catch (Exception e) {

            // TODO log4j
            e.printStackTrace();
        }

    }

    
    public void doGet(HttpServletRequest request, HttpServletResponse response)
            throws IOException, ServletException {
        doPost(request, response);

    }

    public void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        logger_.debug("Entering doPost.");
        logger_.debug("Session: " + request.getSession(true).getId());
      
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html; charset=UTF-8");

        //PrintWriter out = response.getWriter();
        OutputStream out = response.getOutputStream();
        
        if (!request.getParameter("sessionid").equals(request.getSession(true).getId()) ||
             (request.getSession().getAttribute("xmldata") == null)) {
          response.setContentType("text/html");
          out.write(getNotFoundText().getBytes("UTF-8"));
        } else {
         
          // Write xml document
          response.setContentType("text/xml");
          Document resp = (Document)request.getSession().getAttribute("xmldata");
          try {
            DOMUtilsImpl.serializeDocument(resp, out);
          } catch (DOMUtilsException e) {
            e.printStackTrace();
          }
          
        }
        

    }

    protected String getNotFoundText() {
      String ret = "<html>" +
              "<head>" +
              "<title>Nicht gefunden</title>" +
              "</head>" +
              "<body>" +
              "<h1>Fehler - Nicht gefunden</h1>" +
              "<p>Die angeforderte Ressource ist leider nicht verf&uuml;gbar.</p>" +
              "</body>" +
              "</html>";
              
      return ret;
    }
 
    protected void setServerAddress(String serverAddress) {
        this.serverAddress_ = serverAddress;
    }

    
    /**
     * 
     * @param filename
     * @return
     */
    public String getRealPath(String filename) {        
        return this.globalServletConfig_.getServletContext().getRealPath(filename);
    }
   
}

