/*
 * Created on 21.07.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.framework.servlet.content;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author troessler
 * 
 *  
 */
public abstract class ContentFactory {

    protected Properties messageProperties_;
    
    protected HttpServletRequest httpServletRequest_;
    
    protected String contentDefaultEncoding_ = "UTF-8";

    /*
     * If another JSP is used and the factory wants to set more attributes.
     */
    //protected Vector otherAttributes_ = null;
    
    /*
     * If the factory wants to redirect the request to another JSP.
     */
    protected String redirector_ = null;
    
    
    public String getRedirector() {
      return redirector_;
    }
    
    /**
     * 
     * @param messagepropertiesfile
     * @throws IOException
     */
    public ContentFactory(File messagepropertiesfile) throws IOException {
//    	 System.out.println(messagepropertiesfile.getAbsolutePath());
       FileInputStream fis = new FileInputStream(messagepropertiesfile);
       this.messageProperties_ = new Properties();
       this.messageProperties_.load(fis);

    }

    /*public Vector getAttributes() {
      return otherAttributes_;
    }
    
    protected void addAttribute(String attributeName, String value) {
      if (otherAttributes_ == null) {
        otherAttributes_ = new Vector();
      }
      otherAttributes_.addElement(new Attribute(attributeName, value));
    }*

    
    /**
     * 
     * @param key
     * @return
     */
    public String getPropertyValue(String key) {
        return this.messageProperties_.getProperty(key);
    }

    /**
     * interface used for a FrontEndServlet
     * @return
     */
    public abstract String getPageTitle();

    /**
     * interface used for a FrontEndServlet
     * @return
     */
    public abstract String getDispatchTitle();

    /**
     * interface used for a FrontEndServlet
     * @return
     */
    public abstract String getContentTitle();

    /**
     * interface used for a FrontEndServlet
     * @return
     */
    public abstract String getContent();

    /**
     * interface used for a BackEndServlet
     * @return
     */
    public abstract String setHttpServletResponse(HttpServletResponse response);
 
    /**
     * interface used for a BackEndServlet
     * @return
     */
    public abstract String getResponseString();
    
    /*
     * store parameter-map
     */
    public void setHttpServletRequest(HttpServletRequest request) {
       this.httpServletRequest_ = request;
    }

}