/*
 * Created on 20.07.2004
 *
 */
package asit.framework.servlet.content;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import asit.common.Utils;

/**
 * @author troessler
 *
 * 
 */
public abstract class ContentFromXMLFactory extends ContentFactory {
    
    protected String baseXMLFileContent_ = "";    
    
    public ContentFromXMLFactory(File messagepropertiesfile, File basexmlfile) throws IOException {
        super(messagepropertiesfile);
        
        FileInputStream fis = new FileInputStream(basexmlfile);      
        int ch;
        while ((ch=fis.read()) >= 0) 
            this.baseXMLFileContent_ += (char) ch;
  
    }

    
    /**
     * 
     * @param key
     * @param value
     */
    protected void replaceValue(String key, String value) {
     
        // Compile regular expression
        Pattern pattern = Pattern.compile(key);

        // Replace all occurrences of pattern in input
        Matcher matcher = pattern.matcher(this.baseXMLFileContent_);
        this.baseXMLFileContent_ = matcher.replaceAll(value);     
        
    }
    
    /**
     * 
     * @return
     */
    public String getBaseXMLStringQuoted() {
        
        return Utils.simpleQuoter(this.baseXMLFileContent_);
    }
    
    
}
