/*
 * Created on 21.07.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.framework.servlet.content;

import java.io.File;
import java.io.IOException;
import java.net.URLEncoder;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;

/**
 * @author troessler
 * 
 *  
 */
public class IdentityLinkRequestFactory extends SecurityLayerRequestFactory {

    // name of the class of properties used in this factory
    public static String FACTORY_PROPERTIES_CLASS = "IdentityLinkRequestFactory";

    // special fields of the properties-file

    /**
     * @param basexmlfile
     * @throws IOException
     */
    public IdentityLinkRequestFactory(File configpropertiesfile,
            File basexmlfile) throws IOException {
        super(configpropertiesfile, basexmlfile);
    }

    /*
     * (non-Javadoc)
     * 
     * @see asit.servlet.content.ContentFactory#getPageTitle()
     */
    public String getPageTitle() {
        return getPropertyValue(IdentityLinkRequestFactory.FACTORY_PROPERTIES_CLASS
                + "." + MessagePropertiesConstants.MSG_FIELD_PAGETITLE);
    }

    /*
     * (non-Javadoc)
     * 
     * @see asit.servlet.content.ContentFactory#getDispatchTitle()
     */
    public String getDispatchTitle() {
        return getPropertyValue(IdentityLinkRequestFactory.FACTORY_PROPERTIES_CLASS
                + "." + MessagePropertiesConstants.MSG_FIELD_DISPATCHTITLE);
    }

    /*
     * (non-Javadoc)
     * 
     * @see asit.servlet.content.ContentFactory#getContentTitle()
     */
    public String getContentTitle() {
        return getPropertyValue(IdentityLinkRequestFactory.FACTORY_PROPERTIES_CLASS
                + "." + MessagePropertiesConstants.MSG_FIELD_CONTENTTITLE);
    }

    /*
     * (non-Javadoc)
     * 
     * @see asit.servlet.content.ContentFactory#getContent()
     */
    public String getContent() {

        String dataurl;
        String stylesheeturl;
        String redirecturl;
        String capsuleaddress;
        String buttonname;
        String formtext;

        dataurl = getPropertyValue(super.FACTORY_PROPERTIES_CLASS + "."
                + super.FACTORY_PROPERTIES_SECLAY_DATAURL);
        redirecturl = getPropertyValue(super.FACTORY_PROPERTIES_CLASS + "."
                + super.FACTORY_PROPERTIES_SECLAY_REDIRECTURL);
        stylesheeturl = getPropertyValue(super.FACTORY_PROPERTIES_CLASS + "."
                + super.FACTORY_PROPERTIES_SECLAY_STYLESHEETURL);
        buttonname = getPropertyValue(super.FACTORY_PROPERTIES_CLASS + "."
                + super.FACTORY_PROPERTIES_SENDBUTTONNAME);
        formtext = getPropertyValue(super.FACTORY_PROPERTIES_CLASS + "."
                + super.FACTORY_PROPERTIES_FORMTEXT);
        capsuleaddress = getPropertyValue(super.FACTORY_PROPERTIES_CLASS + "."
                + super.FACTORY_PROPERTIES_SECLAY_CAPSULEADDRESS);

        return prepareHTMLRequest(capsuleaddress, this.baseXMLFileContent_,
                dataurl, stylesheeturl, redirecturl, buttonname, formtext);
    }

    /*
     * (non-Javadoc)
     * 
     * @see asit.framework.servlet.content.ContentFactory#getResponseString()
     */
    public String getResponseString() {

        return "";
    }

    /*
     * (non-Javadoc)
     * 
     * @see asit.framework.servlet.content.ContentFactory#getHttpResponse()
     */
    public String setHttpServletResponse(HttpServletResponse response) {

        // set main header fields
        response.setContentType("application/x-www-form-urlencoded"); 
        String outputstring = "";
        try {
            
            ServletOutputStream responsestream = response.getOutputStream();
            outputstring += super.HTTP_REQUEST_PARAM_XMLREQUEST + "="
                    + URLEncoder.encode(this.baseXMLFileContent_);

            String actualkeyvalue;
            if ((actualkeyvalue = getPropertyValue(IdentityLinkRequestFactory.FACTORY_PROPERTIES_CLASS
                    + "." + IdentityLinkRequestFactory.FACTORY_PROPERTIES_SECLAY_DATAURL)) != null)
                
                outputstring += "&"+IdentityLinkRequestFactory.HTTP_REQUEST_PARAM_DATAURL + "="
                        + URLEncoder.encode(actualkeyvalue, contentDefaultEncoding_);
            
            if ((actualkeyvalue = getPropertyValue(IdentityLinkRequestFactory.FACTORY_PROPERTIES_CLASS                                               
                    + "." + IdentityLinkRequestFactory.FACTORY_PROPERTIES_SECLAY_REDIRECTURL)) != null)
                outputstring += "&"+IdentityLinkRequestFactory.HTTP_REQUEST_PARAM_REDIRECTURL + "="
                        + URLEncoder.encode(actualkeyvalue, contentDefaultEncoding_);
            
            if ((actualkeyvalue = getPropertyValue(IdentityLinkRequestFactory.FACTORY_PROPERTIES_CLASS
                    + "." + IdentityLinkRequestFactory.FACTORY_PROPERTIES_SECLAY_STYLESHEETURL)) != null)
                outputstring += "&"+IdentityLinkRequestFactory.HTTP_REQUEST_PARAM_STYLESHEETURL + "="
                        + URLEncoder.encode(actualkeyvalue, contentDefaultEncoding_);   
                   
            // remember: the stream has to be written in the last service,... 
            
            
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return outputstring;
    }

}