package asit.framework.servlet.content;

import iaik.x509.X509Certificate;


public class SimpleVerifyResultFactory extends VerifyResult {

  protected String pageTitle_ = null;
  protected String authority_ = null;
  protected String signerName_ = null;
  protected String signerOU_ = null;
  protected String signerO_ = null;
  protected String signerC_ = null;
  protected String issuerName_ = null;
  protected String issuerOU_ = null;
  protected String issuerO_ = null;
  protected String issuerC_ = null;
  protected String certSerial_ = null;
  protected String certQuality_ = null;
  protected String signCheck_ = null;
  protected String certCheck_ = null;
  protected boolean sC_ = false;
  protected boolean cC_ = false;
  
  protected X509Certificate certificate_ = null;
  
  public SimpleVerifyResultFactory() {}
  
  public SimpleVerifyResultFactory(String pageTitle, String authority,
                                   String signerName, String signerOU,
                                   String signerO, String signerC,
                                   String issuerName, String issuerOU,
                                   String issuerO, String issuerC,
                                   String certSerial, String certQuality,
                                   String signCheck, String certCheck, boolean sC, boolean cC, X509Certificate certificate) {
    
    pageTitle_ = pageTitle;
    authority_ = authority;
    signerName_ = signerName;
    signerOU_ = signerOU;
    signerO_ = signerO;
    signerC_ = signerC;
    issuerName_ = issuerName;
    issuerOU_ = issuerOU;
    issuerO_ = issuerO;
    issuerC_ = issuerC;
    certSerial_ = certSerial;
    certQuality_ = certQuality;
    signCheck_ = signCheck;
    certCheck_ = certCheck;
    sC_ = sC;
    cC_ = cC;
    certificate_ = certificate;
  }

  public X509Certificate getCertificate() {
    return certificate_;
  }
  
  public void setCertificate(X509Certificate cert) {
    certificate_ = cert;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getPageTitle()
   */
  public String getPageTitle() {
    return pageTitle_;
  }
  
  public void setPageTitle(String title) {
    pageTitle_ = title;
  }

  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getAuthority()
   */
  public String getAuthority() {
    return authority_;
  }

  public void setAuthority(String authority) {
    authority_ = authority;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getSignerName()
   */
  public String getSignerName() {
    return signerName_;
  }

  public void setSignerName(String name) {
    signerName_ = name;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getSignerOrganizationalUnit()
   */
  public String getSignerOrganizationalUnit() {
    return signerOU_;
  }

  public void setSignerOrganizationalUnit(String unit) {
    signerOU_ = unit;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getSignerOrganization()
   */
  public String getSignerOrganization() {
    return signerO_;
  }

  public void setSignerOrganization(String org) {
    signerO_ = org;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getSignerCountry()
   */
  public String getSignerCountry() {
    return signerC_;
  }

  public void setSignerCountry(String c) {
    signerC_ = c;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getIssuerName()
   */
  public String getIssuerName() {
    return issuerName_;
  }

  public void setIssuerName(String name) {
    issuerName_ = name;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getIssuerOrganizationalUnit()
   */
  public String getIssuerOrganizationalUnit() {
    return issuerOU_;
  }

  public void setIssuerOrganizationalUnit(String unit) {
    issuerOU_ = unit;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getIssuerOrganization()
   */
  public String getIssuerOrganization() {
    return issuerO_;
  }

  public void setIssuerOrganization(String org) {
    issuerO_ = org;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getIssuerCountry()
   */
  public String getIssuerCountry() {
    return issuerC_;
  }

  public void setIssuerCountry(String c) {
    issuerC_ = c;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getCertSerial()
   */
  public String getCertSerial() {
    return certSerial_;
  }

  public void setCertSerial(String serial) {
    certSerial_ = serial;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getCertQuality()
   */
  public String getCertQuality() {
    return certQuality_;
  }

  public void setCertQuality(String quality) {
    certQuality_ = quality;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getSignatureCheckResult()
   */
  public String getSignatureCheckResult() {
    return signCheck_;
  }

  public void setSignatureCheckResult(String result) {
    signCheck_ = result;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResultFactory#getCertificateCheckResult()
   */
  public String getCertificateCheckResult() {
    return certCheck_;
  }
  
  public void setCertificateCheckResult(String result) {
    certCheck_ = result;
  }

  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResult#signatureCheck()
   */
  public boolean signatureCheck() {
    return sC_;
  }

  public void setSignatureCheck(boolean check) {
    sC_ = check;
  }
  
  /* (non-Javadoc)
   * @see asit.framework.servlet.content.VerifyResult#certificateCheck()
   */
  public boolean certificateCheck() {
    return cC_;
  }
  
  public void setCertificatecheck(boolean check) {
    cC_ = check;
  }
  
  
}
