/*
 * Created on 27.07.2004
 * 
 * TODO To change the template for this generated file go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
package asit.framework.xml;

import iaik.utils.Base64InputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.math.BigInteger;
import java.security.PublicKey;
import java.security.interfaces.RSAPublicKey;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Stack;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import asit.common.ECDSAConverterException;
import asit.common.ECDSAKeyValueConverter;
import asit.moa.client.exception.ClientException;
import asit.moa.client.verify.VerifyResult;
import asit.moa.client.verify.VerifySignatureClient;

/**
 * @author troessler
 * 
 * 
 */
public class IdentityLink {
	/**
	 * holds the IdentityLink XML-document (SAML-Assertion)
	 */
	protected Element idLinkDocument_;
	protected Element rootElement_;
	protected Element samlSubjectElement_;
	protected Stack samlAttributeElements_;
	public boolean debugMode = false;
  
  public String issueInstant = null;
  
	// define some namespaces
	public final static String SAML_NAMESPACE_PREFIX = "saml";
	public final static String SAML_NAMESPACE_URI = "urn:oasis:names:tc:SAML:1.0:assertion";
	public final static String PR_NAMESPACE_PREFIX = "pr";
	public final static String PR_NAMESPACE_URI = "http://reference.e-government.gv.at/namespace/persondata/20020228#";
	public final static String DSIG_NAMESPACE_PREFIX = "dsig";
	public final static String DSIG_NAMESPACE_URI = "http://www.w3.org/2000/09/xmldsig#";
	public final static String XSI_NAMESPACE_PREFIX = "xsi";
	public final static String XSI_NAMESPACE_URI = "http://www.w3.org/2001/XMLSchema-instance";
	// define Element names:
	public final static String ELEMENT_PERSON = "";
	public final static String ELEMENT_PERSON_IDENTIFICATION = "Identification";
	public final static String ELEMENT_PERSON_IDENTIFICATION_TYPE = "Type";
	public final static String ELEMENT_PERSON_IDENTIFICATION_VALUE = "Value";
	public final static String ELEMENT_PERSON_NAME = "Name";
	public final static String ELEMENT_PERSON_GIVENNAME = "GivenName";
	public final static String ELEMENT_PERSON_FAMILYNAME = "FamilyName";
	public final static String ELEMENT_PERSON_DATEOFBIRTH = "DateOfBirth";
	public final static String ELEMENT_RSAKEYVALUE_MODULUS = "Modulus";
	public final static String ELEMENT_RSAKEYVALUE_EXPONENT = "Exponent";
	public final static String ELEMENT_SUBJECT_GIVENNAME = "GivenName";
	public final static String ELEMENT_SUBJECT_FAMILYNAME = "FamilyName";
	public final static String ELEMENT_SIGNATURE = "Signature";

	public final static String ELEMENT_RSAKEYVALUE = "RSAKeyValue";
	public final static String ELEMENT_MODULUS = "Modulus";
	public final static String ELEMENT_EXPONENT = "Exponent";
	public final static String ELEMENT_ECDSAKEYVALUE = "ECDSAKeyValue";

	/**
	 * 
	 * @param xmlidentitylink
	 */
	public IdentityLink(String xmlidentitylink) {
		this.rootElement_ = null;
		ByteArrayInputStream inputstream = new ByteArrayInputStream(
				xmlidentitylink.getBytes());
		// gain the XML-Document
		DocumentBuilderFactory docbuifac = DocumentBuilderFactory.newInstance();
		docbuifac.setValidating(false);
		docbuifac.setNamespaceAware(true);
		DocumentBuilder docbui = null;
		try {
			docbui = docbuifac.newDocumentBuilder();
			this.idLinkDocument_ = docbui.parse(inputstream).getDocumentElement();
      this.issueInstant = this.idLinkDocument_.getAttribute("IssueInstant");
		} catch (Exception e) {
			if (this.debugMode)
				e.printStackTrace();
		}
		this.rootElement_ = this.idLinkDocument_;
	}

	/**
	 * 
	 * @param xmlidentitylink
	 */
	public IdentityLink(Element xmlidentitylink) {

		this.idLinkDocument_ = xmlidentitylink;
		this.rootElement_ = this.idLinkDocument_;
    this.issueInstant = this.idLinkDocument_.getAttribute("IssueInstant");
	}
  
  public IdentityLink(Document xmlidentitylink) {

    this.idLinkDocument_ = xmlidentitylink.getDocumentElement();
    this.rootElement_ = this.idLinkDocument_;
    this.issueInstant = this.idLinkDocument_.getAttribute("IssueInstant");
  }

	/**
	 * 
	 * @return
	 */
	public Hashtable getIdentifications() {
		return getPairsOfElements(IdentityLink.PR_NAMESPACE_PREFIX + ":"
				+ IdentityLink.ELEMENT_PERSON_IDENTIFICATION_TYPE,
				IdentityLink.PR_NAMESPACE_PREFIX + ":"
						+ IdentityLink.ELEMENT_PERSON_IDENTIFICATION_VALUE);
	}

	/**
	 * 
	 * @return
	 */
	public Hashtable getRSAKeyValues() {
		return getPairsOfElements(IdentityLink.DSIG_NAMESPACE_PREFIX + ":"
				+ IdentityLink.ELEMENT_RSAKEYVALUE_MODULUS,
				IdentityLink.DSIG_NAMESPACE_PREFIX + ":"
						+ IdentityLink.ELEMENT_RSAKEYVALUE_EXPONENT);
	}

	/**
	 * 
	 * @return
	 */
	public Hashtable getPairsOfElements(String elementone, String elementtwo) {
		Hashtable pairs = new Hashtable();
		NodeList idtypes = this.idLinkDocument_
				.getElementsByTagName(elementone);
		NodeList idvalues = this.idLinkDocument_
				.getElementsByTagName(elementtwo);
		for (int index = 0; index < idtypes.getLength(); index++) {
			pairs.put(idtypes.item(index).getFirstChild().getNodeValue(),
					idvalues.item(index).getFirstChild().getNodeValue());
		}
		return pairs;
	}

	/**
	 * 
	 * @return
	 */
	public String getGivneName() {
		NodeList result = this.idLinkDocument_
				.getElementsByTagName(IdentityLink.PR_NAMESPACE_PREFIX + ":"
						+ IdentityLink.ELEMENT_SUBJECT_GIVENNAME);

		return (result.item(0).getFirstChild().getNodeValue());
	}

	/**
	 * 
	 * @return
	 */
	public String getSurname() {

		NodeList result = this.idLinkDocument_
				.getElementsByTagName(IdentityLink.PR_NAMESPACE_PREFIX + ":"
						+ IdentityLink.ELEMENT_SUBJECT_FAMILYNAME);

		return (result.item(0).getFirstChild().getNodeValue());
	}

	/**
	 * 
	 * @return
	 */
	public String getDateOfBirth() {

		NodeList result = this.idLinkDocument_
				.getElementsByTagName(IdentityLink.PR_NAMESPACE_PREFIX + ":"
						+ IdentityLink.ELEMENT_PERSON_DATEOFBIRTH);

		return (result.item(0).getFirstChild().getNodeValue());
	}

	/**
	 * 
	 * @param verifyClient
	 * @param moaspaddress
	 * @return
	 * @throws ClientException
	 */
	public VerifyResult verifySignatureOnIdentityLink(
			VerifySignatureClient verifyClient) throws ClientException {

		ElementNameTranslationTable qualifiedNameTable = new ElementNameTranslationTable(
				this.idLinkDocument_);
		String qualifiedNameForSignatureElem = qualifiedNameTable
				.getElementsQualifiedName(ELEMENT_SIGNATURE);
		String namespaceForSignatureElem = this.idLinkDocument_
				.getElementsByTagName(qualifiedNameForSignatureElem).item(0)
				.getNamespaceURI();
		// verirfy signature using MOA-SP
		// verify against the actual date and time
		verifyClient.setContent(this.idLinkDocument_);
    
    SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
    try {
      // we MUST set the date
      verifyClient.setDate(format.parse(issueInstant));
    } catch(Exception e) {
      e.printStackTrace();
      throw new ClientException(e);
    }
		verifyClient.setSignatureLocation("//" + qualifiedNameForSignatureElem);
		verifyClient.addAdditionalNamespace(qualifiedNameTable
				.getElementsNSPrefix(ELEMENT_SIGNATURE),
				namespaceForSignatureElem);
    //verifyClient.setTrustProfileID("MOAIDBuergerkartePersonenbindung");
		VerifyResult result = verifyClient.sendVerifyRequest();
		return result;
	}

	public PublicKey[] getPublicKeys() throws Exception {

		List pubKeys = new ArrayList();
		ElementNameTranslationTable qualifiedNameTable = new ElementNameTranslationTable(
				this.idLinkDocument_);

		// Try to get RSA-Keys
		String qnameExistingRSAParams = qualifiedNameTable
				.getElementsQualifiedName(ELEMENT_RSAKEYVALUE);

		if (qnameExistingRSAParams != null) {

			NodeList RSAnodelist = this.idLinkDocument_
					.getElementsByTagName(qnameExistingRSAParams);

			Element rsaElem;
			for (int idx = 0; idx < RSAnodelist.getLength(); idx++) {
				rsaElem = (Element) RSAnodelist.item(idx);
				String modulus = rsaElem.getElementsByTagName(
						qualifiedNameTable
								.getElementsQualifiedName(ELEMENT_MODULUS))
						.item(0).getFirstChild().getNodeValue();

				String exponent = rsaElem.getElementsByTagName(
						qualifiedNameTable
								.getElementsQualifiedName(ELEMENT_EXPONENT))
						.item(0).getFirstChild().getNodeValue();

				RSAPublicKey resPub = new iaik.security.rsa.RSAPublicKey(
						new BigInteger(1, decode(modulus, true)),
						new BigInteger(1, decode(exponent, true)));
				pubKeys.add(resPub);
			}
		}

		// Try to get ECDSA-Keys
		String qnameExistingECDSAParams = qualifiedNameTable
				.getElementsQualifiedName(ELEMENT_ECDSAKEYVALUE);

		if (qnameExistingECDSAParams != null) {
			NodeList nodelistECDSA = this.idLinkDocument_
					.getElementsByTagName(qnameExistingECDSAParams);

			Element ecdsaElem;
			PublicKey ecPubKey = null;
			for (int idx = 0; idx < nodelistECDSA.getLength(); idx++) {
				try {
					ecdsaElem = (Element) nodelistECDSA.item(idx);
					ecPubKey = ECDSAKeyValueConverter
							.element2ECDSAPublicKey(ecdsaElem);
					pubKeys.add(ecPubKey);
				} catch (Exception e) {
					throw new ECDSAConverterException(
							"Could not convert ECDSA-key.");
				}
			}
		}

		PublicKey[] result = new PublicKey[pubKeys.size()];
		pubKeys.toArray(result);
		return result;
	}

	/**
	 * Read the bytes encoded in a Base64 encoded <code>String</code>.
	 * 
	 * @param base64String
	 *            The <code>String</code> containing the Base64 encoded bytes.
	 * @param ignoreInvalidChars
	 *            Whether to ignore invalid Base64 characters.
	 * @return byte[] The raw bytes contained in the <code>base64String</code>.
	 * @throws IOException
	 *             Failed to read the Base64 data.
	 */
	private byte[] decode(String base64String, boolean ignoreInvalidChars)
			throws IOException {

		Base64InputStream in = new Base64InputStream(new ByteArrayInputStream(
				base64String.getBytes("UTF-8")), ignoreInvalidChars);
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		byte[] bytes = new byte[256];
		int bytesRead;

		while ((bytesRead = in.read(bytes)) > 0) {
			out.write(bytes, 0, bytesRead);
		}

		return out.toByteArray();
	}
  public String getIssueInstant() {
    return issueInstant;
  }
  public void setIssueInstant(String issueInstant) {
    this.issueInstant = issueInstant;
  }
}