//Copyright (C) 2004 A-SIT
//http://www.a-sit.at
//
//All rights reserved.
//
//This source is provided for inspection purposes and recompilation only,
//unless specified differently in a contract with ASIT. This source has to
//be kept in strict confidence and must not be disclosed to any third party
//under any circumstances. Redistribution in source and binary forms, with
//or without modification, are <not> permitted in any case!
//
//THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
//ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
//ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
//FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
//DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
//OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
//HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
//LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
//OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
//SUCH DAMAGE.

package asit.moa;

/**
 * This interface specifies all the constants needed for the MOA applications.
 * 
 * @author <a href="mailto:arne.tauber@iaik.tugraz.at">Arne Tauber</a>
 */
public interface MoaConstants {

  /*
   * Namespaces and namespace prefixes for security layer 1.1.0 and 1.0.0
   */  
	String MOA_NS = "http://reference.e-government.gv.at/namespace/moa/20020822#";
  String MANDATE_NS = "http://reference.e-government.gv.at/namespace/mandates/20040701#";
  String MANDATE_PROFILE_NS = "http://reference.e-government.gv.at/namespace/mandateprofile/20041105#";
  String MOA_PREFIX = "moa:";
  String MOA_POSTFIX = ":moa";
  String MANDATE_PREFIX = "md:";
  String MANDATE_POSTFIX = ":md";
  
  
  String DSIG_NS = "http://www.w3.org/2000/09/xmldsig#";
  String DSIG_PREFIX = "dsig:";
  String DSIG_POSTFIX = ":dsig";
  
  // MOA-VV constants
  String VERIFY_MANDATE_REQUEST = "VerifyMandateRequest";
  String APPLICATION_DOCUMENT = "ApplicationDocument";
  String REPRESENTATIVE = "Representative";
  String MANDATOR = "Mandator";
  String APPLICATION = "Application";
  String SUBMITTER = "Submitter";
  String REPRESENTED = "Represented";
  String MANDATES = "Mandates";
  String MANDATE = "Mandate";
  String MANDATE_CONSTRAINTS = "MandateConstraintsValues";
  String APPLICATION_DATE = "ApplicationDate";
  String TRANSACTION_VALUE = "TransactionValue";
  String AMOUNT = "Amount";
  String CURRENCY = "Currency";
  String ANYCONSTRAINTS = "AnyConstraints";
  String MANDATE_CHECK_PROFILE_REFERENCE = "MandateCheckProfileReference";
  String PROFILE_NAME = "ProfileName";
  String PROFILE_VERSION = "ProfileVersion";
  String MANDATE_CHECK_PROFILE = "MandateCheckProfile";
  
  // Create request constants
  String CREATE_XML_SIGNATURE_REQUEST = "CreateXMLSignatureRequest";
  String SINGLE_SIGNATURE_INFO = "SingleSignatureInfo";
  String DATA_OBJECT_INFO = "DataObjectInfo";
  String STRUCTURE = "Structure";
  String DETACHED = "detached";
  String ENVELOPING = "enveloping";
  String SECURITY_LAYER_CONFORMITY = "SecurityLayerConformity";
  String DATA_OBJECT = "DataObject";
  String CHILD_OF_MANIFEST = "ChildOfManifest";
  String CREATE_TRANSFORMS_INFO_PROFILE = "CreateTransformsInfoProfile";
  String CREATE_TRANSFORMS_INFO_PROFILE_ID = "CreateTransformsInfoProfileID";
  String CREATE_TRANSFORMS_INFO = "CreateTransformsInfo";
  String TRANSFORMS = "Transforms";
  String XML_CONTENT = "XMLContent";
  String BASE64_CONTENT = "Base64Content";
  String FINAL_DATA_METAINFO = "FinalDataMetaInfo";
  String MIME_TYPE = "MimeType";
  String DESCRIPTION = "Description";
  String KEY_IDENTIFIER = "KeyIdentifier";
  String CREATE_SIGNATURE_INFO = "CreateSignatureInfo";
  String CREATE_SIGNATURE_ENVIRONMENT = "CreateSignatureEnvironment";
  String CREATE_SIGNATURE_ENVIRONMENT_PROFILE = "CreateSignatureEnvironmentProfile";
  String CREATE_SIGNATURE_LOCATION = "CreateSignatureLocation";
  String LOC_REF_CONTENT = "LocRefContent";
  
  // verify request
  String VERIFY_XML_SIGNATURE_REQUEST = "VerifyXMLSignatureRequest";
  String DATE_TIME = "DateTime";
  String VERIFY_SIGNATURE_INFO = "VerifySignatureInfo";
  String VERIFY_SIGNATURE_ENVIRONMENT = "VerifySignatureEnvironment";
  String VERIFY_SIGNATURE_LOCATION = "VerifySignatureLocation";
  String TRUST_PROFILE_ID = "TrustProfileID";
  String SUPPLEMENT_PROFILE = "SupplementProfile";
  String CONTENT = "Content";
  String REFERENCE = "Reference";
  String HASH_INPUT_DATA = "ReturnHashInputData";
  
  // moa-id
  String SAMLP_NS_PREFIX = "samlp";
  String SAMLP_NS = "urn:oasis:names:tc:SAML:1.0:protocol";
  
  String REQUEST = "Request";
  String REQUESTID = "RequestID";
  String MAJORVERSION = "MajorVersion";
  String MINORVERSION = "MinorVersion";
  String ISSUEINSTANT = "IssueInstant";
  String ASSERTIONARTIFACT = "AssertionArtifact";
  
  // moa-zs
  String MOA_ZS_PDATA_NS_PREFIX = "p";
  String MOA_ZS_PDATA_NS = "http://reference.e-government.gv.at/namespace/persondata/20020228#";
  
  String MOA_ZS_NS_PREFIX = "mzs";
  String MOA_ZS_NS = "http://reference.e-government.gv.at/namespace/moazs10/app2mzs#";

  
  String IDENTIFICATION = "Identification";
  String VALUE = "Value";
  String TYPE = "Type";
  String NAME = "Name";
  String GIVENNAME = "GivenName";
  String FAMILYNAME = "FamilyName";
  String DATEOFBIRTH = "DateOfBirth";
  String FULLNAME = "FullName";
  String ORGANIZATION = "Organization";
  
  String ADDRESS = "Address";
  String MUNICIPALITY = "Municipality";
  String DELIVERYADDRESS = "DeliveryAddress";
  String COUNTRYCODE = "CountryCode";
  String POSTALCODE = "PostalCode";
  String STREETNAME = "StreetName";
  String BUILDINGNUMBER = "BuildingNumber";
  String UNIT = "Unit";
  String DOORNUMBER = "DoorNumber";
  
  String NUMBER = "Number";
  String FORMATTEDNUMBER = "FormattedNumber";
  String METADATA = "MetaData";
  String APPDELIVERYID = "AppDeliveryID";
  String DELIVERYQUALITY = "DeliveryQuality";
  String REQUIRESENCRYPTION = "RequiresEncryption";
  String PRIVATEDELIVERY = "PrivateDelivery";
  String XMLDOCUMENT = "XMLDocument";
  String XMLCONTENT = "XMLContent";
  String XMLPROFILEID = "XMLProfileID";
  String FILENAME = "FileName";
  String MIMETYPE = "MIMEType";
  String RESULTING_MIMETYPE = "ResultingMIMEType";
  String SIGNATURE_XPATH = "SignatureXPath";
  String SIGNATURE_STYLESHEET = "SignatureStylesheet";
  String PREVIEW_STYLESHEET = "PreviewStylesheet";
  String PAYLOAD = "Payload";
  String BINARY_DOCUMENT = "BinaryDocument";
  String BASE64CONTENT = "Base64Content";
  String DOCUMENT_REFERENCE = "DocumentReference";
  String URL = "URL";
  String MD5CHECKSUM = "MD5Checksum";
  String DELIVERYREQUEST = "DeliveryRequest";
  String SENDER = "Sender";
  String PROFILEID = "ProfileID";
  String SIGKEYID = "SignatureKeyID";
  String RECEIVER = "Receiver";
  String SERVER = "Server";
  String ZUSEURLID = "ZUSEUrlID";
  String X509 = "X509";
   
  
  
}
