/*
 * Created on 26.05.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package asit.moa.client.deliver;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URLEncoder;
import asit.common.Utils;
import asit.moa.client.exception.DeliveryException;


/**
 * @author troessler
 *
 * Used to wrapp the existing ZustellBot-Software
 */
public class DeliveryRobotWrapper {

	private String defaultDocsToSendDirectory_;
	private String sendersXMLFile_;
	private String webServiceURL_;
	private String notificationEmail_;
	private String ldapURL_;

	private String executeableFile_;
	private String executeableFilePath_;

	private int internalDeliveryNumberCounter_ = 0;

	public DeliveryRobotWrapper(
		String defaultsenddir,
		String senderxmlfile,
		String webserviceurl,
		String notificationmail,
		String ldapurl,
		File executeablefile) {

		this.defaultDocsToSendDirectory_ = defaultsenddir;
		this.sendersXMLFile_ = senderxmlfile;
		this.webServiceURL_ = webserviceurl;
		this.notificationEmail_ = notificationmail;
		this.ldapURL_ = ldapurl;

		this.executeableFilePath_ = executeablefile.getParent();
		this.executeableFile_ = executeablefile.getPath();

	}

	public String deliverDocuments() throws DeliveryException {

		String returnstring = "";

		String[] params = new String[11];
		params[0] = this.executeableFile_;
		params[1] = "--directory";
		params[2] = "\"" + this.defaultDocsToSendDirectory_ + "\"";
		params[3] = "--sender";
		params[4] = "\"" + this.sendersXMLFile_ + "\"";
		params[5] = "--webservice-url";
		params[6] = this.webServiceURL_;
		params[7] = "--notification-email";
		params[8] = this.notificationEmail_;
		params[9] = "--ldap";
		params[10] = this.ldapURL_;

		String command =
				params[0]
				+ " "
				+ params[1]
				+ " "
				+ params[2]
				+ " "
				+ params[3]
				+ " "
				+ params[4]
				+ " "
				+ params[5]
				+ " "
				+ params[6]
				+ " "
				+ params[7]
				+ " "
				+ params[8]
				+ " "
				+ params[9]
				+ " "
				+ params[10];
		//System.out.println(command);

		// start a new process since the delivery-programm ends with System.exit
		Process proc;
		try {

			proc = Runtime.getRuntime().exec(command);

      return returnstring;
		} catch (IOException e) {
			throw new DeliveryException("Delivery: Could not add document!");
		}

	}

	public void addDocToSend(
		InputStream file,
		String receiversurname,
		String receivergivenname,
		String receiveremail,
		String deliverynumber,
		String fileextension)
		throws DeliveryException {
		try {
			String filename =
				Utils.replaceWord(
					URLEncoder.encode(receiversurname, "ISO-8859-1"),
					"+",
					"%20")
					+ "+"
					+ Utils.replaceWord(
						URLEncoder.encode(receivergivenname, "ISO-8859-1"),
						"+",
						"%20")
					+ "+"
					+ receiveremail
					+ "+++"
					+ "N+_"
					+ deliverynumber
					+ "."
					+ fileextension;
			//System.out.println(filename);
			FileOutputStream fous =
				new FileOutputStream(
					new File(this.defaultDocsToSendDirectory_ + "/" + filename),
					false);
			int ch;
			String readchars = "";
			while ((ch = file.read()) != -1) {
				readchars += (char) ch;
			}
			fous.write(readchars.getBytes("UTF8"));
			fous.flush();
			fous.close();

		} catch (Exception e) {
			throw new DeliveryException("Delivery: Could not add document!");
		}

	}

	public void addDocToSend(
		String filecontent,
		String receiversurname,
		String receivergivenname,
		String receiveremail,
		String deliverynumber,
		String fileextension)
		throws DeliveryException {
		try {
			String filename =
				Utils.replaceWord(
					URLEncoder.encode(receiversurname, "ISO-8859-1"),
					"+",
					"%20")
					+ "+"
					+ Utils.replaceWord(
						URLEncoder.encode(receivergivenname, "ISO-8859-1"),
						"+",
						"%20")
					+ "+"
					+ receiveremail
					+ "+++"
					+ "N+_"
					+ deliverynumber
					+ "."
					+ fileextension;
			//System.out.println(filename);
			FileOutputStream fous =
				new FileOutputStream(
					new File(this.defaultDocsToSendDirectory_ + "/" + filename),
					false);

			fous.write(filecontent.getBytes("UTF8"));
			fous.flush();
			fous.close();

		} catch (Exception e) {
			throw new DeliveryException("Delivery: Could not add document!");
		}

	}

	/**
	 * 
	 * @author troessler
	 * 
	 * @return
	 */
	public String generateDeliverNumber() {
		String toreturn = String.valueOf(this.internalDeliveryNumberCounter_);
		this.internalDeliveryNumberCounter_++;
		return toreturn;
	}

	/**
		 * 
		 * @author troessler
		 * 
		 * @return
		 */
	public void setDeliverNumber(int newvalue) {
		this.internalDeliveryNumberCounter_ = newvalue;
	}

}
