/*
 * Created on 26.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.moa.client.deliver.address;

import javax.xml.transform.TransformerException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.validator.ValidatorForm;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import asit.bescheid.BescheidElement;
import asit.bescheid.NotificationUtils;


public abstract class AbstractPerson extends ValidatorForm implements BescheidElement {
  
  protected Identification[] identifications_ = null;
  
  protected String firmenBuchNummer_ = null;
  protected String matrikelNummer_ = null;
  protected String sozialVersicherungsNummer_ = null;
  protected String stammzahl_ = null;
  protected String steuernummer_ = null;
  protected String vereinsnummer_ = null;
  protected String zmrZahl_ = null;
  
  protected String personName_ = "AbstractPerson";
  protected Element root_ = null;
  
  
  protected static Log log_ = LogFactory.getLog(AbstractPerson.class.getName()); 
  
  protected boolean useGerman_ = true;
  
  public void setElementName(String name) {
    personName_ = name;
  }
  
  public void setUseGerman(boolean useGerman) {
    useGerman_ = useGerman;
  }
  
  /*
   * @see asit.bescheid.BescheidElement#toElement()
   */
  public Element toElement(Document doc) {
    
    // add prefix self
    root_ = doc.createElementNS(PersonConstants.PERSON_NS, personName_);

    if (identifications_ != null) {
      for (int i=0; i<identifications_.length; i++) {
        Element id = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":Identification");
        root_.appendChild(id);
        Element value = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":Value");
        value.appendChild(doc.createTextNode(identifications_[i].getPValue()));
        id.appendChild(value);
        
        Element type = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":Type");
        type.appendChild(doc.createTextNode(identifications_[i].getPType()));
        id.appendChild(type);
      }
    }
    
    if (useGerman_) {
      // add firmenbuchnummer
      if (!NotificationUtils.isEmpty(firmenBuchNummer_)) {
        addStringElement(root_, doc, PersonConstants.FIRMENBUCHNUMMER, firmenBuchNummer_);
      }
  
      // add matrikelnummer
      if (!NotificationUtils.isEmpty(matrikelNummer_)) {
        addStringElement(root_, doc, PersonConstants.MATRIKELNUMMER, matrikelNummer_);
      }
  
      // add sozialversicherungsnummer
      if (!NotificationUtils.isEmpty(sozialVersicherungsNummer_ )) {
        addStringElement(root_, doc, PersonConstants.SOZIALVERSICHERUNGSNUMMER, sozialVersicherungsNummer_);
      }
  
      // add stammzahl
      if (!NotificationUtils.isEmpty(stammzahl_)) {
        addStringElement(root_, doc, PersonConstants.STAMMZAHL, stammzahl_);
      }
  
      // add steuernummer
      if (!NotificationUtils.isEmpty(steuernummer_)) {
        addStringElement(root_, doc, PersonConstants.STEUERNUMMER, steuernummer_);
      }
  
      // add vereinsnummer
      if (!NotificationUtils.isEmpty(vereinsnummer_)) {
        addStringElement(root_, doc, PersonConstants.VEREINSNUMMER, vereinsnummer_);
      }
  
      // add zmrzahl
      if (!NotificationUtils.isEmpty(zmrZahl_)) {
        addStringElement(root_, doc, PersonConstants.ZMRZAHL, zmrZahl_);
      }
    }
    return root_;
  }
  
 
  
  public static void addStringElement(Element parent, Document doc, String element, String content) {
    Element e = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":" + element);
    e.appendChild(doc.createTextNode(content));
    parent.appendChild(e);
  }
  
  /*
   * @see asit.bescheid.BescheidElement#update(org.w3c.dom.Element)
   */
  public void update(Element element) {
    log_.debug("Updating person:");
    try {
      Node fbn = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.FIRMENBUCHNUMMER + "/text()");
      if (fbn != null) {
        log_.debug("Found Firmenbuchnummer node: " + fbn.getNodeValue());
        firmenBuchNummer_ = fbn.getNodeValue();
      }

      Node mat = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.MATRIKELNUMMER + "/text()");
      if (mat != null) {
        log_.debug("Found Matrikelnummer node: " + mat.getNodeValue());
        matrikelNummer_ = mat.getNodeValue();
      }

      Node soz = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.SOZIALVERSICHERUNGSNUMMER + "/text()");
      if (soz != null) {
        log_.debug("Found Sozialversicherungsnummer node: " + soz.getNodeValue());
        sozialVersicherungsNummer_ = soz.getNodeValue();
      }

      Node stamm = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.STAMMZAHL + "/text()");
      if (stamm != null) {
        log_.debug("Found Stammzahl node: " + stamm.getNodeValue());
        stammzahl_ = stamm.getNodeValue();
      }

      Node steuernummer = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.STEUERNUMMER + "/text()");
      if (steuernummer != null) {
        log_.debug("Found Steuernummer node: " + steuernummer.getNodeValue());
        steuernummer_ = steuernummer.getNodeValue();
      }

      Node vereinsnummer = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.VEREINSNUMMER + "/text()");
      if (vereinsnummer != null) {
        log_.debug("Found Vereinsnummer node: " + vereinsnummer.getNodeValue());
        vereinsnummer_ = vereinsnummer.getNodeValue();
      }

      Node zmrzahl = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.ZMRZAHL + "/text()");
      if (zmrzahl != null) {
        log_.debug("Found ZMRZahl node: " + zmrzahl.getNodeValue());
        zmrZahl_ = zmrzahl.getNodeValue();
      }

      
    } catch(TransformerException e) {
      log_.debug("Error while evaluating XPath expression: " + e.getMessage());
    }
  }
  public String getPSozialversicherungsnummer() {
    return sozialVersicherungsNummer_;
  }
  /**
   * @param sozialVersicherungsNummer_ The sozialVersicherungsNummer_ to set.
   */
  public void setPSozialversicherungsnummer(String sozialVersicherungsNummer) {
    this.sozialVersicherungsNummer_ = sozialVersicherungsNummer;
  }
  /**
   * @return Returns the stammzahl_.
   */
  public String getPStammzahl() {
    return stammzahl_;
  }
  /**
   * @param stammzahl_ The stammzahl_ to set.
   */
  public void setPStammzahl(String stammzahl) {
    this.stammzahl_ = stammzahl;
  }
  /**
   * @return Returns the steuernummer_.
   */
  public String getPSteuernummer() {
    return steuernummer_;
  }
  /**
   * @param steuernummer_ The steuernummer_ to set.
   */
  public void setPSteuernummer(String steuernummer) {
    this.steuernummer_ = steuernummer;
  }
  /**
   * @return Returns the vereinsnummer_.
   */
  public String getPVereinsnummer() {
    return vereinsnummer_;
  }
  /**
   * @param vereinsnummer_ The vereinsnummer_ to set.
   */
  public void setPVereinsnummer(String vereinsnummer) {
    this.vereinsnummer_ = vereinsnummer;
  }
  /**
   * @return Returns the zmrZahl_.
   */
  public String getPZMRZahl() {
    return zmrZahl_;
  }
  /**
   * @param zmrZahl_ The zmrZahl_ to set.
   */
  public void setPZMRZahl(String zmrZahl) {
    this.zmrZahl_ = zmrZahl;
  }
  /**
   * @return Returns the firmenBuchNummer_.
   */
  public String getPFirmenbuchnummer() {
    return firmenBuchNummer_;
  }
  /**
   * @param firmenBuchNummer_ The firmenBuchNummer_ to set.
   */
  public void setPFirmenbuchnummer(String firmenBuchNummer_) {
    this.firmenBuchNummer_ = firmenBuchNummer_;
  }
  /**
   * @return Returns the matrikelNummer_.
   */
  public String getPMatrikelnummer() {
    return matrikelNummer_;
  }
  /**
   * @param matrikelNummer_ The matrikelNummer_ to set.
   */
  public void setPMatrikelnummer(String matrikelNummer) {
    this.matrikelNummer_ = matrikelNummer;
  }
  
  public Identification[] getIdentifications() {
    return identifications_;
  }
  public void setIdentifications(Identification[] identifications_) {
    this.identifications_ = identifications_;
  }
}
