/*
 * Created on 27.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.moa.client.deliver.address;

import java.io.Serializable;
import javax.xml.transform.TransformerException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import asit.bescheid.BescheidConstants;
import asit.bescheid.BescheidElement;
import asit.bescheid.EckData;
import asit.bescheid.NotificationUtils;

// FFIXXXXXXXXXXXXXXXXX ALOT OF THINGS

/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Adressat implements BescheidElement, EckData, Serializable {
  
  protected Identification[] identifcations_ = null;
  
  protected AbstractPerson person_ = null;
  protected KompNichtNatuerlichePerson corporateBody_ = null;
  
  protected KompPostalAddress address_ = null;
  
  protected String internetAdress_ = null;
  protected String telefonnummer_ = null;
  
  protected static Log log_ = LogFactory.getLog(Adressat.class.getName()); 
  
  protected String elementName_ = BescheidConstants.BESCHEID_NS_PREFIX + ":Adressat";
  
  protected boolean useGerman_ = true;

  protected String feldName_ = null;
  
  public Adressat() {}
  
  public Adressat(boolean useGerman) {
    useGerman_ = useGerman;
  }
  
  public boolean getUseGerman() {
    return useGerman_;
  }
  
  public void setUseGerman(boolean useGerman) {
    useGerman_ = useGerman;
    if (person_ != null) {
      person_.setUseGerman(useGerman);
    }
    if (address_ != null) {
      address_.setUseGerman(useGerman);
    }
  }
  
  /* (non-Javadoc)
   * @see asit.bescheid.EckData#getEFeldName()
   */
  public String getEFeldName() {
    return feldName_;
  }
  /* (non-Javadoc)
   * @see asit.bescheid.EckData#setEFeldName(java.lang.String)
   */
  public void setEFeldName(String feldName) {
    feldName_ = feldName;
  }
  
  /* (non-Javadoc)
   * @see asit.bescheid.EckData#getEDescription()
   */
  public String getEDescription() {
    return toString();
  }
  
  public void setEDescription(String string) {
  }
  
  /* (non-Javadoc)
   * @see asit.bescheid.EckData#getType()
   */
  public String getType() {
    return EckData.KOMPPERSON;
  }
  
  public void setType(String string) {}
  
  public void setElementName(String name) {
    elementName_ = name;
  }
  
  public String getElementName() {
    return elementName_;
  }
  
  public KompPostalAddress getPostAddress() {
    return address_;
  }
   
  public void setPostAddress(KompPostalAddress address) {
    address_ = address;
  } 
  
  public void setPerson(AbstractPerson person) {
	    log_.debug("\n\n\nUPDATING PERSON (removing CorporateBody)\n\n\n");
	    this.person_ = person;
	    this.corporateBody_ = null;
	  }
	  
  public void setCorporateBody(KompNichtNatuerlichePerson corporateBody) {
	    log_.debug("\n\n\nUPDATING CORPORATE BODY (removing Person)\n\n\n");
	    this.corporateBody_ = corporateBody;
	    this.person_ = null;
	  }
  
  public KompNichtNatuerlichePerson getCorporateBody() {
    return this.corporateBody_;
  }
  
  public AbstractPerson getPerson() {
    return person_;
  }

  /*
   * @see asit.bescheid.BescheidElement#toElement(org.w3c.dom.Document)
   */
  public Element toElement(Document doc) {
    //elementName_ = useGerman_ ? elementName_ : BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.RECEIVER;
    
    Element adressat = doc.createElementNS(BescheidConstants.BESCHEID_NS, elementName_);
    
    // add here all identifiers

    // add person element
    if (person_ != null) {
      person_.setUseGerman(useGerman_);
      adressat.appendChild(person_.toElement(doc));
    } else if (corporateBody_ != null) {
   	 corporateBody_.setUseGerman(useGerman_);
   	 adressat.appendChild(corporateBody_.toElement(doc));
    }
    
    // add address element
    if (address_ != null) {
      address_.setUseGerman(useGerman_);
      adressat.appendChild(address_.toElement(doc));
    }
    
    // internetadresse
    if (!NotificationUtils.isEmpty(internetAdress_)) {
      
      String inet = useGerman_ ? PersonConstants.INTERNETADRESSE : PersonConstants.INTERNETADDRESS;
      Element internetAdresse = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":" + inet);
      adressat.appendChild(internetAdresse);
      String adressElement = useGerman_ ? PersonConstants.ADRESSE : PersonConstants.ADRESS;
      AbstractPerson.addStringElement(internetAdresse, doc, adressElement, internetAdress_);
    }
    
    // telefonnummer
    if (!NotificationUtils.isEmpty(telefonnummer_)) {
      String tel = useGerman_ ? PersonConstants.TELEFONADRESSE : PersonConstants.TELEPHONEADDRESS;
      Element telefonadresse = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":" + tel);
      adressat.appendChild(telefonadresse);

      String number = useGerman_ ? PersonConstants.NUMMER : PersonConstants.NUMBER;
      Element nummer = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":" + number);
      telefonadresse.appendChild(nummer);
      
      String formatNumberElement = useGerman_ ? PersonConstants.FORMATIERTENUMMER : PersonConstants.FORMATTEDNUMBER;
      AbstractPerson.addStringElement(nummer, doc, formatNumberElement, telefonnummer_);
    }
    
    return adressat;
  }

  /*
   * @see asit.bescheid.BescheidElement#update(org.w3c.dom.Element)
   */
  public void update(Element element) {
    log_.debug("Updating adressat: " + element.getTagName());
    try {
      
      // retrieve feldname
      Node feldname = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FELDNAME + "/text()");
      if (feldname != null) {
        log_.debug("Found Feldname adresse node: " + feldname.getNodeValue());
        feldName_ = feldname.getNodeValue();
      }
      
      // kompakte natuerliche person
      Node knp = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.KOMPAKTENATUERLICHEPERSON);
      if (knp != null) {
        log_.debug("Found kompakte natuerliche person");
        
        person_ = new KompNatuerlichePerson();
        person_.update((Element)knp);
        
      }
      
      //  kompakte nichtnatuerliche person
      Node knnp = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.KOMPAKTENICHTNATUERLICHEPERSON);
      if (knnp != null) {
        log_.debug("Found kompakte nicht natuerliche person");
        
        person_ = new KompNichtNatuerlichePerson();
        person_.update((Element)knnp);
        
      }
      
      //  kompakte postadresse
      Node postadr = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.KOMPAKTEPOSTADRESSE);
      if (postadr != null) {
        log_.debug("Found kompakte postadresse");
        
        address_ = new KompPostalAddress();
        address_.update((Element)postadr);
        
      }
      
      // retrieve internetaddress
      Node iaddress = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.INTERNETADRESSE + "/" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.ADRESSE + "/text()");
      if (iaddress != null) {
        log_.debug("Found Internet adresse node: " + iaddress.getNodeValue());
        internetAdress_ = iaddress.getNodeValue();
      }
      
      // retrieve telefonnummer
      Node tel = XPathAPI.selectSingleNode(element, "descendant-or-self::" +
          PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.TELEFONADRESSE +
          "/" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.NUMMER +
          "/" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.FORMATIERTENUMMER + "/text()");
      if (tel != null) {
        log_.debug("Found telefonnummer node: " + tel.getNodeValue());
        telefonnummer_ = tel.getNodeValue();
      }

      
    } catch(TransformerException e) {
      log_.debug("Error while evaluating XPath expression: " + e.getMessage());
    }
    
  }
  
  public String toString() {
    return getAPerson() + " - " + getAAddress();
  }
    
  public void setAPerson(String value) {}
  
  public String getAPerson() {
    if (person_ != null) {
      return person_.toString();
    } else {
      return "[ Keine Personenangaben ]";
    }
  }
  
  public void setAAddress(String value) {}
    
  
  public String getAAddress() {
    if (address_ != null) {
      return address_.toString();
    } else {
      return "[ Keine Adressangaben ]";
    }
  }
  
  /**
   * @return Returns the internetAdress_.
   */
  public String getAInternetAdress() {
    return internetAdress_;
  }
  /**
   * @param internetAdress_ The internetAdress_ to set.
   */
  public void setAInternetAdress(String internetAdress) {
    this.internetAdress_ = internetAdress;
  }
  /**
   * @return Returns the telefonnummer_.
   */
  public String getATelefonnummer() {
    return telefonnummer_;
  }
  /**
   * @param telefonnummer_ The telefonnummer_ to set.
   */
  public void setATelefonnummer(String telefonnummer) {
    this.telefonnummer_ = telefonnummer;
  }
}
