/*
 * Created on 26.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.moa.client.deliver.address;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import javax.xml.transform.TransformerException;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import asit.bescheid.Bescheid;
import asit.bescheid.NotificationUtils;



/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class KompNatuerlichePerson extends AbstractPerson {
  

  protected String vorname_ = null;
  protected String familienname_ = null;
  protected String familienstand_ = null;
  protected String geschlecht_ = null;
  protected String geburtsdatum_ = null;
  protected String geburtsort_ = null;
  protected String staatsangehoerigkeit_ = null;
 
  
  public final static String KEIN = "- kein -";
  
  // possible familienstaende
  protected Set familienStaende_ = new HashSet(Arrays.asList(new String[] { "ledig",
                                                                            "verheiratet",
                                                                            "verwitwet",
                                                                            "geschieden" }));

  protected Set geschlechter_ = new HashSet(Arrays.asList(new String[] { "M",
                                                                         "W" }));

  
  
  // 1 affix erlaubt
  protected String affix_ = null;
  protected String affixTyp_ = "akademischerGrad";
  protected String affixPosition_ = "prefix";
  
  public KompNatuerlichePerson() {
    personName_ = "p:KompakteNatuerlichePerson";
    useGerman_ = true;
  }

  public void setUseGerman(boolean useGerman) {
    super.setUseGerman(useGerman);
    if (useGerman) {
      personName_ = "p:KompakteNatuerlichePerson";
    } else {
      personName_ = "p:PhysicalPerson";
    }
  }    
  
  public KompNatuerlichePerson(boolean useGerman) {
    setUseGerman(useGerman);
  }

  
  public Collection getPFamilienStaende() {
    return familienStaende_;
  }
  
  public Collection getPGeschlechter() {
    return geschlechter_;
  }
  
  public Collection getPStaaten() {
   log_.debug("Get Staaten");
   String countriesFile = super.getServlet().getServletContext().getRealPath("/WEB-INF/res/countries.txt");
   log_.debug("File: " + countriesFile);
   Collection codes = NotificationUtils.getLaenderCodes(countriesFile);
   Collection names = NotificationUtils.getLaenderNamen(countriesFile);
   
   ArrayList ret = new ArrayList();
   
   Iterator it = codes.iterator();
   Iterator it2 = names.iterator();
   log_.debug("Iteriere...");
   while (it.hasNext()) {
     ret.add(it.next() + " - " + it2.next());
   }
   return ret;
  }
  
  public static String getCountryCode(String country) {
    if (NotificationUtils.isEmpty(country) || KEIN.equals(country)) {
      return null;
    } else {
      int index = country.indexOf("-");
      return country.substring(0, index-1);
    }
  }

  public static String getCountryName(String country) {
    if (NotificationUtils.isEmpty(country) || KEIN.equals(country)) {
      return null;
    } else {
      int index = country.indexOf("-");
      return country.substring(index+2);
    }
  }

  
  // get a compact representation of a natural person
  public String toString() {
    if (NotificationUtils.isEmpty(vorname_) &&
        NotificationUtils.isEmpty(familienname_)) {
      return "[ Keine Angaben ]";
    }
    String ret = "";
    if (!NotificationUtils.isEmpty(vorname_)) {
      ret += vorname_;
    }
    if (!NotificationUtils.isEmpty(familienname_)) {
      if (!NotificationUtils.isEmpty(vorname_)) {
        ret += " ";
      }
      ret += familienname_;
    }
    if (!NotificationUtils.isEmpty(geburtsdatum_)) {
      if (!NotificationUtils.isEmpty(vorname_) ||
          !NotificationUtils.isEmpty(familienname_)) {
        ret += ", ";
      }
      ret += geburtsdatum_;
    }
    return ret;
  }
  
  /*
   * @see asit.bescheid.BescheidElement#toElement(org.w3c.dom.Document)
   */
  public Element toElement(Document doc) {
    super.toElement(doc);
    
    String nm = useGerman_ ? PersonConstants.KOMPAKTERPERSONENNAME : PersonConstants.NAME;
    
    if (vorname_ != null &&
        familienname_ != null) {
      Element kpname = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":" + nm);
      root_.appendChild(kpname);
      
      // vorname
      if (vorname_ != null) {
        String str = useGerman_ ? PersonConstants.VORNAME : PersonConstants.GIVENNAME;
        addStringElement(kpname, doc, str, vorname_);
      }
  
      // familienname
      if (familienname_ != null) {
        String str = useGerman_ ? PersonConstants.FAMILIENNAME : PersonConstants.FAMILYNAME;
        addStringElement(kpname, doc, str, familienname_);
      }
      
      //  affix - gibt es nur im deutschen
      if (!NotificationUtils.isEmpty(affix_) && useGerman_) {
        Element affix = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.AFFIX);
        kpname.appendChild(affix);
        affix.appendChild(doc.createTextNode(affix_));
        if (affixTyp_ != null) {
          affix.setAttribute("typ", affixTyp_);
        }
        if (affixPosition_ != null) {
          affix.setAttribute("position", affixPosition_);
        }
      }
    }
    

    // familienstand - gibt es nur im deutschen
    if (!NotificationUtils.isEmpty(familienstand_) && !KEIN.equals(familienstand_) && useGerman_) {
      addStringElement(root_, doc, PersonConstants.FAMILIENSTAND, familienstand_);
    }

    // geschlecht - gibt es nur im deutschen
    if (!NotificationUtils.isEmpty(geschlecht_ )  && !KEIN.equals(geschlecht_) && useGerman_) {
      addStringElement(root_, doc, PersonConstants.GESCHLECHT, geschlecht_);
    }

    // geburtsdatum 
    if (!NotificationUtils.isEmpty(geburtsdatum_)) {
      String elemname = useGerman_ ? PersonConstants.GEBURTSDATUM: PersonConstants.DATEOFBIRTH;
      Date date = Bescheid.stringToDateNormal(geburtsdatum_);
      addStringElement(root_, doc, elemname, Bescheid.dateToStringXML(date));

    }

    // geburtsort - nur dt
    if (!NotificationUtils.isEmpty(geburtsort_) && useGerman_) {
      addStringElement(root_, doc, PersonConstants.GEBURTSORT, geburtsort_);
    }

    // staatsangehoerigkeit - nur dt
    if (!NotificationUtils.isEmpty(staatsangehoerigkeit_)  && useGerman_) {
      String code = getCountryCode(staatsangehoerigkeit_);
      String name = getCountryName(staatsangehoerigkeit_);
      if (!NotificationUtils.isEmpty(code) && !NotificationUtils.isEmpty(name)) {
        Element staat = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.STAATSANGEHOERIGKEIT);
        root_.appendChild(staat);
        if (!NotificationUtils.isEmpty(code)) {
          addStringElement(staat, doc, PersonConstants.ISOCODE3, code);
        }
        if (!NotificationUtils.isEmpty(name)) {
          addStringElement(staat, doc, PersonConstants.STAATSNAMEDE, name);
        }

      }
    }

    
    return root_;
  }
  
  /* (non-Javadoc)
   * @see asit.bescheid.BescheidElement#update(org.w3c.dom.Element)
   */
  public void update(Element element) {
    super.update(element);
    
    log_.debug("Updating kompakte natuerliche person:");
    try {
      Node vorname = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.VORNAME + "/text()");
      if (vorname != null) {
        log_.debug("Found Vorname node: " + vorname.getNodeValue());
        vorname_ = vorname.getNodeValue();
      }

      Node familienname = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.FAMILIENNAME + "/text()");
      if (familienname != null) {
        log_.debug("Found Familienname node: " + familienname.getNodeValue());
        familienname_ = familienname.getNodeValue();
      }
      
      Node affix = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.AFFIX + "/text()");
      if (affix != null) {
        log_.debug("Found Affix node: " + affix.getNodeValue());
        affix_ = affix.getNodeValue();
        Node affixTyp = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.AFFIX + "/@typ");
        if (affixTyp != null) {
          log_.debug("Found affixtyp: " + affixTyp.getNodeValue());
          affixTyp_ = affixTyp.getNodeValue();
        }
        Node affixPosition = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.AFFIX + "/@position");
        if (affixPosition != null) {
          log_.debug("Found affixposition: " + affixPosition.getNodeValue());
          affixPosition_ = affixPosition.getNodeValue();
        }
      }

      Node familienstand = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.FAMILIENSTAND + "/text()");
      if (familienstand != null) {
        log_.debug("Found Familienstand node: " + familienstand.getNodeValue());
        familienstand_ = familienstand.getNodeValue();
      }

      Node geschlecht = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.GESCHLECHT + "/text()");
      if (geschlecht != null) {
        log_.debug("Found Geschlecht node: " + geschlecht.getNodeValue());
        geschlecht_ = geschlecht.getNodeValue();
      }

      Node geburtsdatum = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.GEBURTSDATUM + "/text()");
      if (geburtsdatum != null) {
        log_.debug("Found Geburtsdatum node: " + geburtsdatum.getNodeValue());
        geburtsdatum_ = geburtsdatum.getNodeValue();
      }

      Node geburtsort = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.GEBURTSORT + "/text()");
      if (geburtsort != null) {
        log_.debug("Found Geburtsort node: " + geburtsort.getNodeValue());
        geburtsort_ = geburtsort.getNodeValue();
      }

      Node staat = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.ISOCODE3 + "/text()");
      if (staat != null) {
        log_.debug("Found Staatsangehoerigkeit node: " + staat.getNodeValue());
        staatsangehoerigkeit_ = staat.getNodeValue();
      }

      
    } catch(TransformerException e) {
      log_.debug("Error while evaluating XPath expression: " + e.getMessage());
    }
    
  }
  /**
   * @return Returns the familienname_.
   */
  public String getPFamilienname() {
    return familienname_;
  }
  /**
   * @param familienname_ The familienname_ to set.
   */
  public void setPFamilienname(String familienname) {
    this.familienname_ = familienname;
  }
  /**
   * @return Returns the familienstand_.
   */
  public String getPFamilienstand() {
    return NotificationUtils.isEmpty(familienstand_) ? KEIN : familienstand_;
  }
  /**
   * @param familienstand_ The familienstand_ to set.
   */
  public void setPFamilienstand(String familienstand) {
    this.familienstand_ = familienstand;
  }
  
  /**
   * @return Returns the geburtsdatum_.
   */
  public String getPGeburtsdatum() {
    return Bescheid.dateToStringNormal(Bescheid.stringToDateNormal(geburtsdatum_));
  }
  /**
   * @param geburtsdatum_ The geburtsdatum_ to set.
   */
  public void setPGeburtsdatum(String geburtsdatum) {
    this.geburtsdatum_ = geburtsdatum;
  }
  /**
   * @return Returns the geburtsort_.
   */
  public String getPGeburtsort() {
    return geburtsort_;
  }
  /**
   * @param geburtsort_ The geburtsort_ to set.
   */
  public void setPGeburtsort(String geburtsort) {
    this.geburtsort_ = geburtsort;
  }
  /**
   * @return Returns the geschlecht_.
   */
  public String getPGeschlecht() {
    return NotificationUtils.isEmpty(geschlecht_) ? KEIN : geschlecht_;
  }
  /**
   * @param geschlecht_ The geschlecht_ to set.
   */
  public void setPGeschlecht(String geschlecht) {
    this.geschlecht_ = geschlecht;
  }
  /**
   * @return Returns the staatsangehoerigkeit_.
   */
  public String getPStaatsangehoerigkeit() {
    return NotificationUtils.isEmpty(staatsangehoerigkeit_) ? KEIN : staatsangehoerigkeit_;
  }
  /**
   * @param staatsangehoerigkeit_ The staatsangehoerigkeit_ to set.
   */
  public void setPStaatsangehoerigkeit(String staatsangehoerigkeit) {
    this.staatsangehoerigkeit_ = staatsangehoerigkeit;
  }
  /**
   * @return Returns the vorname_.
   */
  public String getPVorname() {
    return vorname_;
  }
  /**
   * @param vorname_ The vorname_ to set.
   */
  public void setPVorname(String vorname) {
    this.vorname_ = vorname;
  }
  /**
   * @return Returns the affix_.
   */
  public String getPAffix() {
    return affix_;
  }
  /**
   * @param affix_ The affix_ to set.
   */
  public void setPAffix(String affix) {
    this.affix_ = affix;
  }

  /**
   * @param vzbpk
   */
  public void setVZustellbPK(String vzbpk) {
    
    identifications_ = new Identification[1];
    Identification id = new Identification();
    id.setPType("urn:publicid:gv.at:ecdid+ZU");
    id.setPValue(vzbpk);
    identifications_[0] = id;
    
    
  }

}
