/*
 * Created on 28.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.moa.client.deliver.address;

import java.util.Vector;
import javax.xml.transform.TransformerException;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import asit.bescheid.NotificationUtils;


/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class KompNichtNatuerlichePerson extends AbstractPerson {
  
  protected Vector typ_ = new Vector();
  protected String vollerName_ = "";

  protected String rechtsForm_ = null;
  protected String verwaltungseinheit_ = null;

  public KompNichtNatuerlichePerson() {
    personName_ = "p:KompakteNichtNatuerlichePerson";
    useGerman_ = true;
  }

  public void setUseGerman(boolean useGerman) {
    super.setUseGerman(useGerman);
    if (useGerman) {
      personName_ = "p:KompakteNichtNatuerlichePerson";
    } else {
      personName_ = "p:CorporateBody";
    }
    useGerman_ = useGerman;
  }    
  
  public KompNichtNatuerlichePerson(boolean useGerman) {
    setUseGerman(useGerman);
  }
  
  
  /**
   * @return Returns the rechtsForm_.
   */
  public String getPRechtsform() {
    return rechtsForm_;
  }
  /**
   * @param rechtsForm_ The rechtsForm_ to set.
   */
  public void setPRechtsform(String rechtsForm) {
    this.rechtsForm_ = rechtsForm;
  }

  /**
   * @param typ_ The typ_ to set.
   */
  public void addTyp(String typ) {
    typ_.addElement(typ);
  }
  
  public String[] getPTyp() {
    String[] ret = new String[typ_.size()];
    typ_.copyInto(ret);
    return ret;
  }
  
  /**
   * @return Returns the verwaltungseinheit_.
   */
  public String getPVerwaltungseinheit() {
    return verwaltungseinheit_;
  }
  /**
   * @param verwaltungseinheit_ The verwaltungseinheit_ to set.
   */
  public void setPVerwaltungseinheit(String verwaltungseinheit) {
    this.verwaltungseinheit_ = verwaltungseinheit;
  }
  /**
   * @return Returns the vollerName_.
   */
  public String getPVollerName() {
    return vollerName_;
  }
  /**
   * @param vollerName_ The vollerName_ to set.
   */
  public void setPVollerName(String vollerName) {
    this.vollerName_ = vollerName;
  }
  
  public String toString() {
    return vollerName_;
  }
  
  
  
  /* (non-Javadoc)
   * @see asit.bescheid.BescheidElement#toElement(org.w3c.dom.Document)
   */
  public Element toElement(Document doc) {
    super.toElement(doc);
    
    // add voller name
    if (vollerName_ == null) {
      vollerName_ = "";
    }
    String vnElement = useGerman_ ? PersonConstants.VOLLERNAME : PersonConstants.FULLNAME ;
    addStringElement(root_, doc, vnElement, vollerName_);
    
    // add rechtsform - nur dt
    if (!NotificationUtils.isEmpty(rechtsForm_) && useGerman_) {
      addStringElement(root_, doc, PersonConstants.RECHTSFORM, rechtsForm_);
    }

    // add verwaltungseinheit
    if (!NotificationUtils.isEmpty(verwaltungseinheit_)) {
      String vwElement = useGerman_ ? PersonConstants.VERWALTUNGSEINHEIT : PersonConstants.ORGANIZATION;
      addStringElement(root_, doc, vwElement, verwaltungseinheit_);
    }
    return root_;
  }
  
  /* (non-Javadoc)
   * @see asit.bescheid.BescheidElement#update(org.w3c.dom.Element)
   */
  public void update(Element element) {
    super.update(element);
    
    log_.debug("Updating kompakte nicht natuerliche person: "+ element.getTagName());
    try {
      
      // retrieve voller name
      Node vollername = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.VOLLERNAME + "/text()");
      if (vollername != null) {
        log_.debug("Found vollername node: " + vollername.getNodeValue());
        vollerName_ = vollername.getNodeValue();
      }
      
      //  retrieve rechtsform
      Node rechtsform = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.RECHTSFORM + "/text()");
      if (rechtsform != null) {
        log_.debug("Found rechtsform node: " + rechtsform.getNodeValue());
        rechtsForm_ = rechtsform.getNodeValue();
      }

      //  retrieve verwaltungseinheit
      Node verwaltungseinheit = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.VERWALTUNGSEINHEIT + "/text()");
      if (verwaltungseinheit != null) {
        log_.debug("Found verwaltungseinheit node: " + verwaltungseinheit.getNodeValue());
        verwaltungseinheit_ = verwaltungseinheit.getNodeValue();
      }
    } catch(TransformerException e) {
      log_.debug("Error while evaluating XPath expression: " + e.getMessage());
    }
  }
}
