package asit.moa.client.deliver.address;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import javax.xml.transform.TransformerException;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.validator.ValidatorForm;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import asit.bescheid.BescheidConstants;
import asit.bescheid.EckData;
import asit.bescheid.NotificationUtils;


// Kompakte Postadresse
public class KompPostalAddress extends ValidatorForm implements EckData {

  
  protected String staatsangehoerigkeit_ = null;
  protected String postleitzahl_ = null;
  protected String gemeinde_ = null;
  
  protected String strassenname_ = null;
  protected String orientierungsnummer_ = null;
  protected String gebaeude_ = null;
  protected String nutzungseinheitsnummer_ = null;
  
  protected String feldName_ = null;
  
  public void setEDescription(String s) {
  }
  
  protected boolean useGerman_ = true;
  
  
  public void setUseGerman(boolean useGerman) {
    useGerman_ = useGerman;
  }
  
  protected static Log log_ = LogFactory.getLog(KompPostalAddress.class); 
  
  // returns String representation of Adress
  public String toString() {
    String ret = "";
    if (!NotificationUtils.isEmpty(strassenname_)) {
      ret += strassenname_;
      if (!NotificationUtils.isEmpty(orientierungsnummer_)) {
        ret += ", " + orientierungsnummer_;
        if (!NotificationUtils.isEmpty(gebaeude_)) {
          ret += ", " + gebaeude_;
          if (!NotificationUtils.isEmpty(nutzungseinheitsnummer_)) {
            ret += ", " + nutzungseinheitsnummer_;
          }
        }
      }
    }
    if (!NotificationUtils.isEmpty(postleitzahl_)) {
      if (!NotificationUtils.isEmpty(strassenname_)) {
        ret += " - ";
      }
      ret += postleitzahl_;
    }
    
    if (!NotificationUtils.isEmpty(gemeinde_ )) {
      if (!NotificationUtils.isEmpty(strassenname_ ) && !NotificationUtils.isEmpty(postleitzahl_)) {
        ret += " - ";
      }
      if (!NotificationUtils.isEmpty(postleitzahl_ )) {
        ret += " ";
      }
      ret += gemeinde_;
    }
    if (!NotificationUtils.isEmpty(staatsangehoerigkeit_) && !KompNatuerlichePerson.KEIN.equals(staatsangehoerigkeit_)) {
      ret += " (";
      ret += staatsangehoerigkeit_ + ")";
    }
    if (ret.equals("")) {
      return "[ Keine Adressangaben ]";
    }
    return ret;
  }
  
  
  /**
   * @return Returns the gebaeude_.
   */
  public String getPGebaeude() {
    return gebaeude_;
  }
  /**
   * @param gebaeude_ The gebaeude_ to set.
   */
  public void setPGebaeude(String gebaeude) {
    this.gebaeude_ = gebaeude;
  }
  /**
   * @return Returns the gemeinde_.
   */
  public String getPGemeinde() {
    return gemeinde_;
  }
  /**
   * @param gemeinde_ The gemeinde_ to set.
   */
  public void setPGemeinde(String gemeinde) {
    this.gemeinde_ = gemeinde;
  }
  /**
   * @return Returns the nutzungseinheitsnummer_.
   */
  public String getPNutzungseinheitsnummer() {
    return nutzungseinheitsnummer_;
  }
  /**
   * @param nutzungseinheitsnummer_ The nutzungseinheitsnummer_ to set.
   */
  public void setPNutzungseinheitsnummer(String nutzungseinheitsnummer) {
    this.nutzungseinheitsnummer_ = nutzungseinheitsnummer;
  }
  /**
   * @return Returns the orientierungsnummer_.
   */
  public String getPOrientierungsnummer() {
    return orientierungsnummer_;
  }
  /**
   * @param orientierungsnummer_ The orientierungsnummer_ to set.
   */
  public void setPOrientierungsnummer(String orientierungsnummer) {
    this.orientierungsnummer_ = orientierungsnummer;
  }
  /**
   * @return Returns the postleitzahl_.
   */
  public String getPPostleitzahl() {
    return postleitzahl_;
  }
  /**
   * @param postleitzahl_ The postleitzahl_ to set.
   */
  public void setPPostleitzahl(String postleitzahl) {
    this.postleitzahl_ = postleitzahl;
  }
  /**
   * @return Returns the staatsCode_.
   */
  public String getPStaatsangehoerigkeit() {
    return NotificationUtils.isEmpty(staatsangehoerigkeit_) ? KompNatuerlichePerson.KEIN : staatsangehoerigkeit_;
  }
  
  public void setPStaatsangehoerigkeit(String staatsangehoerigkeit) {
    this.staatsangehoerigkeit_ = staatsangehoerigkeit;
  }
  

  public Collection getPStaaten() {
    log_.debug("Get Staaten");
    String countriesFile = super.getServlet().getServletContext().getRealPath("/WEB-INF/res/countries.txt");
    log_.debug("File: " + countriesFile);
    Collection codes = NotificationUtils.getLaenderCodes(countriesFile);
    Collection names = NotificationUtils.getLaenderNamen(countriesFile);
    
    ArrayList ret = new ArrayList();
    
    Iterator it = codes.iterator();
    Iterator it2 = names.iterator();
    log_.debug("Iteriere...");
    while (it.hasNext()) {
      ret.add(it.next() + " - " + it2.next());
    }
    return ret;
   }
  
  /**
   * @return Returns the strassenname_.
   */
  public String getPStrassenname() {
    return strassenname_;
  }
  /**
   * @param strassenname_ The strassenname_ to set.
   */
  public void setPStrassenname(String strassenname) {
    this.strassenname_ = strassenname;
  }
  
  /*
   * @see asit.bescheid.BescheidElement#toElement(org.w3c.dom.Document)
   */
  public Element toElement(Document doc) {
    String postElement = useGerman_ ? PersonConstants.KOMPAKTEPOSTADRESSE : PersonConstants.POSTALADDRESS;
    Element kompost = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":" + postElement);
    
    String code = KompNatuerlichePerson.getCountryCode(staatsangehoerigkeit_);
    String name = KompNatuerlichePerson.getCountryName(staatsangehoerigkeit_);
    
    // add staatscode (can be empty)
    if (!NotificationUtils.isEmpty(code)) {
      String codeElement = useGerman_ ? PersonConstants.STAATSCODE : PersonConstants.COUNTRYCODE;
      AbstractPerson.addStringElement(kompost, doc, codeElement, code);
    }

    // add staatsname (can be empty)
    if (!NotificationUtils.isEmpty(name) && useGerman_) {
      AbstractPerson.addStringElement(kompost, doc, PersonConstants.STAATSNAME, name);
    }

    // add postleitzahl
    if (postleitzahl_ == null) {
      postleitzahl_ = "";
    }
    String plzElement = useGerman_ ? PersonConstants.POSTLEITZAHL : PersonConstants.POSTALCODE;
    AbstractPerson.addStringElement(kompost, doc, plzElement, postleitzahl_);

    // add gemeinde
    if (gemeinde_ == null) {
      gemeinde_ = "";
    }
    
    String munElement = useGerman_ ? PersonConstants.GEMEINDE : PersonConstants.MUNICIPALITY;
    AbstractPerson.addStringElement(kompost, doc, munElement, gemeinde_);

    String deliverElement = useGerman_ ? PersonConstants.ZUSTELLADRESSE : PersonConstants.DELIVERYADDRESS; 
    Element zustellAdresse = doc.createElementNS(PersonConstants.PERSON_NS, PersonConstants.PERSON_NS_PREFIX + ":" + deliverElement);
    kompost.appendChild(zustellAdresse);
    
    // add strassenname
    if (strassenname_ == null) {
      strassenname_ = "";
    }
    String snElement = useGerman_ ? PersonConstants.STRASSENNAME : PersonConstants.STREETNAME;
    AbstractPerson.addStringElement(zustellAdresse, doc, snElement, strassenname_);
    
    // add orientierungsnummer
    if (orientierungsnummer_ == null) {
      orientierungsnummer_ = "";
    }
    String numElement = useGerman_ ? PersonConstants.GEBAEUDE : PersonConstants.BUILDINGNUMBER;
    AbstractPerson.addStringElement(zustellAdresse, doc, numElement, orientierungsnummer_);

    //  add gebaeude (can be empty)
    if (!NotificationUtils.isEmpty(gebaeude_)) {
      //String gebElement = useGerman_ ? PersonConstants.GEBAEUDE : PersonConstants.BUILDINGNUMBER;
      String gebElement = useGerman_ ? PersonConstants.ORIENTIERUNGSNUMMER : PersonConstants.UNIT;
      AbstractPerson.addStringElement(zustellAdresse, doc, gebElement, gebaeude_);
    }

    //  add nutzungseinheit
    if (!NotificationUtils.isEmpty(nutzungseinheitsnummer_)) {
      String nutzElement = useGerman_ ? PersonConstants.NUTZUNGSEINHEITNUMMER : PersonConstants.DOORNUMBER;
      AbstractPerson.addStringElement(zustellAdresse, doc, nutzElement, nutzungseinheitsnummer_);
    }
    
    return kompost;
    
  }

  /*
   * @see asit.bescheid.BescheidElement#update(org.w3c.dom.Element)
   */
  public void update(Element element) {
    log_.debug("Updating postaddresse: " + element.getTagName());
    try {
      
      //  retrieve feldname
      Node feldname = XPathAPI.selectSingleNode(element, "descendant-or-self::" + BescheidConstants.BESCHEID_NS_PREFIX + ":" + BescheidConstants.FELDNAME + "/text()");
      if (feldname != null) {
        log_.debug("Found Feldname node: " + feldname.getNodeValue());
        feldName_ = feldname.getNodeValue();
      }
      
      String staatsCodeValue = null;
      
      // retrieve staatscode
      Node staatscode = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.STAATSCODE + "/text()");
      if (staatscode != null) {
        log_.debug("Found Staatscode node: " + staatscode.getNodeValue());
        staatsCodeValue = staatscode.getNodeValue();
      }

      String staatsCodeName = null;
      
      // retrieve staatsname
      Node staatsname = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.STAATSNAME + "/text()");
      if (staatsname != null) {
        log_.debug("Found Staatsname node: " + staatsname.getNodeValue());
        staatsCodeName = staatsname.getNodeValue();
      }
      
      if (!NotificationUtils.isEmpty(staatsCodeValue) && !NotificationUtils.isEmpty(staatsCodeName)) {
        staatsangehoerigkeit_ = staatsCodeValue + " - " + staatsCodeName;
      }

      // retrieve postleitzahl
      Node plz = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.POSTLEITZAHL + "/text()");
      if (plz != null) {
        log_.debug("Found PLZ node: " + plz.getNodeValue());
        postleitzahl_ = plz.getNodeValue();
      }

      // retrieve gemeinde
      Node gemeinde = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.GEMEINDE+ "/text()");
      if (gemeinde != null) {
        log_.debug("Found Gemeinde node: " + gemeinde.getNodeValue());
        gemeinde_ = gemeinde.getNodeValue();
      }

      // retrieve strassenname
      Node strassenname = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.STRASSENNAME + "/text()");
      if (strassenname != null) {
        log_.debug("Found Strassenname node: " + strassenname.getNodeValue());
        strassenname_ = strassenname.getNodeValue();
      }

      // retrieve orientierungsnummer
      Node orientierungsnummer = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.ORIENTIERUNGSNUMMER + "/text()");
      if (orientierungsnummer != null) {
        log_.debug("Found Orientierungsnummer node: " + orientierungsnummer.getNodeValue());
        orientierungsnummer_ = orientierungsnummer.getNodeValue();
      }

      // retrieve gebaude
      Node gebaeude = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.GEBAEUDE + "/text()");
      if (gebaeude != null) {
        log_.debug("Found Gebaeude node: " + gebaeude.getNodeValue());
        gebaeude_ = gebaeude.getNodeValue();
      }

      // retrieve gebaude
      Node nutzungseinheitnummer = XPathAPI.selectSingleNode(element, "descendant-or-self::" + PersonConstants.PERSON_NS_PREFIX + ":" + PersonConstants.NUTZUNGSEINHEITNUMMER + "/text()");
      if (nutzungseinheitnummer != null) {
        log_.debug("Found Nutzungseinheitnummer node: " + nutzungseinheitnummer.getNodeValue());
        nutzungseinheitsnummer_ = nutzungseinheitnummer.getNodeValue();
      }
    } catch(TransformerException e) {
      log_.debug("Error while evaluating XPath expression: " + e.getMessage());
    }
  }


  /* (non-Javadoc)
   * @see asit.bescheid.EckData#getType()
   */
  public String getType() {
    return EckData.KOMPOSTALADDRESS;
  }

  public void setType(String s) {
    // do nothing - dummy method for Java BEAN
  }

  /* (non-Javadoc)
   * @see asit.bescheid.EckData#getEFeldName()
   */
  public String getEFeldName() {
    return feldName_;
  }


  /* (non-Javadoc)
   * @see asit.bescheid.EckData#setEFeldName()
   */
  public void setEFeldName(String feldName) {
    feldName_ = feldName;
  }


  /* (non-Javadoc)
   * @see asit.bescheid.EckData#getEDescription()
   */
  public String getEDescription() {
    return toString();
  }
}
