package asit.moa.client.id;

/**
 * Default-Implementation for the ExtendedSAMLAttribute interface
 * 
 * @author Sven Ainger
 */
// AIGNER

public class ExtendedSAMLAttributeImpl implements ExtendedSAMLAttribute {

	private Object value;
	private String name;
	private String nameSpace;
	
	/**
	 * Constructs a <code>ExtendedSAMLAttributeImpl</code> that holds information about the newly generated ExtendedSAMLAttribute
	 * 
	 * @param value <code>Object</code> containing the
	 * 				 value of the extended attribute
	 * @param name <code>String</code> containing the name of the extended element
	 * @param nameSpace <code>String</code> containing the namespace of the extended element
	 * @param addToAUTHBlock <code>boolean</code> true if the attribute should be added to the signed attribute list
	 */
	public ExtendedSAMLAttributeImpl(Object value, String name, String nameSpace)
	{
		this.value = value;
		this.name = name;
		this.nameSpace = nameSpace;
	}
	
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getNameSpace() {
		return nameSpace;
	}
	public void setNameSpace(String nameSpace) {
		this.nameSpace = nameSpace;
	}
	public Object getValue() {
		return value;
	}
	public void setValue(Object value) {
		this.value = value;
	}

   public String toString() {
      StringBuffer buffer = new StringBuffer();
      buffer.append("name=").append(this.name);
      buffer.append(", nameSpace=").append(this.nameSpace);
      buffer.append(", value=").append(this.value);
      return super.toString();
   }
	
}
