/*
 * Created on 28.01.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.moa.client.id;

import java.io.StringWriter;
import java.util.Calendar;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import asit.common.Utils;
import asit.moa.MoaConstants;
import asit.moa.client.AbstractClient;
import asit.moa.client.exception.ClientException;


/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MOAIDClientImpl extends AbstractClient implements MOAIDClient {

  protected Document doc_ = null;
  
  protected String base64SamlArtifact_;
  
  public MOAIDClientImpl() throws ClientException {
    super();
  }
  
//  "<samlp:Request xmlns:samlp=\"urn:oasis:names:tc:SAML:1.0:protocol\" RequestID=\"{0}\" MajorVersion=\"1\" MinorVersion=\"0\" IssueInstant=\"{1}\">"
//   + "<samlp:AssertionArtifact>{2}</samlp:AssertionArtifact>"
//  + "</samlp:Request>";
  
  /* (non-Javadoc)
   * @see asit.moa.client.Client#getRequest()
   */
  public Element getRequest() throws ClientException {
    if (base64SamlArtifact_ == null) {
      throw new ClientException("Please set first the saml artifact.");
    }
    doc_ = AbstractClient.createNewDocument();
    
    String issueInstant = buildDateTime(Calendar.getInstance());
    Element root = doc_.createElementNS(MoaConstants.SAMLP_NS, MoaConstants.SAMLP_NS_PREFIX + ":" + MoaConstants.REQUEST);
    root.setAttribute("xmlns:" + MoaConstants.SAMLP_NS_PREFIX, MoaConstants.SAMLP_NS);
    try {
      root.setAttribute(MoaConstants.REQUESTID, Utils.generateAppDeliveryID());
    } catch(Exception e) {
      throw new ClientException(e);
    }
    root.setAttribute(MoaConstants.MAJORVERSION, "1");
    root.setAttribute(MoaConstants.MINORVERSION, "0");
    root.setAttribute(MoaConstants.ISSUEINSTANT, issueInstant);
    
    Element assertionArtifact = doc_.createElementNS(MoaConstants.SAMLP_NS, MoaConstants.SAMLP_NS_PREFIX + ":" + MoaConstants.ASSERTIONARTIFACT);
    assertionArtifact.appendChild(doc_.createTextNode(base64SamlArtifact_));
    root.appendChild(assertionArtifact);
    
    return root;
  }

  /* (non-Javadoc)
   * @see asit.moa.client.id.MOAIDClient#setSAMLArtifact(java.lang.String)
   */
  public void setSAMLArtifact(String base64EncodedSamlArtifact) {
    base64SamlArtifact_ = base64EncodedSamlArtifact;
    
  }
  
  public static String buildDateTime(Calendar cal) {
    StringWriter out = new StringWriter();
    out.write("" + cal.get(Calendar.YEAR));
    out.write("-");
    out.write(to2DigitString(cal.get(Calendar.MONTH) + 1));
    out.write("-");
    out.write(to2DigitString(cal.get(Calendar.DAY_OF_MONTH)));
    out.write("T");
    out.write(to2DigitString(cal.get(Calendar.HOUR_OF_DAY)));
    out.write(":");
    out.write(to2DigitString(cal.get(Calendar.MINUTE)));
    out.write(":");
    out.write(to2DigitString(cal.get(Calendar.SECOND)));
    int tzOffsetMilliseconds =
      cal.get(Calendar.ZONE_OFFSET) + cal.get(Calendar.DST_OFFSET);
    if (tzOffsetMilliseconds != 0) {
      int tzOffsetMinutes = tzOffsetMilliseconds / (1000 * 60);
      int tzOffsetHours = tzOffsetMinutes / 60;
      tzOffsetMinutes -= tzOffsetHours * 60;
      if (tzOffsetMilliseconds > 0) {
        out.write("+");
        out.write(to2DigitString(tzOffsetHours));
        out.write(":");
        out.write(to2DigitString(tzOffsetMinutes));
      } else {
        out.write("-");
        out.write(to2DigitString(-tzOffsetHours));
        out.write(":");
        out.write(to2DigitString(-tzOffsetMinutes));
      }
    }
    return out.toString();
  }
  
  private static String to2DigitString(int number) {
    if (number < 10)
      return "0" + number;
    else
      return "" + number;
  }

  /* (non-Javadoc)
   * @see asit.moa.client.id.MOAIDClient#getAuthenticationData()
   */
  public MOAIDPrincipal getAuthenticationData(String address) throws ClientException {

      Element response = super.sendRequest(address);
      
      return MOAIDPrincipalParser.parse(response);
      
  
  }
  
  public MOAIDPrincipal getAuthenticationData() throws ClientException {
      Element response = super.sendRequest(defaultAddress_);
      
      return MOAIDPrincipalParser.parse(response);
      
  }
}
