package asit.moa.client.sign;

import org.w3c.dom.Element;
import asit.moa.client.Client;
import asit.moa.client.exception.ClientException;
import asit.moa.client.exception.RequestException;

/**
 * @author atauber
 */
public interface CreateSignatureClient extends Client {

    public void setKeyIdentifier(String identifier);
    
    public void setDefaultAddress(String address);
    
    public void setSingleSignatureInfos(SingleSignatureInfo[] infos);
    
    /*
     * Sends the signature request and extracts the following element:
     * 
     *  (a) if the request claimed for an enveloped signature the document where the signature is enveloped
     *  (b) if the request claimed for a detached signature the signature itself, <dsig:Signature>
     */
    Element sendSignatureRequest() throws ClientException, RequestException;
    Element sendSignatureRequest(String address) throws ClientException, RequestException;
    Element sendSignatureRequest(String address, Element request) throws ClientException, RequestException;
}
