package asit.moa.client.sign;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import asit.moa.MoaConstants;


/**
 * @author atauber
 */
public class MetaInfoImpl implements MetaInfo {

  
  protected String mimeType_ = null;
  protected String description_ = null;
  
  public MetaInfoImpl(String mimeType, String description) {
    if (mimeType == null) {
      throw new NullPointerException("Argument \"mimeType\" must not be null");
    }
    mimeType_ = mimeType;
    description_ = description;
  }

  /* (non-Javadoc)
   * @see asit.framework.moaclient.MetaInfo#getMimeType()
   */
  public String getMimeType() {
    return mimeType_;
  }

  /* (non-Javadoc)
   * @see asit.framework.moaclient.MetaInfo#getDescription()
   */
  public String getDescription() {
    return description_;
  }

  /* (non-Javadoc)
   * @see asit.framework.moaclient.MetaInfo#toElement(org.w3c.dom.Document)
   */
  public Element toElement(Document doc) {
    // mime-type
    Element finalDataMetaInfo = doc.createElementNS(MoaConstants.MOA_NS, MoaConstants.MOA_PREFIX + MoaConstants.FINAL_DATA_METAINFO);
    Element mimeTypeElement = doc.createElementNS(MoaConstants.MOA_NS, MoaConstants.MOA_PREFIX + MoaConstants.MIME_TYPE);
    mimeTypeElement.appendChild(doc.createTextNode(mimeType_));
    finalDataMetaInfo.appendChild(mimeTypeElement);

    if (description_ != null) {
      Element descr = doc.createElementNS(MoaConstants.MOA_NS, MoaConstants.MOA_PREFIX + MoaConstants.DESCRIPTION);
      descr.appendChild(doc.createTextNode(description_));
      finalDataMetaInfo.appendChild(descr);
    }
    return finalDataMetaInfo;
  }
  
}
