/*
 * Created on 25.02.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.moa.client.status;

import java.text.SimpleDateFormat;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import asit.moa.MoaConstants;
import asit.moa.client.AbstractClient;
import asit.moa.client.exception.ClientException;


/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class StatusClientImpl extends AbstractClient implements StatusClient {

  private String moazsId_;

  public StatusClientImpl() throws ClientException {
    doc_ = AbstractClient.createNewDocument();
  }
  
  /*
   * @see asit.moa.client.status.StatusClient#setMZSId(java.lang.String)
   */
  public void setMZSId(String mzsid) throws ClientException {
    moazsId_ = mzsid;
  }

  /*
   * @see asit.moa.client.Client#getRequest()
   */
  public Element getRequest() throws ClientException {
    Element root = doc_.createElement(MoaConstants.MOA_ZS_NS_PREFIX + ":StatusRequest");
    root.setAttribute("xmlns:" + MoaConstants.MOA_ZS_NS_PREFIX, MoaConstants.MOA_ZS_NS);
    root.appendChild(doc_.createTextNode(moazsId_));  
    return root;
  }

  /* (non-Javadoc)
   * @see asit.moa.client.status.StatusClient#sendStatusRequest(java.lang.String)
   */
  public StatusResponse sendStatusRequest(String adress) throws ClientException {
    Element response = super.sendRequest(adress);
    try {
      return parseResponse(response);
    } catch(Exception e) {
      throw new ClientException(e);
    }
  }
  
  private StatusResponse parseResponse(Element response) throws Exception {
    String prefix = response.getPrefix();
    if (prefix == null) {
      prefix = "";
    }
    
    
    if ("Success".equals(response.getLocalName())) {
      SuccessStatusResponseImpl ret = new SuccessStatusResponseImpl();
      Node n = XPathAPI.selectSingleNode(response, "self::" + prefix + ":Success/" + prefix + ":MZSDeliveryID/text()");
      if (n != null) {
        ret.setMZSID(n.getNodeValue());
      }
      n = XPathAPI.selectSingleNode(response, "self::" + prefix + ":Success/" + prefix + ":AppDeliveryID/text()");
      if (n != null) {
        ret.setAppId(n.getNodeValue());
      }
      n = XPathAPI.selectSingleNode(response, "self::" + prefix + ":Success/" + prefix + ":TimeStamp/text()");
      if (n != null) {
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd kk:mm:ss");
        ret.setTimeStamp(format.parse(n.getNodeValue()));
      }
      n = XPathAPI.selectSingleNode(response, "self::" + prefix + ":Success/" + prefix + ":ErrorCode/text()");
      if (n != null) {
        ret.setErrorCode(n.getNodeValue());
      }
      n = XPathAPI.selectSingleNode(response, "self::" + prefix + ":Success/" + prefix + ":ErrorText/text()");
      if (n != null) {
        ret.setErrorMessage(n.getNodeValue());
      }
      return ret;
    }
    if ("Error".equals(response.getLocalName())) {
      ErrorStatusResponseImpl ret = new ErrorStatusResponseImpl();
      Node n = XPathAPI.selectSingleNode(response, "self::" + prefix + ":Error/" + prefix + ":Code/text()");
      if (n != null) {
        ret.setCode(n.getNodeValue());
      }
      n = XPathAPI.selectSingleNode(response, "self::" + prefix + ":Error/" + prefix + ":Text/text()");
      if (n != null) {
        ret.setMessage(n.getNodeValue());
      }
      return ret;
    }
    return null;
  }
}
