/*
 * Created on 17.02.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.moa.moaid;

import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.net.ssl.HttpsURLConnection;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import asit.common.Utils;
import asit.moa.moaid.manager.JDBCRoleManager;

/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class BPKCalculatorServlet extends HttpServlet {

  
  private final static String PERSON_XPATH = "/InfoboxReadResponse/BinaryFileData/XMLContent/Assertion/AttributeStatement/Subject/SubjectConfirmation/SubjectConfirmationData/Person/";
  
  
  
  protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException,
      IOException {

    doPost(request, response);
  }
  protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException,
      IOException {

    String redirectCode = "error";
    String errorCode = null;
    try {
      // fetch response
      String xmlResponse = request.getParameter("XMLResponse");
      if (xmlResponse == null) {
        return;
      }
      
      Document doc = Utils.readDocFromIsNoNS(new ByteArrayInputStream(xmlResponse.getBytes()));
      
      String givenName = getGivenName(doc);
      
      // pruefe, ob daten vorhanden sind
      if (givenName == null) {
        return;
      }
      
      String familyName = getFamilyName(doc);
      Date dateOfBirth = getDateOfBirth(doc);
      String bpk = getBPK(doc);
      String bpkIdentifier = getBPKType(doc);
      
      JDBCRoleManager manager = new JDBCRoleManager(getServletContext().getInitParameter("jdbcurl"));
      Citizen c = new Citizen(givenName, familyName, dateOfBirth);
      // hinzufuegen von person
      int cit = manager.getCitizenId(c);
      if (cit == -1) {
        manager.addCitizen(c);
      }
      
      // registriere bpk nur, falls es nicht die stammzahl ist
      if (!"urn:publicid:gv.at:baseid".equals(bpkIdentifier)) {
        manager.addBPK(bpk, c);
      }
      redirectCode = "success";
      //System.out.println(xmlResponse);
      
    } catch(Exception e) {
      errorCode = e.getMessage();
      e.printStackTrace();
    } finally {
      
      String mainURL = request.getRequestURL().substring(0, request.getRequestURL().lastIndexOf("/"));
      
      String redirectURL = mainURL + "/register.jsp?action=" + redirectCode;
      if (errorCode != null) {
        redirectURL += "&errorcode=" + URLEncoder.encode(errorCode, "UTF-8");
      }
      response.setContentType("application/x-www-form-urlencoded");
      PrintWriter out = response.getWriter();
      out.println("XMLRequest=" + URLEncoder.encode("<ok/>", "UTF-8"));
      out.println("&RedirectURL=" + URLEncoder.encode(redirectURL, "UTF-8"));
    }
    
  }
  
  
  private String getFamilyName(Document doc) {
    try {
      Node n = XPathAPI.selectSingleNode(doc, PERSON_XPATH + "Name/FamilyName/text()");
      if (n != null) {
        return n.getNodeValue();
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
    return null;

  }
  
  private String getGivenName(Document doc) {
    try {
      Node n = XPathAPI.selectSingleNode(doc, PERSON_XPATH + "Name/GivenName/text()");
      if (n != null) {
        return n.getNodeValue();
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
    return null;

  }
  
  private Date getDateOfBirth(Document doc) {
    try {
      Node n = XPathAPI.selectSingleNode(doc, PERSON_XPATH + "DateOfBirth/text()");
      if (n != null) {
        String s = n.getNodeValue();
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        return format.parse(s);
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
    return null;

  }

  private String getBPK(Document doc) {
    try {
      Node n = XPathAPI.selectSingleNode(doc, PERSON_XPATH + "Identification/Value/text()");
      if (n != null) {
        return n.getNodeValue();
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
    return null;

  }
  
  private String getBPKType(Document doc) {
    try {
      Node n = XPathAPI.selectSingleNode(doc, PERSON_XPATH + "Identification/Type/text()");
      if (n != null) {
        return n.getNodeValue();
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
    return null;

  }

  protected static Document sendSecurityLayerRequest(URL connectionURL, String request, String dataURL, String redirectURL) throws Exception {
    if (request == null) {
      throw new NullPointerException("Kann keinen null Request senden.");
    }
    HttpURLConnection connection;
    if (connectionURL != null) {
      if (connectionURL.toExternalForm().startsWith("https")) {
        connection = (HttpsURLConnection)connectionURL.openConnection();
      } else {
        connection = (HttpURLConnection)connectionURL.openConnection();
      }
      connection.setRequestMethod("POST");
      //connection.setUseCaches(false);
      connection.setDoOutput(true);
      
      connection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
      
      String toSend = URLEncoder.encode(request, "UTF-8");
      toSend = "XMLRequest=" + toSend;
      
      // add redirect url
      if (redirectURL != null &&
          !"".equals(redirectURL)) {
        toSend += "&RedirectURL=" + URLEncoder.encode(redirectURL, "UTF-8");
      }

      // add data url
      if (dataURL != null &&
          !"".equals(dataURL)) {
        toSend += "&DataURL=" + URLEncoder.encode(dataURL, "UTF-8");
      }
      
      connection.setRequestProperty("Content-Length", String.valueOf(toSend.getBytes().length));
      
      OutputStream out = connection.getOutputStream();
      out.write(toSend.getBytes());
      out.flush();
      
      // get response
      connection.connect();
      int responseCode = connection.getResponseCode();
      
      if (responseCode != 200) {
        InputStream is = connection.getErrorStream();
        int ch;
        String ret = "";
        while ((ch = is.read()) != -1) {
          ret += (char)ch;
        }
        is.close();
        throw new Exception("Antwortcode nicht 200 bei Kontakt zu Security Layer: " + ret);
      }
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      factory.setNamespaceAware(false);
      Document doc = null;
      try {
        DocumentBuilder builder = factory.newDocumentBuilder();
        doc = builder.parse(connection.getInputStream());
        
        Node error = XPathAPI.selectSingleNode(doc, "/ErrorResponse");
        if (error != null) {
          String code = "Unbekannt";
          Node codeNode = XPathAPI.selectSingleNode(doc, "/ErrorResponse/ErrorCode/text()");
          if (codeNode != null) {
            code = codeNode.getNodeValue();
          }
          String info = "Unbekannt";
          Node infoNode = XPathAPI.selectSingleNode(doc, "/ErrorResponse/Info/text()");
          if (infoNode != null) {
            info = infoNode.getNodeValue();
          }
          throw new Exception(info);
        }
        
        return doc;
      } catch(IOException e) {
        
        throw(e);
      } catch (Exception e) {
        e.printStackTrace();
        
        throw new Exception(e.getMessage());
      }
    } else {
      return null;
    }
  }
  
  public static void main(String[] args) throws Exception {
    Document doc = Utils.readDocFromIsNoNS(new FileInputStream("c:/temp/identity.xml"));
    BPKCalculatorServlet s = new BPKCalculatorServlet();
//    System.out.println(s.getGivenName(doc));
//    System.out.println(s.getFamilyName(doc));
//    System.out.println(s.getDateOfBirth(doc));
//    System.out.println(s.getBPK(doc));
  }
}
