package asit.moa.moaid.manager;

import java.util.List;
import asit.moa.moaid.Citizen;


public interface RoleManager {
  
  // manage citizenroles
  void addCitizenRole(String role, Citizen citizen) throws RoleManagerException;
  void removeCitizenRole(String role, Citizen citizen) throws RoleManagerException;
  void removeCitizenRoles(String role) throws RoleManagerException;
  void removeCitizenRoles(Citizen citizen)  throws RoleManagerException;
  
  // manage citizenprofiles
  void addCitizenProfile(String role, Citizen citizen) throws RoleManagerException;
  void removeCitizenProfile(String role, Citizen citizen) throws RoleManagerException;
  void removeCitizenProfiles(String role) throws RoleManagerException;
  void removeCitizenProfiles(Citizen citizen) throws RoleManagerException;
  
  
  // manage bpks
  void addBPK(String base64BPK, Citizen citizen) throws RoleManagerException;
  void removeBPK(String base64BPK) throws RoleManagerException;
  
  // manage citizens
  void addCitizen(Citizen citizen) throws RoleManagerException;
  void removeCitizen(Citizen citizen) throws RoleManagerException;
  List getCitizens() throws RoleManagerException;
  
  // manage roles
  void addRole(String role) throws RoleManagerException;
  void removeRole(String role) throws RoleManagerException;
  List getRoles() throws RoleManagerException;
  
  // manage profiles
  void addAuthorityProfile(String profileName) throws RoleManagerException;
  void removeAuthorityProfile(String profileName) throws RoleManagerException;
  List getAuthorityProfiles() throws RoleManagerException;
  
}
