package asit.moa.moazs;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import asit.common.Utils;
import asit.moa.client.deliver.moazs.DeliveryResponse;
import asit.moa.client.deliver.moazs.MOAZSClientImpl;
import asit.moa.moazs.notifier.UtilsProtocolEntry;
import asit.moa.moazs.notifier._BaseRootDAO;


public class MOAZSNotifierService extends HttpServlet {
  
  MOAZSWatchDog watchdog = null;
  
  public void destroy() {
    super.destroy();
    
    // kill the watchdog
    if (watchdog != null) {
      watchdog.kill();
    }
  }
  // initialize
  public void init() throws ServletException {
    super.init();
    try {
      _BaseRootDAO.initialize();
//      System.out.println("Starte Watchdog...");
      // start watchdog
      watchdog = new MOAZSWatchDog();
      watchdog.start();
    } catch(Exception e) {
      throw new ServletException(e);
    }
  }
  protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException,
      IOException {
    doPost(request, response);
  }
  protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException,
      IOException {

    try {
      
      // namespace awares parsen
      Document doc = Utils.readDocFromIsNS(request.getInputStream());
      String soapPrefix = doc.getDocumentElement().getPrefix();
      
      NodeList resp = XPathAPI.selectNodeList(doc.getDocumentElement(), "/" + soapPrefix + ":Envelope/" + soapPrefix + ":Body/child::node()[1]");
      
      if (resp.getLength() > 0) {
        
        DeliveryResponse deliveryResponse = MOAZSClientImpl.parseResponse((Element)resp.item(0));
        
        //System.out.println("DELIVERY: " + deliveryResponse.getType());
        UtilsProtocolEntry.addProtocolEntry(deliveryResponse);
        
      } else {
        throw new Exception("Kein SOAP Content gefunden.");
      }
      
      // send ok
      response.setContentType("text/xml");
      Utils.serializeElement(Utils.packIntoSoap(Utils.parseXMLString("<ok/>").getDocumentElement()), response.getOutputStream());
    } catch(Exception e) {
      e.printStackTrace();
      response.sendError(500, "Interner Server Error - " + e.getMessage());
    }
  }
}
