package asit.moa.moazs;

import java.util.Date;
import java.util.Iterator;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import asit.moa.moazs.notifier.Config;
import asit.moa.moazs.notifier.ProtocolEntry;
import asit.moa.moazs.notifier.UtilsConfig;
import asit.moa.moazs.notifier.UtilsProtocolEntry;


public class MOAZSWatchDog extends Thread {
  
  private final static long SLEEP_INTERVAL = 20000;
  
  static Log logger_ = LogFactory.getLog(MOAZSWatchDog.class.getName());
  
  private long interval_ = 0;
  
  private boolean isKilled_ = false;
  
  public synchronized void kill() {
    isKilled_ = true;
  }
  
  public void run() {
    
    while(!isKilled_) {
      try {
        Config cfg = UtilsConfig.get("deletetime");
        if (cfg != null) {
          interval_ = Long.parseLong(cfg.getValue());
        }
      } catch(Exception e) {
        interval_ = 0;
      }
      
      // delete old entries
      if (interval_ > 0) {
        Date olderThan = new Date();
        olderThan.setTime(olderThan.getTime() - (interval_ * 60000));
        try {
          List toDelete = UtilsProtocolEntry.getProtocolEntries(olderThan);
          for (Iterator it= toDelete.iterator(); it.hasNext();) {
            ProtocolEntry entry = (ProtocolEntry)it.next();
            logger_.debug("Deleting entry (MZS): " + entry.getMoazsId());
            UtilsProtocolEntry.deleteProtocolEntry((ProtocolEntry)entry);
          }
        } catch(Exception e) {
          e.printStackTrace();
        }
      }
      
      // send entries
      try {
        UtilsProtocolEntry.sendEmail();
      } catch(Exception e) {
        e.printStackTrace();
      }
      
          
      try { sleep(SLEEP_INTERVAL); } catch(Exception e) {
          e.printStackTrace();
        }
    }
  }
  
}
