package asit.moa.moazs.notifier;

import java.io.Serializable;


/**
 * This is an object that contains data related to the appid table.
 * Do not modify this class because it will be overwritten if the configuration file
 * related to this class is modified.
 *
 * @hibernate.class
 *  table="appid"
 */

public abstract class BaseAppId  implements Serializable {

	public static String REF = "AppId";
	public static String PROP_APP_ID = "appId";
	public static String PROP_DO_SEND = "doSend";
	public static String PROP_SEND_ONLY_ERROR = "sendOnlyError";
	public static String PROP_SEND_AFTER = "sendAfter";
	public static String PROP_SEND_FETCHED = "sendFetched";


	// constructors
	public BaseAppId () {
		initialize();
	}

	/**
	 * Constructor for primary key
	 */
	public BaseAppId (long id) {
		this.setId(id);
		initialize();
	}

	/**
	 * Constructor for required fields
	 */
	public BaseAppId (
		long id,
		java.lang.String appId,
		int doSend,
		int sendOnlyError,
		int sendAfter,
		int sendFetched) {

		this.setId(id);
		this.setAppId(appId);
		this.setDoSend(doSend);
		this.setSendOnlyError(sendOnlyError);
		this.setSendAfter(sendAfter);
		this.setSendFetched(sendFetched);
		initialize();
	}

	protected void initialize () {}



	private int hashCode = Integer.MIN_VALUE;

	// primary key
	private long id;

	// fields
	private java.lang.String appId;
	private int doSend;
	private int sendOnlyError;
	private int sendAfter;
	private int sendFetched;



	/**
	 * Return the unique identifier of this class
     * @hibernate.id
     *  generator-class="hilo"
     *  column="appid_id"
     */
	public long getId () {
		return id;
	}

	/**
	 * Set the unique identifier of this class
	 * @param id the new ID
	 */
	public void setId (long id) {
		this.id = id;
		this.hashCode = Integer.MIN_VALUE;
	}




	/**
	 * Return the value associated with the column: app_id
	 */
	public java.lang.String getAppId () {
		return appId;
	}

	/**
	 * Set the value related to the column: app_id
	 * @param appId the app_id value
	 */
	public void setAppId (java.lang.String appId) {
		this.appId = appId;
	}



	/**
	 * Return the value associated with the column: do_send
	 */
	public int getDoSend () {
		return doSend;
	}

	/**
	 * Set the value related to the column: do_send
	 * @param doSend the do_send value
	 */
	public void setDoSend (int doSend) {
		this.doSend = doSend;
	}



	/**
	 * Return the value associated with the column: send_only_error
	 */
	public int getSendOnlyError () {
		return sendOnlyError;
	}

	/**
	 * Set the value related to the column: send_only_error
	 * @param sendOnlyError the send_only_error value
	 */
	public void setSendOnlyError (int sendOnlyError) {
		this.sendOnlyError = sendOnlyError;
	}



	/**
	 * Return the value associated with the column: send_after
	 */
	public int getSendAfter () {
		return sendAfter;
	}

	/**
	 * Set the value related to the column: send_after
	 * @param sendAfter the send_after value
	 */
	public void setSendAfter (int sendAfter) {
		this.sendAfter = sendAfter;
	}



	/**
	 * Return the value associated with the column: send_fetched
	 */
	public int getSendFetched () {
		return sendFetched;
	}

	/**
	 * Set the value related to the column: send_fetched
	 * @param sendFetched the send_fetched value
	 */
	public void setSendFetched (int sendFetched) {
		this.sendFetched = sendFetched;
	}





	public boolean equals (Object obj) {
		if (null == obj) return false;
		if (!(obj instanceof asit.moa.moazs.notifier.AppId)) return false;
		else {
			asit.moa.moazs.notifier.AppId appId = (asit.moa.moazs.notifier.AppId) obj;
			return (this.getId() == appId.getId());
		}
	}

	public int hashCode () {
		if (Integer.MIN_VALUE == this.hashCode) {
			return (int) this.getId();
		}
		return this.hashCode;
	}


	public String toString () {
		return super.toString();
	}


}