package asit.moa.moazs.notifier;

import java.io.Serializable;


/**
 * This is an object that contains data related to the config table.
 * Do not modify this class because it will be overwritten if the configuration file
 * related to this class is modified.
 *
 * @hibernate.class
 *  table="config"
 */

public abstract class BaseConfig  implements Serializable {

	public static String REF = "Config";
	public static String PROP_NAME = "name";
	public static String PROP_VALUE = "value";


	// constructors
	public BaseConfig () {
		initialize();
	}

	/**
	 * Constructor for primary key
	 */
	public BaseConfig (long id) {
		this.setId(id);
		initialize();
	}

	/**
	 * Constructor for required fields
	 */
	public BaseConfig (
		long id,
		java.lang.String name,
		java.lang.String value) {

		this.setId(id);
		this.setName(name);
		this.setValue(value);
		initialize();
	}

	protected void initialize () {}



	private int hashCode = Integer.MIN_VALUE;

	// primary key
	private long id;

	// fields
	private java.lang.String name;
	private java.lang.String value;



	/**
	 * Return the unique identifier of this class
     * @hibernate.id
     *  generator-class="hilo"
     *  column="config_id"
     */
	public long getId () {
		return id;
	}

	/**
	 * Set the unique identifier of this class
	 * @param id the new ID
	 */
	public void setId (long id) {
		this.id = id;
		this.hashCode = Integer.MIN_VALUE;
	}




	/**
	 * Return the value associated with the column: name
	 */
	public java.lang.String getName () {
		return name;
	}

	/**
	 * Set the value related to the column: name
	 * @param name the name value
	 */
	public void setName (java.lang.String name) {
		this.name = name;
	}



	/**
	 * Return the value associated with the column: value
	 */
	public java.lang.String getValue () {
		return value;
	}

	/**
	 * Set the value related to the column: value
	 * @param value the value value
	 */
	public void setValue (java.lang.String value) {
		this.value = value;
	}





	public boolean equals (Object obj) {
		if (null == obj) return false;
		if (!(obj instanceof asit.moa.moazs.notifier.Config)) return false;
		else {
			asit.moa.moazs.notifier.Config config = (asit.moa.moazs.notifier.Config) obj;
			return (this.getId() == config.getId());
		}
	}

	public int hashCode () {
		if (Integer.MIN_VALUE == this.hashCode) {
			return (int) this.getId();
		}
		return this.hashCode;
	}


	public String toString () {
		return super.toString();
	}


}