package asit.moa.moazs.notifier;

import java.io.Serializable;


/**
 * This is an object that contains data related to the logEntry table.
 * Do not modify this class because it will be overwritten if the configuration file
 * related to this class is modified.
 *
 * @hibernate.class
 *  table="logEntry"
 */

public abstract class BaseLogEntry  implements Serializable {

	public static String REF = "LogEntry";
	public static String PROP_NAME = "name";
	public static String PROP_EMAIL = "email";


	// constructors
	public BaseLogEntry () {
		initialize();
	}

	/**
	 * Constructor for primary key
	 */
	public BaseLogEntry (long id) {
		this.setId(id);
		initialize();
	}

	/**
	 * Constructor for required fields
	 */
	public BaseLogEntry (
		long id,
		java.lang.String name,
		java.lang.String email) {

		this.setId(id);
		this.setName(name);
		this.setEmail(email);
		initialize();
	}

	protected void initialize () {}



	private int hashCode = Integer.MIN_VALUE;

	// primary key
	private long id;

	// fields
	private java.lang.String name;
	private java.lang.String email;

	// many to one
	private asit.moa.moazs.notifier.ProtocolEntry protId;



	/**
	 * Return the unique identifier of this class
     * @hibernate.id
     *  generator-class="hilo"
     *  column="log_id"
     */
	public long getId () {
		return id;
	}

	/**
	 * Set the unique identifier of this class
	 * @param id the new ID
	 */
	public void setId (long id) {
		this.id = id;
		this.hashCode = Integer.MIN_VALUE;
	}




	/**
	 * Return the value associated with the column: name
	 */
	public java.lang.String getName () {
		return name;
	}

	/**
	 * Set the value related to the column: name
	 * @param name the name value
	 */
	public void setName (java.lang.String name) {
		this.name = name;
	}



	/**
	 * Return the value associated with the column: email
	 */
	public java.lang.String getEmail () {
		return email;
	}

	/**
	 * Set the value related to the column: email
	 * @param email the email value
	 */
	public void setEmail (java.lang.String email) {
		this.email = email;
	}



	/**
	 * Return the value associated with the column: protocol_id
	 */
	public asit.moa.moazs.notifier.ProtocolEntry getProtId () {
		return protId;
	}

	/**
	 * Set the value related to the column: protocol_id
	 * @param protId the protocol_id value
	 */
	public void setProtId (asit.moa.moazs.notifier.ProtocolEntry protId) {
		this.protId = protId;
	}





	public boolean equals (Object obj) {
		if (null == obj) return false;
		if (!(obj instanceof asit.moa.moazs.notifier.LogEntry)) return false;
		else {
			asit.moa.moazs.notifier.LogEntry logEntry = (asit.moa.moazs.notifier.LogEntry) obj;
			return (this.getId() == logEntry.getId());
		}
	}

	public int hashCode () {
		if (Integer.MIN_VALUE == this.hashCode) {
			return (int) this.getId();
		}
		return this.hashCode;
	}


	public String toString () {
		return super.toString();
	}


}