package asit.moa.moazs.notifier;

import java.io.Serializable;


/**
 * This is an object that contains data related to the protocolentry table.
 * Do not modify this class because it will be overwritten if the configuration file
 * related to this class is modified.
 *
 * @hibernate.class
 *  table="protocolentry"
 */

public abstract class BaseProtocolEntry  implements Serializable {

	public static String REF = "ProtocolEntry";
	public static String PROP_MOAZS_ID = "moazsId";
	public static String PROP_APP_ID = "appId";
	public static String PROP_ERROR_CODE = "errorCode";
	public static String PROP_ERROR_MESSAGE = "errorMessage";
	public static String PROP_ERROR_FILE_NAME = "errorFileName";
	public static String PROP_TIME_STAMP = "timeStamp";
	public static String PROP_STATUS = "status";
	public static String PROP_SENT = "sent";
	public static String PROP_FETCHED = "fetched";


	// constructors
	public BaseProtocolEntry () {
		initialize();
	}

	/**
	 * Constructor for primary key
	 */
	public BaseProtocolEntry (long id) {
		this.setId(id);
		initialize();
	}

	/**
	 * Constructor for required fields
	 */
	public BaseProtocolEntry (
		long id,
		java.lang.String moazsId,
		java.lang.String appId,
		java.lang.String errorCode,
		java.lang.String errorMessage,
		java.lang.String errorFileName,
		java.util.Date timeStamp) {

		this.setId(id);
		this.setMoazsId(moazsId);
		this.setAppId(appId);
		this.setErrorCode(errorCode);
		this.setErrorMessage(errorMessage);
		this.setErrorFileName(errorFileName);
		this.setTimeStamp(timeStamp);
		initialize();
	}

	protected void initialize () {}



	private int hashCode = Integer.MIN_VALUE;

	// primary key
	private long id;

	// fields
	private java.lang.String moazsId;
	private java.lang.String appId;
	private java.lang.String errorCode;
	private java.lang.String errorMessage;
	private java.lang.String errorFileName;
	private java.util.Date timeStamp;
	private java.lang.String status;
	private int sent;
	private int fetched;



	/**
	 * Return the unique identifier of this class
     * @hibernate.id
     *  generator-class="hilo"
     *  column="protocol_id"
     */
	public long getId () {
		return id;
	}

	/**
	 * Set the unique identifier of this class
	 * @param id the new ID
	 */
	public void setId (long id) {
		this.id = id;
		this.hashCode = Integer.MIN_VALUE;
	}




	/**
	 * Return the value associated with the column: mzs_id
	 */
	public java.lang.String getMoazsId () {
		return moazsId;
	}

	/**
	 * Set the value related to the column: mzs_id
	 * @param moazsId the mzs_id value
	 */
	public void setMoazsId (java.lang.String moazsId) {
		this.moazsId = moazsId;
	}



	/**
	 * Return the value associated with the column: app_id
	 */
	public java.lang.String getAppId () {
		return appId;
	}

	/**
	 * Set the value related to the column: app_id
	 * @param appId the app_id value
	 */
	public void setAppId (java.lang.String appId) {
		this.appId = appId;
	}



	/**
	 * Return the value associated with the column: error_code
	 */
	public java.lang.String getErrorCode () {
		return errorCode;
	}

	/**
	 * Set the value related to the column: error_code
	 * @param errorCode the error_code value
	 */
	public void setErrorCode (java.lang.String errorCode) {
		this.errorCode = errorCode;
	}



	/**
	 * Return the value associated with the column: error_message
	 */
	public java.lang.String getErrorMessage () {
		return errorMessage;
	}

	/**
	 * Set the value related to the column: error_message
	 * @param errorMessage the error_message value
	 */
	public void setErrorMessage (java.lang.String errorMessage) {
		this.errorMessage = errorMessage;
	}



	/**
	 * Return the value associated with the column: error_fn
	 */
	public java.lang.String getErrorFileName () {
		return errorFileName;
	}

	/**
	 * Set the value related to the column: error_fn
	 * @param errorFileName the error_fn value
	 */
	public void setErrorFileName (java.lang.String errorFileName) {
		this.errorFileName = errorFileName;
	}



	/**
	 * Return the value associated with the column: time_stamp
	 */
	public java.util.Date getTimeStamp () {
		return timeStamp;
	}

	/**
	 * Set the value related to the column: time_stamp
	 * @param timeStamp the time_stamp value
	 */
	public void setTimeStamp (java.util.Date timeStamp) {
		this.timeStamp = timeStamp;
	}



	/**
	 * Return the value associated with the column: status
	 */
	public java.lang.String getStatus () {
		return status;
	}

	/**
	 * Set the value related to the column: status
	 * @param status the status value
	 */
	public void setStatus (java.lang.String status) {
		this.status = status;
	}



	/**
	 * Return the value associated with the column: sent
	 */
	public int getSent () {
		return sent;
	}

	/**
	 * Set the value related to the column: sent
	 * @param sent the sent value
	 */
	public void setSent (int sent) {
		this.sent = sent;
	}



	/**
	 * Return the value associated with the column: fetched
	 */
	public int getFetched () {
		return fetched;
	}

	/**
	 * Set the value related to the column: fetched
	 * @param fetched the fetched value
	 */
	public void setFetched (int fetched) {
		this.fetched = fetched;
	}





	public boolean equals (Object obj) {
		if (null == obj) return false;
		if (!(obj instanceof asit.moa.moazs.notifier.ProtocolEntry)) return false;
		else {
			asit.moa.moazs.notifier.ProtocolEntry protocolEntry = (asit.moa.moazs.notifier.ProtocolEntry) obj;
			return (this.getId() == protocolEntry.getId());
		}
	}

	public int hashCode () {
		if (Integer.MIN_VALUE == this.hashCode) {
			return (int) this.getId();
		}
		return this.hashCode;
	}


	public String toString () {
		return super.toString();
	}


}