/*
 * Created on 24.02.2005
 * 
 * TODO To change the template for this generated file go to Window -
 * Preferences - Java - Code Style - Code Templates
 */

package asit.moa.moazs.notifier;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.Vector;
import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.Message.RecipientType;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Query;
import org.apache.log4j.Logger;
import asit.common.BufferDataSource;
import asit.common.LogFactory;
import asit.common.Utils;
import asit.moa.client.deliver.moazs.BinaryDocument;
import asit.moa.client.deliver.moazs.DeliveryResponse;
import asit.moa.client.deliver.moazs.ErrorDeliveryResponse;
import asit.moa.client.deliver.moazs.ResponseTypes;
import asit.moa.moazs.notifier.dao.LogEntryDAO;
import asit.moa.moazs.notifier.dao.ProtocolEntryDAO;


/**
 * @author atauber
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class UtilsProtocolEntry {

  static {
    try {
      _BaseRootDAO.initialize();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  static Logger logger_ = LogFactory.getLogger(UtilsProtocolEntry.class.getName());
  private final static String CLAZZ = ProtocolEntry.class.getName();

  private static boolean isEmpty(String str) {
    return str == null || "".equals(str);
  }
  
  public static List doSearchProtocolEntries(String moazsId, String appId, String dateFrom,
      String dateTo, String errorCode, String errorMessage) throws HibernateException {
    boolean hasSearchParameter = false;
    // first perform a search in the protocol entries
    String queryString = "from " + ProtocolEntry.class.getName() + " as prot";
    if (!isEmpty(moazsId)) {
      queryString += " where prot.moazsId ILIKE '%" + moazsId + "%'";
      hasSearchParameter = true;
    }
    // appid
    if (!isEmpty(appId)) {
      if (!hasSearchParameter) {
        queryString += " where";
      } else {
        queryString += " and ";
      }
      queryString += " prot.appId ILIKE " + "'%" + appId + "%'";
      hasSearchParameter = true;
    }
    // errorcode
    if (!isEmpty(errorCode)) {
      if (!hasSearchParameter) {
        queryString += " where";
      } else {
        queryString += " and ";
      }
      queryString += " prot.errorCode = " + "'" + errorCode + "'";
      hasSearchParameter = true;
    }
    //  errormessage
    if (!isEmpty(errorMessage)) {
      if (!hasSearchParameter) {
        queryString += " where";
      } else {
        queryString += " and ";
      }
      queryString += " prot.errorMessage ILIKE " + "'%" + errorMessage + "%'";
      hasSearchParameter = true;
    }
    SimpleDateFormat format = new SimpleDateFormat("dd.MM.yyyy");
    Date from = null;
    Date to = null;
    try {
      from = format.parse(dateFrom);
    } catch (Exception e) {
    }
    try {
      to = format.parse(dateTo);
    } catch (Exception e) {
    }
    if (from != null && to != null) {
      if (!hasSearchParameter) {
        queryString += " where";
      } else {
        queryString += " and ";
      }
      format = new SimpleDateFormat("yyyy-MM-dd");
      queryString += " prot.timeStamp between " + "'" + format.format(from) + "' and '" + format.format(to) + "'";
    } else if (from != null) {
      if (!hasSearchParameter) {
        queryString += " where";
      } else {
        queryString += " and ";
      }
      format = new SimpleDateFormat("yyyy-MM-dd");
      queryString += " prot.timeStamp >= " + "'" + format.format(from) + "'";
    } else if (to != null) {
      if (!hasSearchParameter) {
        queryString += " where";
      } else {
        queryString += " and ";
      }
      format = new SimpleDateFormat("yyyy-MM-dd");
      queryString += " prot.timeStamp <= " + "'" + format.format(to) + "'";
    }
//    System.out.println("QUERY: " + queryString);
    ProtocolEntryDAO dao = new ProtocolEntryDAO();
    Query query = dao.getSession().createQuery(queryString);
    // list from protocol entries
    return query.list();
  }

  
  public static void deleteProtocolEntry(ProtocolEntry entry) throws HibernateException {
    // delete from log entries
    LogEntryDAO dao = new LogEntryDAO();
    Query query = dao.getSession().createQuery(
        "from " + LogEntry.class.getName() + " as entry where entry.protId = ?");
    query.setLong(0, entry.getId());
    dao.delete(query);
    // delete protocol entry
    ProtocolEntryDAO pdao = new ProtocolEntryDAO();
    pdao.delete(entry);
  }

  public static void addProtocolEntry(ProtocolEntry entry) throws HibernateException {
    ProtocolEntryDAO dao = new ProtocolEntryDAO();
    dao.save(entry);
  }

  public static ProtocolEntry getProtocolEntry(String mzsId) throws HibernateException {
    ProtocolEntryDAO dao = new ProtocolEntryDAO();
    Query query = dao.getSession().createQuery("from " + CLAZZ + " as prot where prot.moazsId = ?");
    query.setString(0, mzsId);
    List list = query.list();
    if (list.size() > 0) {
      return (ProtocolEntry) list.iterator().next();
    }
    return null;
  }

  public static List getProtocolEntries(Date refDate) throws HibernateException {
    ProtocolEntryDAO dao = new ProtocolEntryDAO();
    Query query = dao.getSession().createQuery(
        "from " + CLAZZ + " as prot where prot.timeStamp < ?");
    query.setTimestamp(0, refDate);
    return query.list();
  }

  public static void sendEmail() throws Exception {
    ProtocolEntryDAO dao = new ProtocolEntryDAO();
    Query query = dao.getSession().createQuery("from " + CLAZZ + " as prot where prot.sent = 0");
    List list = query.list();
    for (Iterator it = list.iterator(); it.hasNext();) {
      sendEmail((ProtocolEntry) it.next());
    }
  }

  public static String getSMTPHost() throws HibernateException {
    Config cfg = UtilsConfig.get("mailhost");
    if (cfg != null) {
      return cfg.getValue();
    }
    return null;
  }

  public static String getSMTPSender() throws HibernateException {
    Config cfg = UtilsConfig.get("mailsender");
    if (cfg != null) {
      return cfg.getValue();
    }
    return "unbekannt@unbekannt.com";
  }

  public static void sendEmail(ProtocolEntry entry) throws Exception {
    AppId appid = UtilsAppId.getAppId(entry.getAppId());
    if (appid == null) {
      // mark as sent
      entry.setSent(1);
      ProtocolEntryDAO dao = new ProtocolEntryDAO();
      dao.update(entry);
      logger_.debug("Keine Adressaten gefunden fuer Protocol-Entry: mzsid " + entry.getMoazsId()
                    + " appid + " + entry.getAppId());
      return;
    }
    // send only when send flag is set
    // if not, make pseudo sent
    if (appid.getDoSend() != 1) {
      entry.setSent(1);
      ProtocolEntryDAO dao = new ProtocolEntryDAO();
      dao.update(entry);
      return;
    }
    // if not send fetched entries and already fetched, mark as sent
    if (appid.getSendFetched() != 1 && entry.getFetched() == 1) {
      entry.setSent(1);
      ProtocolEntryDAO dao = new ProtocolEntryDAO();
      dao.update(entry);
      return;
    }
    
    // if shoud only send error messages
    if (appid.getSendOnlyError() == 1 && !ResponseTypes.ERROR.equals(entry.getStatus())) {
      entry.setSent(1);
      ProtocolEntryDAO dao = new ProtocolEntryDAO();
      dao.update(entry);
      return;
    }
    
    // send only when date-time is correct
    Date timestamp = entry.getTimeStamp();
    Date now = new Date();
    long sendAfter = appid.getSendAfter() * 60000;
    // do not send, push back in queue
    if ((now.getTime() - timestamp.getTime()) < sendAfter) {
      return;
    }
    List adressaten = UtilsAppId.getAdressaten(appid);
    if (adressaten.size() == 0) {
      logger_.debug("Keine Adressaten gefunden fuer Protocol-Entry: mzsid " + entry.getMoazsId()
                    + " appid + " + entry.getAppId());
      return;
    }
    Properties props = new Properties();
    props.put("mail.smtp.host", getSMTPHost());
    Session session = Session.getDefaultInstance(props, null);
    Message message = new MimeMessage(session);
    message.setFrom(new javax.mail.internet.InternetAddress(getSMTPSender()));
    Vector logEntries = new Vector();
    BodyPart messageBodyPart = new MimeBodyPart();
    for (Iterator it = adressaten.iterator(); it.hasNext();) {
      AppIdUser user = (AppIdUser) it.next();
      EmailAdressat adressat = user.getAdressat();
      logger_.debug("Sende E-mail and: " + adressat.getName() + " - " + adressat.getEmail());
      message.addRecipient(RecipientType.BCC, new javax.mail.internet.InternetAddress(
          adressat.getName() + "<" + adressat.getEmail() + ">"));
      LogEntry le = new LogEntry();
      le.setEmail(adressat.getEmail());
      le.setName(adressat.getName());
      le.setProtId(entry);
      logEntries.add(le);
    }
    BinaryDocument bdoc = new BinaryDocument(getMailBody(entry), "status.html", "text/html");
    String subject = "[ " + entry.getMoazsId() + " ] ";
    subject += ResponseTypes.SUCCESS.equals(entry.getStatus())
        ? "Zustellung erfolgreich"
        : "Zustellung fehlgeschlagen";
    message.setSubject(subject);
    Multipart multipart = new MimeMultipart();
    messageBodyPart = new MimeBodyPart();
    DataSource source = new BufferDataSource(bdoc);//new FileDataSource(file);
    messageBodyPart.setDataHandler(new DataHandler(source));
    messageBodyPart.setFileName(bdoc.getFileName());
    multipart.addBodyPart(messageBodyPart);
    message.setContent(multipart);
    Transport transport = session.getTransport("smtp");
    Transport.send(message);
    // set the status that we have delivered
    entry.setSent(1);
    ProtocolEntryDAO dao = new ProtocolEntryDAO();
    dao.update(entry);
    // add log entries
    for (int i = 0; i < logEntries.size(); i++) {
      UtilsLogEntry.addLogEntry((LogEntry) logEntries.get(i));
    }
  }

  public static InputStream getMailBody(ProtocolEntry entry) throws Exception {
    ByteArrayOutputStream out = new ByteArrayOutputStream();
    String site = ResponseTypes.SUCCESS.equals(entry.getStatus())
        ? "z_success.html"
        : "z_error.html";
    InputStream is = UtilsProtocolEntry.class.getClassLoader().getResourceAsStream(
        "asit/moa/moazs/notifier/" + site);
    if (is == null) {
      logger_.debug("InputStream ist null: Ressource: " + site);
      return new ByteArrayInputStream(" ".getBytes());
    }
    Utils.dumpInputOutputStream(is, out);
    String ret = out.toString();
    ret = Utils.replaceVariable(ret, "<appid>", entry.getAppId());
    ret = Utils.replaceVariable(ret, "<mzsid>", entry.getMoazsId());
    SimpleDateFormat format = new SimpleDateFormat("dd.MM.yyyy - kk:mm:ss");
    ret = Utils.replaceVariable(ret, "<datum>", format.format(entry.getTimeStamp()));
    ret = Utils.replaceVariable(ret, "<error>", entry.getErrorMessage());
    return new ByteArrayInputStream(ret.getBytes());
  }

  public static void addProtocolEntry(DeliveryResponse response) throws HibernateException {
    ProtocolEntry entry = new ProtocolEntry();
    entry.setAppId(response.getAppDeliveryID());
    logger_.debug("MZSID: " + response.getMZSDeliveryID());
    entry.setMoazsId(response.getMZSDeliveryID());
    entry.setTimeStamp(new Date());
    entry.setStatus(response.getType());
    entry.setSent(0);
    entry.setFetched(0);
    if (ResponseTypes.ERROR.equals(response.getType())) {
      ErrorDeliveryResponse r = (ErrorDeliveryResponse) response;
      entry.setErrorMessage(r.getText() != null ? r.getText() : "");
      entry.setErrorCode(r.getCode() != null ? r.getCode() : "");
      entry.setErrorFileName(r.getDocumentReference() != null ? r.getDocumentReference() : "");
    }
    addProtocolEntry(entry);
  }
}