/*
 * Created on 25.02.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asit.verifier.paper;

import iaik.ixsil.init.IXSILInit;
import iaik.ixsil.util.URI;
import iaik.security.provider.IAIK;
import iaik.security.rsa.RSAPrivateKey;
import iaik.x509.X509Certificate;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.security.KeyPairGenerator;
import java.security.Security;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Hashtable;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import asit.common.Utils;
import asit.moa.MoaConstants;
import asit.moa.client.ClientFactory;
import asit.moa.client.verify.VerifyResult;
import asit.moa.client.verify.VerifySignatureClient;


/**
 * @author atauber
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PapierVerificationService extends HttpServlet {
  
  private static X509Certificate cert_ = null;
  private static RSAPrivateKey private_ = null;
  
  private static String moaspUrl_ = null;
  private VerifySignatureClient client_;
  
  private static URL bildMarkeURL_ = null;
  
  public void init() throws ServletException {
    try {
      Security.addProvider(new IAIK());

      String bildmarkePath = getServletContext().getRealPath("/bildmarke.jpg");
      bildMarkeURL_ = new URL("file:" + bildmarkePath);
//      System.out.println(bildMarkeURL_);
      // Initialize IXSIL
      String ixsilInitParameter = getServletContext().getInitParameter("ixsilinit");
      if (ixsilInitParameter == null) {
        String path = getServletContext().getRealPath("/WEB-INF/res/ixsilinit/properties/init.properties");
        URL tmpURL = new URL("file:" + path);
        IXSILInit.init(new URI(tmpURL.toString()));
      } else {
        IXSILInit.init(new URI(ixsilInitParameter));
      }
      
      // Initialize certificate
      String certParameter = getServletContext().getInitParameter("cert");
      if (certParameter == null) {
        String path = getServletContext().getRealPath("/WEB-INF/res/sigcert.cer");
        cert_ = new X509Certificate(new FileInputStream(path));
      } else {
        cert_ = new X509Certificate(new FileInputStream(certParameter));
      }
      
      // Initialize some private key
      KeyPairGenerator generator = KeyPairGenerator.getInstance("RSA", "IAIK");
      generator.initialize(512);
      private_ = (RSAPrivateKey)generator.generateKeyPair().getPrivate();
      
      moaspUrl_ = getServletContext().getInitParameter("moaspurl");
      if (moaspUrl_ == null) {
        throw new Exception("Keine URL fuer MOA-SP angegeben.");
      }
      String trustProfile = getServletContext().getInitParameter("trustprofile");
      if (trustProfile == null) {
        throw new Exception("Trustprofile must not be null.");
      }
      client_ = ClientFactory.getVerifySignatureClient();
      client_.setTrustProfileID(trustProfile);
      client_.addAdditionalNamespace("dsig", MoaConstants.DSIG_NS);
      client_.addAdditionalNamespace("n", "http://reference.e-government.org/namespace/zuse/recipientnotification/10#");
    } catch(Exception e) {
      e.printStackTrace();
      destroy();
    }
  }

  protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException,
    IOException {
    doPost(request, response);
  }
  
  protected void check(String str, String identifier, Hashtable table, String errorMessage) {
    if (str == null ||
        "".equals(str)) {
      table.put(identifier, errorMessage);
    }
    
  }
  
  protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException,
      IOException {
    
    Hashtable table = new Hashtable();
    
    // Pruefen der Felder
    String verify = request.getParameter("verify");
    String preview = request.getParameter("preview");
    
    String senderName = request.getParameter("sender");
    check(senderName, "sender", table, "Der Sendername darf nicht leer sein.");
    
    String geschaeftsZahl = request.getParameter("gz");
    check(geschaeftsZahl, "gz", table, "Die Gesch&auml;ftszahl darf nicht leer sein.");
    
    String zustellQualitaet = request.getParameter("zq");
    
    String zustellServer = request.getParameter("zuse");
    check(zustellServer, "zuse", table, "Der Name des Zustellservers darf nicht leer sein.");
    
    String ersteVerstaendigung = request.getParameter("erste");
    String zweiteVerstaendigung = request.getParameter("zweite");
    
    String name = request.getParameter("name");
    check(name, "name", table, "Die Angabe des Namens darf nicht leer sein.");
    
    String strasse = request.getParameter("strasse");
    check(strasse, "strasse", table, "Die Strassenangabe darf nicht leer sein.");
    
    String gemeinde = request.getParameter("gemeinde");
    check(gemeinde, "gemeinde", table, "Die Angabe der Gemeinde darf nicht leer sein.");
    
    String plz = request.getParameter("plz");
    check(plz, "plz", table, "Die Postleitzahl darf nicht leer sein.");
    
    String signatureTime = request.getParameter("sigtime");
    check(signatureTime, "sigtime", table, "Der Signaturzeitpunkt darf nicht leer sein.");
    
    String signatureValue = request.getParameter("sigvalue");
    check(signatureValue, "sigvalue", table, "Der Signaturwert darf nicht leer sein.");

    SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
    Date erste = null;
    try {
      erste = format.parse(ersteVerstaendigung);
    } catch(Exception e) {
      table.put("erste", "Das angegebene Datum entspricht nicht vorausgesetztem Format.");
    }
    Date zweite = null;
    
    try {
      zweite = format.parse(zweiteVerstaendigung);
    } catch(Exception e) {
      table.put("zweite", "Das angegebene Datum entspricht nicht vorausgesetztem Format.");
    }

    // ok wir haben fehler
    if (!table.isEmpty()) {
      request.setAttribute("errors", table);
      request.getRequestDispatcher("index.jsp").forward(request, response);
      return;
    }
    
    // wir haben keine fehler - fahre fort
    PaperNotification not = new PaperNotification();
    not.setSenderName(senderName);
    not.setDeliveryId(geschaeftsZahl);
    not.setDeliveryQuality(zustellQualitaet);
    not.setFirstNotification(erste);
    not.setBase64SignatureValue(signatureValue);
    not.setMunicipality(gemeinde);
    not.setRecipientAdressLine(strasse);
    not.setRecipientName(name);
    not.setRecipientPostalCode(plz);
    not.setDueDate(zweite);
    not.setSigningTime(signatureTime);
    not.setCert(cert_);
    not.setKey(private_);
    not.setClient(client_);
    // make the preview
    if (preview != null) {
      try {
        
        // replace $bildmarkeurl$ variable with url of bildmarke
        InputStream postKarteIS = PapierVerificationService.class.getClassLoader().getResourceAsStream("/postkarte.xsl");
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        Utils.dumpInputOutputStream(postKarteIS, bos);
        String replacedPostKarte = Utils.replaceVariable(bos.toString(), "BILD_MARKE_URL", bildMarkeURL_.toString());
//        System.out.println(replacedPostKarte);
        ByteArrayInputStream formattedIS = new ByteArrayInputStream(replacedPostKarte.getBytes());
        
        // now transform to pdf
        InputStream is = not.getPDFNotification(formattedIS);
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        Utils.dumpInputOutputStream(is, out);
        response.setContentType("application/pdf");
        response.setContentLength(out.size());
        Utils.dumpInputOutputStream(new ByteArrayInputStream(out.toByteArray()), response.getOutputStream());
        return;
      } catch(Exception e) {
        e.printStackTrace();
        response.sendError(500, "Interner Server Fehler - " + e.getMessage());
      }
      
    // verify the request
    } else {
      try {
        VerifyResult result = not.verifySignature(moaspUrl_);
        Utils.mapVerifyResultToJSP(result, request);
        request.getRequestDispatcher("verify_result.jsp").forward(request, response);
        return;
      } catch(Exception e) {
        e.printStackTrace();
        response.sendError(500, "Interner Server Fehler - " + e.getMessage());
        return;
      }
      
    }
    
    
  }
}
